Attribute VB_Name = "BigInt_Definition_SWTAPI"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cui`Ɗ{֐jSWTAPI
'
'------------------------------------------------------------------------------
'
'  SetWaitableTimer API ֘ÃW[ł
'
'------------------------------------------------------------------------------
'  Tv
'    vO̎sꎞ~邽߂ Sleep API ֐gp邱Ƃ悭܂B
'    Sleep ֐gpꍇ̒Z 1 ́A
'    AvP[VsĂXbhꎞ~A
'    AvP[VɂĊJꂽEBhEĕ`悳ȂƂłB
'    ɂAĥȂ[U[ C^[tFCX\܂B
'    Sleep ֐̑ SetWaitableTimer gp邱Ƃł܂B
'    ̊֐ł́Aʂ̍ĕ`ADDE bZ[W̕\Ȃǂ\łB
'      Visual Basic  SetWaitableTimer gp@
'      http://support.microsoft.com/default.aspx/kb/231298/ja
'------------------------------------------------------------------------------
'
'
'Declare
Private Declare Function CreateWaitableTimer Lib "kernel32" _
    Alias "CreateWaitableTimerA" ( _
    ByVal lpSemaphoreAttributes As Long, _
    ByVal bManualReset As Long, _
    ByVal lpName As String) As Long
'
Private Declare Function OpenWaitableTimer Lib "kernel32" _
    Alias "OpenWaitableTimerA" ( _
    ByVal dwDesiredAccess As Long, _
    ByVal bInheritHandle As Long, _
    ByVal lpName As String) As Long
    
Private Declare Function SetWaitableTimer Lib "kernel32" ( _
    ByVal hTimer As Long, _
          lpDueTime As FILETIME, _
    ByVal lPeriod As Long, _
    ByVal pfnCompletionRoutine As Long, _
    ByVal lpArgToCompletionRoutine As Long, _
    ByVal fResume As Long) As Long
'
Private Declare Function CancelWaitableTimer Lib "kernel32" ( _
    ByVal hTimer As Long)
'
Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long
'
Private Declare Function WaitForSingleObject Lib "kernel32" ( _
    ByVal hHandle As Long, _
    ByVal dwMilliseconds As Long) As Long
'
Private Declare Function MsgWaitForMultipleObjects Lib "user32" ( _
    ByVal nCount As Long, _
          pHandles As Long, _
    ByVal fWaitAll As Long, _
    ByVal dwMilliseconds As Long, _
    ByVal dwWakeMask As Long) As Long
'------------------------------------------------------------------------------
'
'[U[`^
Private Type FILETIME
    dwLowDateTime  As Long
    dwHighDateTime As Long
End Type
'------------------------------------------------------------------------------
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
Private Const WAIT_ABANDONED& = &H80&
Private Const WAIT_ABANDONED_0& = &H80&
Private Const WAIT_FAILED& = -1&
Private Const WAIT_IO_COMPLETION& = &HC0&
Private Const WAIT_OBJECT_0& = 0
Private Const WAIT_OBJECT_1& = 1
Private Const WAIT_TIMEOUT& = &H102&
'
Private Const INFINITE = &HFFFF
Private Const ERROR_ALREADY_EXISTS = 183&
'
Private Const QS_HOTKEY& = &H80
Private Const QS_KEY& = &H1
Private Const QS_MOUSEBUTTON& = &H4
Private Const QS_MOUSEMOVE& = &H2
Private Const QS_PAINT& = &H20
Private Const QS_POSTMESSAGE& = &H8
Private Const QS_SENDMESSAGE& = &H40
Private Const QS_TIMER& = &H10
Private Const QS_MOUSE& = (QS_MOUSEMOVE _
                        Or QS_MOUSEBUTTON)
Private Const QS_INPUT& = (QS_MOUSE _
                        Or QS_KEY)
Private Const QS_ALLEVENTS& = (QS_INPUT _
                            Or QS_POSTMESSAGE _
                            Or QS_TIMER _
                            Or QS_PAINT _
                            Or QS_HOTKEY)
Private Const QS_ALLINPUT& = (QS_SENDMESSAGE _
                           Or QS_PAINT _
                           Or QS_TIMER _
                           Or QS_POSTMESSAGE _
                           Or QS_MOUSEBUTTON _
                           Or QS_MOUSEMOVE _
                           Or QS_HOTKEY _
                           Or QS_KEY)
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
'  Wait  Wait(lNumberOfSeconds As Long)
' ======= Function ֐ ==========================================
'------------------------------------------------------------------------------
'
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/05/30]    Ver.1.90 Alpha EditioniJŁj  dlύX   W[ύX (BigInt_Definition_SWTAPIBigInt_Sample_SWTAPI)
'                                                           X   Waiẗ(lNumberOfSeconds)̍ŏl(0.0000001)ǉ
'   [2008/11/06]    Ver.1.69 Alpha EditioniJŁj      X   Waiẗ(lNumberOfSeconds)Long^Double^֕ύX <ɂPbȉWait\>
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ̑
'    Wait֐ꕔ VBApɏC (Application.Name  App.EXEName)
'------------------------------------------------------------------------------
'

'Wait
Public Sub Wait(lNumberOfSeconds As Double)
Dim ft          As FILETIME   '
Dim lRet        As Long       '
Dim lBusy       As Long       '
Dim hTimer      As Long       '
Dim dblUnits    As Double     '
Dim dblDelay    As Double     '
Dim dblDelayLow As Double     '
    On Error GoTo ERR:
    If lNumberOfSeconds < 0.0000001 Then Exit Sub
    'hTimer = CreateWaitableTimer(0, True, App.EXEName & "Timer")
    'VBApɏC (Application.Name  App.EXEName)
    hTimer = CreateWaitableTimer(0, True, Application.Name & "Timer")
    If ERR.LastDllError = ERROR_ALREADY_EXISTS Then
        ' If the timer already exists, it does not hurt to open it
        ' as long as the person who is trying to open it has the
        ' proper access rights.
    Else
        ft.dwLowDateTime = -1&
        ft.dwHighDateTime = -1&
        lRet = SetWaitableTimer(hTimer, ft, 0, 0, 0, 0)
    End If
    ' Convert the Units to nanoseconds.
    dblUnits = CDbl(&H10000) * CDbl(&H10000)
    dblDelay = CDbl(lNumberOfSeconds) * 1000# * 10000#
    ' By setting the high/low time to a negative number, it tells
    ' the Wait (in SetWaitableTimer) to use an offset time as
    ' opposed to a hardcoded time. If it were positive, it would
    ' try to convert the value to GMT.
    ft.dwHighDateTime = -CLng(dblDelay / dblUnits) - 1&
    dblDelayLow = -dblUnits * (dblDelay / dblUnits - Fix(dblDelay / dblUnits))
    If dblDelayLow < CDbl(&H80000000) Then
        ' &H80000000 is MAX_LONG, so you are just making sure
        ' that you don't overflow when you try to stick it into
        ' the FILETIME structure.
        dblDelayLow = dblUnits + dblDelayLow
        ft.dwHighDateTime = ft.dwHighDateTime + 1&
    End If
    ft.dwLowDateTime = CLng(dblDelayLow)
    lRet = SetWaitableTimer(hTimer, ft, 0, 0, 0, False)
    Do
        ' QS_ALLINPUT means that MsgWaitForMultipleObjects will
        ' return every time the thread in which it is running gets
        ' a message. If you wanted to handle messages in here you could,
        ' but by calling Doevents you are letting DefWindowProc
        ' do its normal windows message handling---Like DDE, etc.
        lBusy = MsgWaitForMultipleObjects(1, hTimer, False, INFINITE, QS_ALLINPUT&)
        DoEvents
    Loop Until lBusy = WAIT_OBJECT_0
    ' Close the handles when you are done with them.
    CloseHandle hTimer
Exit Sub
ERR:
'Resume Next
End Sub
