Attribute VB_Name = "BigInt_Functions_3"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ 3
'
'------------------------------------------------------------------------------
'
'@{Z֐ ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    X^[Őߎ <xP>   BIStirlingsApproximation(A As BigIntType, Optional Digit As Long = 32#) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  VKǉ   X^[Őߎ(BIStirlingsApproximation)VKǉ
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃CuKvł
'------------------------------------------------------------------------------
'

'X^[Őߎ Stirling's approximation <xP> ********************************************************************************
Public Function BIStirlingsApproximation(a As BigIntType, Optional Digit As Long = 32#) As BigIntType
'  K(n!)ߎ
'  n!{(2n)}{(n^n)/(e^n)}{1 +(1/(12*n))+(1/(288*n^2))-(139/(51840*(n^3)))-(571/(2488320*(n^4)) +O(n^(-5)))}    ((n+1)) [n0]
'                                ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ ~~~~~~~~~~
'                                                       xP                                      c
'------------------------------------------------------------------------------
'  Ql  wW
'            : I.R.Cptuz~, I.M.Qwy{
'            : ΋`F
'            oŎ:ۑP  (a58N121s/3041-2796-7924)
'            ISBN-10: 4621027964
'            ISBN-13: 978-4621027967
'            [P.937 (8.327)]
'------------------------------------------------------------------------------
'  QlURL  Stirling's Approximation -- from Wolfram MathWorld
'             http://mathworld.wolfram.com/StirlingsApproximation.html
'           en.wikipedia
'             http://en.wikipedia.org/wiki/Stirling's_approximation
'           ja.Wikipedia
'             http://ja.wikipedia.org/wiki/%E3%82%B9%E3%82%BF%E3%83%BC%E3%83%AA%E3%83%B3%E3%82%B0%E3%81%AE%E8%BF%91%E4%BC%BC
'           Stirling's Formula for N!
'             http://www.lassp.cornell.edu/sethna/Cracks/Stirling.html
'             {(2n)}{(n^n)/(e^n)}{1+1/(12*n)+1/(288*n^2)-139/(51840*n^3)-571/(2488320*n^4)+163879/(209018880*n^5)+5246819/(75246796800*n^6)-534703531/(902961561600*n^7)-4483131259/(86684309913600*n^8)+...}
'------------------------------------------------------------------------------
'    A         [BigIntType]    [U[`^
'  @@@Digit     [Long]          iȗ/ȗ:32j߂錅
'  ߒl@I  [BigIntType]    [U[`^ X^[Őߎl
'@@  @ُI  [BigIntType]    [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    EX^[Ǒi{xPjŁAKߎ
'          iAK (n0) j
'          ߎlȂRXgiԁjŋ߂邱ƂôŁA
'            iḰjł΂قڐmɁAZԂŋ߂邱Ƃo
'------------------------------------------------------------------------------
'    A>10, A<=255431603  <BIPowers̐ɂ>
'        )4294967288!BigIntType̒`ŕ\\H͖mF
'           Iɂ́APC̐ŁA܂ŌvZłȂƎv
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntAdd, BigIntMul, BigIntDiv,
'              BICBit, DigitCheck,
'              SetBigIntDigitCalculations,
'              BIKetaN, BISqr, BIPowers, BIExp,
'              BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    EʏAX^[Őߎ(K)̗LȌȒPɂ͔coȂ̂ŁA
'          Digit(߂錅)͏ȗꍇiƎvj
'          ȗƁA߂錅́A32ŉZ܂
'          Ӂj܂łߎȂ̂Őlƈv̂́A100000! (A:100000) ŐXQVx
'                 (Digit: 32)
'                   (Pentium4 3.20 GHz)
'                   [By Ver.1.94 BigInt_Demo(vZߒo:ON)]
'                         10! ^l: 3628800 (7)
'                             ߎ: 3628799 (v4)
'                                   ^^^^
'                         20! ^l: 2432902008176640000 (19)
'                             ߎ: 2432902007581509677 (v9)
'                                   ^^^^^^^^^
'                      10000! ^l: 2.84625968091705451890641321E+35659 (35660)
'                             ߎ: 2.84625968091705451890639089E+35659 (v22)
'                                   ^^^^^^^^^^^^^^^^^^^^^^^
'                     100000! ^l: 2.8242294079603478742934215780245E+456573 (456574)
'                             ߎ: 2.8242294079603478742934215778031E+456573 (v27)
'                                   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
'                   ߎ́Ai_ȉ؂̂Ăjł̒l
'------------------------------------------------------------------------------
'  Ql  vZ
'          (Pentium4 3.20 GHz)
'          [By Ver.1.94 BigInt_Demo(vZߒo:ON)]
'              A=255431603, Digit=32  1b  ߒl:1.6955045728564543375149139366542E+2036551104
'------------------------------------------------------------------------------
Dim AA     As BigIntType   'Copy
Dim Pi     As BigIntType   '
Dim Pix2   As BigIntType   '2
Dim CC     As BigIntType   'vZߒ̉
Dim C1     As BigIntType   '(2n)
Dim C2     As BigIntType   'n^n
Dim C3     As BigIntType   'e^n
Dim C4     As BigIntType   '{1+(1/(12*n))+(1/(288*n^2))-(139/(51840*(n^3)))-(571/(2488320*(n^4))}
Dim C41    As BigIntType   '1
Dim C42    As BigIntType   '1/(12*n)
Dim C43    As BigIntType   '1/(288*n^2)
Dim C44    As BigIntType   '-139/(51840*(n^3))
Dim C45    As BigIntType   '-571/(2488320*(n^4))
Dim X1     As BigIntType   '萔  1
Dim TMP    As BigIntType   'temp
Dim I      As Long         '
Dim J      As Long         '
Dim M      As Long         'vZi=Digit:߂錅j
Dim dDigit As Long         ']T
Dim SA     As String       '
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(a) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        AA = a
        '-------------------------------------------------------------
        '0폜
        With AA
            If Right$(.BigInt, 1&) = "0" Then   '@@@-VBA-@@@
                For I = 9& To 1& Step -1&
                    J = 10& ^ I
                    If Len(.BigInt) > J Then
                        Do While Right$(.BigInt, J) = String$(J, "0")    '@@@-VBA-@@@
                            .BigInt = Left$(.BigInt, Len(.BigInt) - J)   '@@@-VBA-@@@
                            .BigExp = .BigExp + J
                        Loop
                    End If
                Next I
                Do While Asc(Right$(.BigInt, 1&)) = 48 And Len(.BigInt) > 1&   '@@@-VBA-@@@
                    .BigInt = Mid$(.BigInt, 1&, Len(.BigInt) - 1&)             '@@@-VBA-@@@
                    .BigExp = .BigExp + 1&
                Loop
            End If
        End With
        '-------------------------------------------------------------
        If AA.BigSgn = "-" Or AA.BigExp < 0& Or Len(AA.BigInt) > 10& Then
        'AA<0 or 񐮐 or Ήl(11ȏ̐l[0]ɂ͔Ή)
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            'ȉ AA ͎Ri̐jƌ肷ioj
            SA = AA.BigInt & String$(AA.BigExp, "0")
            If Len(SA) > 10& Then
            'Ήl(11ȏ̐lɂ͔Ή)
                BigIntErrFLG = 5
                Error BigIntErrFLG
            Else
                I = CLng(SA)
                If I < 10& Or I > 255431603 Then
                'l
                    BigIntErrFLG = 5
                    Error BigIntErrFLG
                Else
                '10<=A<=255431603
                    '߂錅̃`FbN
                    If Not DigitCheck(Digit) Then Exit Function
                    ']T
                    dDigit = 3&
                    'vZ
                    M = SetBigIntDigitCalculations(Digit, dDigit)
                    '
                    Pi = BIPi(M, False)
                    '(2n)
                    Pix2 = BigIntMul(BICBit(2), Pi, M)   '2
                    TMP = BigIntMul(Pix2, AA, M)         '2n
                    C1 = BISqr(TMP, M)                   '
                    'n^n
                    C2 = BIPowers(AA, AA, M)
                    'e^n
                    C3 = BIExp(AA, M)
                    '{1+(1/(12*n))+(1/(288*n^2))-(139/(51840*(n^3)))-(571/(2488320*(n^4))}
                    X1 = BICBit(1)
                    C41 = X1
                    C42 = BigIntDiv(X1, BigIntMul(BICBit(12), AA, M), M)                       '1/(12*n)
                    TMP = BigIntMul(AA, AA, M)                                                 'n^2
                    C43 = BigIntDiv(X1, BigIntMul(BICBit(288), TMP, M), M)                     '1/(288*n^2)
                    TMP = BigIntMul(TMP, AA, M)                                                'n^3
                    C44 = BigIntDiv(BICBit(139), BigIntMul(BICBit(51840), TMP, M), M)          '139/(51840*n^3)
                    C44.BigSgn = "-"                                                           '
                    TMP = BigIntMul(TMP, AA, M)                                                'n^4
                    C45 = BigIntDiv(BICBit(571), BigIntMul(BICBit(2488320), TMP, M), M)        '571/(2488320*(n^4)
                    C45.BigSgn = "-"                                                           '
                    C4 = BigIntAdd(BigIntAdd(BigIntAdd(BigIntAdd(C41, C42), C43), C44), C45)   'C41+C42+C43+C44
                    '(2n)*{(n^n)/(e^n)}{1+(1/(12*n))+(1/(288*n^2))-(139/(51840*(n^3)))-(571/(2488320*(n^4))}
                    TMP = BigIntDiv(BigIntMul(C1, C2, M), C3, M)                               '(2n)*(n^n)/(e^n)
                    CC = BigIntMul(TMP, C4, M)                                                 '
                    'EߒlZbg
                    BIStirlingsApproximation = BIKetaN(CC, CLng(Digit))
                End If
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIStirlingsApproximation")
End Function
