Attribute VB_Name = "BigInt_Functions_AGM"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ AGM
'
'------------------------------------------------------------------------------
'
'@Zp􉽕 (Arithmetic-geometric mean) ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    Zp􉽕   BIAGM(A As BigIntType, B As BigIntType, Optional Digit As Variant, _
'                         Optional debug_ As Variant, Optional debug2_ As Variant) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  dlύX   W[ύX(BigInt_Functions_AGMBigInt_Functions_B)
'                                                       dlύX   Zp􉽕(BIAGM)  ǉ(debug_,debug2_)
'   [2009/11/10]    Ver.1.86 Alpha EditioniJŁj  VKǉ   Zp􉽕ρiArithmetic-geometric meanj
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ  ̃W[݂̂ł͍쓮ł܂
'             VBAő{Zs߂̃CuKvł
'------------------------------------------------------------------------------
'

'Zp􉽕ρiArithmetic-geometric meanj
Public Function BIAGM(a As BigIntType, B As BigIntType, Optional Digit As Variant, _
                      Optional debug_ As Variant, Optional debug2_ As Variant) As BigIntType
' Zp􉽕 [A.G.M.]
'---------------------------------------------------------------------------
'  @A         [BigIntType]      [U[`^
'  @@@B         [BigIntType]      [U[`^
'  @@@Digit     [Long]            ߂錅
'        debug_    [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_   [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'  ߒl@I  [BigIntType]      [U[`^ (AGM̉)
'@@  @ُI  [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    |arg(b/a)|<>΂ł镡fa,bɂ
'          arg:fʂɂΊp
'        a(1) = (a + b) / 2
'        b(1) = (ab)
'        a(N + 1) = (a(N) + b(N)) / 2
'        b(n+1)=(a(n)b(n))
'         (n>=1)
'        ƒ߂΁A{a(n)},{b(n)}͓lɎB
'        ̋Ɍa, b̎Zp􉽕ςƌĂԡ
'        AA􉽕b(n)͎̍̕Zpa(n)̑ɂ̂I()
'        () ̃W[ł́AA,BƂ݂̎̂ΏۂƂ
'------------------------------------------------------------------------------
'    A,BƂ̎(f͑ΏۊO)
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BIKetaAwase, BigIntSub,
'              BIOverflowErrCheck,
'              BIEq0, SetBigIntDigitCalculations,
'              BIIsAEqualB,  BIKetaN,
'              BIWarnningDialog
'        萔  BigIntLimit, DefaultDigit
'        ϐ  DefaultDigit2, BigIntErrFLG, FunctionChangeFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql@vZ  (Pentium4 2.80C GHz) v
'------------------------------------------------------------------------------
Dim AA          As BigIntType   'Copy
Dim BB          As BigIntType   '
Dim CC          As BigIntType   'vZ̉
Dim EE          As BigIntType   '
Dim X05         As BigIntType   '萔  0
Dim M           As Long         'vZi=Digit:߂錅j
Dim dAE         As Long         'Position_AA-Position_EE
Dim dBE         As Long         'Position_BB-Position_EE
Dim Count       As Long         'JE^[
Dim LimtC       As Long         'vZ
Dim dDigit      As Long         ']T
Dim Position_AA As Long         'ŏ̐̈ AA
Dim Position_BB As Long         'ŏ̐̈ BB
Dim Position_EE As Long         'ŏ̐̈ EE
'
Dim OldTime  As Single          '
Dim DebugTxt As String          '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(a) Or BIIsError(B) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        If Asc(a.BigSgn) = 45 Or Asc(B.BigSgn) = 45 Then
        'A<0 or B<0
            BigIntErrFLG = 5
            Error BigIntErrFLG
        ElseIf BIEq0(a) Or BIEq0(B) Then
        'A=0 or B=0
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            AA = a
            BB = B
            '萔
            dDigit = 3&                 ']T
            LimtC = 1000&               'vZ
            X05 = BICBit(0.5)
            '
            'vZi߂錅`FbNj
            M = SetBigIntDigitCalculations(DigitCheck_And_SetBigIntDigitCalculations(Digit, Len(AA.BigInt), Len(BB.BigInt), "AGM"), dDigit)
            '
            Count = 0&
            '
            If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                     " C : Do`Loop vZ" & vbCr & _
                                                     " N : " & vbCr & _
                                                     " S : i|Zp-􉽕|j" & vbCr & _
                                                     " T : vZ" & vbCr & _
                                                     "---------------------------" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "C:" & CStr(Count) & _
                           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                ''##############################################################
                'Debug.Print "C:" & CStr(Count) & _
                '           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]")
                ''##############################################################
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            Do
                Count = Count + 1&
                If Count > LimtC Then Error 51                        'vZ񐔃`FbN
                CC = BigIntMul(BigIntAdd(AA, BB, M), X05, M)          'Zp
                BB = BISqr(BigIntMul(AA, BB, M), M)                   '􉽕
                AA = CC
                EE = BigIntSub(AA, BB, M)                             '
                EE.BigSgn = "+"
                '`FbN
                Position_AA = Len(AA.BigInt) + AA.BigExp              'AÄ
                Position_BB = Len(BB.BigInt) + BB.BigExp              'BB̈
                Position_EE = Len(EE.BigInt) + EE.BigExp              'EË
                '(A>=E>=B) dAE>=0, dBE<=0
                dAE = Position_AA - Position_EE
                dBE = Position_BB - Position_EE
                If BIEq0(EE) Then
                'EE=0 ([̃`FbN)
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "C:" & CStr(Count) & _
                                   ", N:" & CStr(M) & _
                                   ", S:" & BI2ExpN(EE, 3) & _
                                   ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        ''##############################################################
                        'Debug.Print "C:" & CStr(Count) & _
                        '           ", N:" & CStr(M) & _
                        '           ", S:" & BI2ExpN(EE, 3) & _
                        '           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]")
                        ''##############################################################
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    Exit Do
                End If
                '
                If Not IsMissing(debug_) Then
                    NowTime = Timer
                    DebugTxt = "C:" & CStr(Count) & _
                               ", N:" & CStr(dBE) & _
                               ", S:" & BI2ExpN(EE, 3) & _
                               ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    ''##############################################################
                    'Debug.Print "C:" & CStr(Count) & _
                    '           ", N:" & CStr(dBE) & _
                    '           ", S:" & BI2ExpN(EE, 3) & _
                    '           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]")
                    ''##############################################################
                    OldTime = NowTime
                End If
                '
                '
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                '
            Loop While dAE <= Digit
            'EߒlZbg
            BIAGM = BIKetaN(AA, CLng(Digit))
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIAGM")
End Function
