Attribute VB_Name = "BigInt_Functions_Combination"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ Combination
'
'------------------------------------------------------------------------------
'
'@g(Ƒg) ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'       Permutation [aob]     BIPermutation(A As BigIntType, B As BigIntType, Optional Digit As Variant) As BigIntType
'    g Combination [abb]     BICombination(A As BigIntType, B As BigIntType, Optional Digit As Variant) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  VKǉ   (BIPermutation),g(BICombination)VKǉ
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃CuKvł
'------------------------------------------------------------------------------
'

' Permutation ********************************************************************************
Public Function BIPermutation(N As BigIntType, M As BigIntType, Optional Digit As Variant) As BigIntType
'  nom [=n!/(n-m)!] (n>=m)
'------------------------------------------------------------------------------
'    N         [BigIntType]    [U[`^
'  @@@M         [BigIntType]    [U[`^
'  @@@Digit     [Variant/Long]  iȗj߂錅
'                                  IsMissing֐gp̂Variant^ƂĂ
'  ߒl@I  [BigIntType]    [U[`^ A!(=K)
'@@  @ُI  [BigIntType]    [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    E(permutation)͂ЂƂ̏WvfIяoāA
'          ԂɈӖĕׂƂ́A̕т̂
'        E0!1 Ƃ
'------------------------------------------------------------------------------
'    N>0, M>0, N>=M
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntSub, BIFactorial2,
'              DigitCheck, SetBigIntDigitCalculations,
'              BIKetaN,
'              BIWarnningDialog
'        萔  BigIntLimit, DefaultDigit
'        ϐ  DefaultDigit2, BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    EʏAǨʂ̌ȒPɂ͔coȂ̂ŁA
'          Digit(߂錅)͏ȗꍇ
'          ȗƁApubN萔DefaultDigitpubNϐDefaultDigit2
'          ̌ŉẐŒ
'------------------------------------------------------------------------------
'  Ql  vZ v
'------------------------------------------------------------------------------
Dim NN     As BigIntType   'Copy
Dim MM     As BigIntType   '
Dim CC     As BigIntType   '
Dim dD     As BigIntType   '
Dim EE     As BigIntType   '
Dim X1     As BigIntType   '萔 1
Dim L      As Long         '
Dim Md     As Long         'vZi=Digit:߂錅j
Dim LB     As Long         '
Dim dDigit As Long         ']T
Dim S      As String       '
Dim SA     As String       '
Dim SB     As String       '
Dim SA2    As String       '
Dim SB2    As String       '
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(N) Or BIIsError(M) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        NN = N
        MM = M
        '-------------------------------------------------------------
        If NN.BigSgn = "-" Or NN.BigExp < 0& Or Len(NN.BigInt) > 10& Then
        'NN<0 or 񐮐 or Ήl(11ȏ̐lɂ͔Ή)
            BigIntErrFLG = 5
            Error BigIntErrFLG
        ElseIf MM.BigSgn = "-" Or MM.BigExp < 0& Or Len(MM.BigInt) > 10& Then
        'MM<0 or 񐮐 or Ήl(11ȏ̐lɂ͔Ή)
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '萔
            X1.BigSgn = "+"
            X1.BigInt = "1"
            X1.BigExp = 0&
            '0!=101ƌȂ
            If Asc(NN.BigInt) = 48 And Len(NN.BigInt) = 1& Then
            'NN=0
                NN = X1
            End If
            If Asc(MM.BigInt) = 48 And Len(MM.BigInt) = 1& Then
            'MM=0
                MM = X1
            End If
            'ȉ NN,MM ƂRi̐jOƂ
            'NN>=BB`FbN
            SA = NN.BigInt & String$(NN.BigExp, "0")
            SB = MM.BigInt & String$(MM.BigExp, "0")
            L = Len(SA) - Len(SB)
            If L > 0& Then
                SA2 = SA
                SB2 = String$(L, "0") & SB
            ElseIf L < 0& Then
            'MM>AAmi{Ȃ炱error 5j
                SA2 = String$(-L, "0") & SA
                SB2 = SB
            Else
                SA2 = SA
                SB2 = SB
            End If
            If SB2 > SA2 Then
            'MM>NN
                BigIntErrFLG = 5
                Error BigIntErrFLG
            Else
                '߂錅̃`FbN
                If Not DigitCheck(Digit) Then Exit Function
                ']T
                dDigit = 5&
                'vZ
                Md = SetBigIntDigitCalculations(Digit, dDigit)
                '-------------------------------------------------------------
                dD = BigIntSub(NN, MM)          'A-B
                CC = BIFactorial2(NN, dD, Md)   'A!/(A-B)!
                '-------------------------------------------------------------
                If BIIsError(CC) Then
                    BigIntErrFLG = 5
                    Error BigIntErrFLG
                Else
                    'EߒlZbg
                    BIPermutation = BIKetaN(CC, CLng(Digit))
                End If
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPermutation")
End Function
'g Combination ********************************************************************************
Public Function BICombination(N As BigIntType, M As BigIntType, Optional Digit As Variant) As BigIntType
'  nbm [=n!/{m!(n-m)!}=(nom)/m!] (n>=m)
'------------------------------------------------------------------------------
'    N         [BigIntType]    [U[`^
'  @@@M         [BigIntType]    [U[`^
'  @@@Digit     [Variant/Long]  iȗj߂錅
'                                  IsMissing֐gp̂Variant^ƂĂ
'  ߒl@I  [BigIntType]    [U[`^ A!(=K)
'@@  @ُI  [BigIntType]    [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    E̗vf̏W܂肩炢̗vfIяo@A
'          邢͑Iяovf́gׂ鏇Ԃ̈ႢʂɁĥׂ̂
'        Enbmnb(n-m)
'        E0!1 Ƃ
'------------------------------------------------------------------------------
'    n>0, m>0, n>=m
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntSub, BigIntDiv, BIFactorial, BIFactorial2,
'              DigitCheck,
'              BIKetaN,
'              BIWarnningDialog
'        萔  BigIntLimit, DefaultDigit
'        ϐ  DefaultDigit2, BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    EʏAǨʂ̌ȒPɂ͔coȂ̂ŁA
'          Digit(߂錅)͏ȗꍇ
'          ȗƁApubN萔DefaultDigitpubNϐDefaultDigit2
'          ̌ŉẐŒ
'------------------------------------------------------------------------------
'  Ql  vZ v
'------------------------------------------------------------------------------
Dim NN     As BigIntType   'Copy
Dim MM     As BigIntType   '
Dim CC     As BigIntType   '
Dim dD     As BigIntType   '
Dim EE     As BigIntType   '
Dim X1     As BigIntType   '萔 1
Dim L      As Long         '
Dim Md     As Long         'vZi=Digit:߂錅j
Dim LB     As Long         '
Dim LC     As Long         '
Dim dDigit As Long         ']T
Dim S      As String       '
Dim SA     As String       '
Dim SB     As String       '
Dim SA2    As String       '
Dim SB2    As String       '
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(N) Or BIIsError(M) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        NN = N
        MM = M
        '-------------------------------------------------------------
        If NN.BigSgn = "-" Or NN.BigExp < 0& Or Len(NN.BigInt) > 10& Then
        'nn<0 or 񐮐 or Ήl(11ȏ̐lɂ͔Ή)
            BigIntErrFLG = 5
            Error BigIntErrFLG
        ElseIf MM.BigSgn = "-" Or MM.BigExp < 0& Or Len(MM.BigInt) > 10& Then
        'MM<0 or 񐮐 or Ήl(11ȏ̐lɂ͔Ή)
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '萔
            X1.BigSgn = "+"
            X1.BigInt = "1"
            X1.BigExp = 0&
            '0!=101ƌȂ
            If Asc(NN.BigInt) = 48 And Len(NN.BigInt) = 1& Then
            'NN=0
                NN = X1
            End If
            If Asc(MM.BigInt) = 48 And Len(MM.BigInt) = 1& Then
            'MM=0
                MM = X1
            End If
            'ȉ nn,MM ƂRi̐jOƂ
            'nn>=BB`FbN
            SA = NN.BigInt & String$(NN.BigExp, "0")
            SB = MM.BigInt & String$(MM.BigExp, "0")
            L = Len(SA) - Len(SB)
            If L > 0& Then
                SA2 = SA
                SB2 = String$(L, "0") & SB
            ElseIf L < 0& Then
            'MM>AAmi{Ȃ炱error 5j
                SA2 = String$(-L, "0") & SA
                SB2 = SB
            Else
                SA2 = SA
                SB2 = SB
            End If
            If SB2 > SA2 Then
            'MM>nn
                BigIntErrFLG = 5
                Error BigIntErrFLG
            Else
                L = CLng(SA)
                LB = CLng(SB)
                LC = L - LB
                If LC < LB Then
                'a-b<b
                    'ab(a-b)abb
                    MM = X1
                    MM.BigInt = CStr(LC)
                End If
                '߂錅̃`FbN
                If Not DigitCheck(Digit) Then Exit Function
                ']T
                dDigit = 5&
                '-------------------------------------------------------------
                dD = BigIntSub(NN, MM)                                   'n-m
                EE = BIFactorial2(NN, dD)                                'nPm=n!/(n-m)!
                dD = BIFactorial(MM)                                     'm!
                Md = Len(EE.BigInt & String$(EE.BigExp, "0")) + dDigit   'vZ
                CC = BigIntDiv(EE, dD, Md)                               '(nPm)/m!={n!/(n-m)!}/m!
                '-------------------------------------------------------------
                If BIIsError(CC) Then
                    BigIntErrFLG = 5
                    Error BigIntErrFLG
                Else
                    'EߒlZbg
                    BICombination = BIKetaN(CC, CLng(Digit))
                End If
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BICombination")
End Function
