Attribute VB_Name = "BigInt_Sample_Clothoid_Dbl"
Option Explicit
'
'------------------------------------------------------------------------------
'@TvvOŎgp郂W[ł
'------------------------------------------------------------------------------
'
'
'------------------------------------------------------------------------------
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'  N\ChW Clothoid(ClothoidXY() As Double, L As Double, A As Double, R As Double, Optional Digit As Variant = 16, Optional N As Variant = 100, Optional Count As Variant) As Boolean
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2008/10/05]    Ver.1.67 Alpha EditioniJŁj  VKǉ   N\ChW(Clothoid) {x_^(Double)
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ
'------------------------------------------------------------------------------
'

'N\ChW@m{x_^(Double)Łn
Public Function Clothoid(ClothoidXY() As Double, L As Double, a As Double, Optional Digit As Variant = 15, Optional N As Variant = 100, Optional Count As Variant) As Boolean
'  N\ChW
'------------------------------------------------------------------------------
'    ClothoidXY [Double]   N\ChWiߒlpj
'        L          [Double]   N\ChȐ
'        A          [Double]   p[^
'        Digit      [Long]     iȗj߂錅        iȗ15j
'        N          [Long]     iȗjőJԂvZ񐔁iȗ100j
'        Count      [Long]     iȗjJԂvZ񐔁iߒlpŌvZɂ͎gpȂj
'  ߒl  I   [Boolean]  True
'        ُI   [Boolean]  Flse
'------------------------------------------------------------------------------
'    N\ChȐ́AȐ L Ɣa R ႷȐ
'@@@    R~L = A^2@iA͒萔j
'@      Cӓ_ł̃N\ChȐ LAa RAăтƂ̊Ԃɂ́A
'@@@     = L/2R
'------------------------------------------------------------------------------
'    Digit<=15i{x_^̌j,N<=500
'------------------------------------------------------------------------------
'  ˑ  ֐(Private) Log10
'------------------------------------------------------------------------------
'    N\ChȐ L 傫Ȃ()Ɛxɒ[ɈȂ
'          QT]ȏiA=1,L>8,Digit=15j
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium4 2.80C GHz) [By Ver.1.67 BigInt_Demo(vZߒo:ON)]
'          A=1, L=0`8.5, Step0.01, _8501_: PU x
'------------------------------------------------------------------------------
Dim ClothoidX   As Double   '
Dim ClothoidY   As Double   '
Dim R           As Double   'a
Dim Tau         As Double   '
Dim Tau2        As Double   '^2
Dim F2N1X       As Double   '(2(N-1))!
Dim F2N1Y       As Double   '(2N-1)!
Dim SgnX        As Double   'X
Dim CxTMP       As Double   '
Dim CxTMP2      As Double   '
Dim TauPowerX   As Double   '
Dim FactorialX  As Double   '
Dim SgnY        As Double   'Y
Dim CyTMP       As Double   '
Dim CyTMP2      As Double   '
Dim TauPowerY   As Double   '
Dim FactorialY  As Double   '
Dim I           As Long     '
Dim K           As Long     '
Dim Ddm         As Long     ']Ti錅j[Decision-digit margin]
Dim dEX         As Long     'X livŽj
Dim dEY         As Long     'Y livŽj
Dim dDigit      As Long     'vZ]T
Dim dStepN      As Long     'o͕px
    On Error GoTo ERR:
    'Zo, őJԂvZ l`FbN
    If (a < 0) Or (Digit > 15) Or (N > 100) Or (Digit <= 0) Or (N <= 0) Then
        'iuvV[W̌ĂяoA܂͈słBvG[^Iɔj
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        CxTMP = 0#
        CxTMP2 = 0#
        ClothoidX = 0#
        CyTMP = 0#
        CyTMP2 = 0#
        ClothoidY = 0#
        '
        If L = 0# Then
        'L=0
            'ClothoidX = X0
            'ClothoidY = Y0
            R = 0#
        Else
        'L>0
            Ddm = 5&       ']T
            dDigit = 5&    'vZ]T
            dStepN = 2&    'o̓Xebv
            '萔
            R = a * a / L
            Tau = L / (2# * R)
            Tau2 = Tau ^ 2#
            'l
            SgnX = -1#
            SgnY = -1#
            F2N1X = 1#
            F2N1Y = 1#
            ' N ̈ʎ
            'X: A(2){(-1)^(N-1)/((2(N-1)!*(4N-3))*^(2*(N-1))}
            'Y: Aс(2){(-1)^(N-1)/((2N-1)!*(4N-1))*^(2*(N-1))}
            For I = 1& To N
                'CxTMP = ((-1) ^ (I - 1)) / ((2 * (I - 1)!) * (4 * I - 3)) * (Tau ^ (2 * (I - 1)))
                'CyTMP = ((-1) ^ (I - 1)) / (((2 * I - 1)!) * (4 * I - 1)) * (Tau ^ (2 * (I - 1)))
                '(-1)^(N-1)
                SgnX = CDbl((-1&) ^ (I - 1&))
                SgnY = CDbl((-1&) ^ (I - 1&))
                'X:1/((2(N-1)!*(4N-3))
                'Y:1/((2N-1)!*(4N-1))
                If I = 1& Then
                    F2N1X = 1#
                    F2N1Y = 1#
                Else
                    F2N1X = F2N1X * (2& * (I - 1&)) * (2& * (I - 1&) - 1&)
                    F2N1Y = F2N1Y * (2& * I - 1&) * (2& * I - 1& - 1&)
                End If
                FactorialX = 1# / (F2N1X * (4& * I - 3&))
                FactorialY = 1# / (F2N1Y * (4& * I - 1&))
                '^(2*(N-1))
                If I = 1& Then
                    TauPowerX = 1#
                    TauPowerY = 1#
                Else
                    TauPowerX = TauPowerX * Tau2
                    TauPowerY = TauPowerY * Tau2
                End If
                CxTMP = SgnX * FactorialX * TauPowerX
                CyTMP = SgnY * FactorialY * TauPowerY
                '
                If I = 1& Then
                    dEX = 0&
                    dEY = 0&
                Else
                'l Zo
                    dEX = Int(Log10(Abs(ClothoidX / CxTMP)))
                    dEY = Int(Log10(Abs(ClothoidY / CyTMP)))
                End If
                '-----------------------------------------------------------
                '
                If dEX > Digit + Ddm And dEY > Digit + Ddm Then
                '
                    Count = I
                    Exit For
                ElseIf CxTMP = CxTMP2 And CyTMP = CyTMP2 Then
                'ω
                    Exit For
                ElseIf IsError(CxTMP) Or IsError(CyTMP) Then
                'G[l
                    Exit Function
                ElseIf K = N Then
                'őJԂvZ
                    Exit For
                End If
                '-----------------------------------------------------------
                ClothoidY = ClothoidY + CyTMP
                ClothoidX = ClothoidX + CxTMP
                CxTMP2 = CxTMP
                CyTMP2 = CyTMP
                '
                If K Mod dStepN = 0& Then
                    Call Wait(0.0000001)   'DoEvents
                End If
                Count = I
            Next I
            ClothoidX = Sgn(L) * a * Sqr(2# * Tau) * ClothoidX
            ClothoidY = Sgn(L) * a * Tau * Sqr(2# * Tau) * ClothoidY
        End If
        'W ߒlZbg
        ReDim ClothoidXY(0 To 1)
        ClothoidXY(0) = ClothoidX
        ClothoidXY(1) = ClothoidY
        'I
        Clothoid = True
    End If
Exit Function
ERR:
'Resume Next
    Erase ClothoidXY
    Clothoid = False
End Function
'pΐ
Private Function Log10(X As Double) As Double
'  pΐ(10Ƃΐ)
'------------------------------------------------------------------------------
'    X         [Double]  pΐ߂鐔l
'  ߒl  I  [Double]  pΐ
'        ُI  [Double]  0
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  ˑ
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium4 2.80C GHz)
'                     mF
'------------------------------------------------------------------------------
    On Error Resume Next
    Log10 = Log(X) / Log(10#)
End Function
