Attribute VB_Name = "BigInt_Definition_FFT"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ FFT
'
'------------------------------------------------------------------------------
'
'@t[Gϊ (FFT:Fast Fourier Transform) ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
Public Const FFTLimitDigit As Long = 4       't[Gϊ  ivf̌j
'                                                FFTDouble^ŉZ錅ŃI[o[t[Ȃ̕Kv܂
'                                                DoublȅZx1ƉZx2ŃI[o[t[Ȃ
'                                                  5 A=99999   OK (A*A+A*A+A*A=99999*99999+99999*99999+99999*99999=29999400003 <11>)
'                                                  6   B=999999  OK (B*B+B*B+B*B=999999*999999+999999*999999+999999*999999=2999994000003 <13>)
'                                                  7   C=9999999 NG (C*C+C*C+C*C=9999999*9999999+9999999*9999999+9999999*9999999=299999940000003 <15>)
Public Const FFTLimitN     As Long = 18      't[Gϊ  z񐔂̍őliQ̐搔Ŏwj
'                                               ()́AA*B FFTLimitDigit=5 ̎́iɁjPŌvZłő包
'                                               <>́AA*B FFTLimitDigit=4 ̎́iɁjPŌvZłő包
'                                                 2^14=  16384(   40960), 2^15=   32768(   81920), 2^16=   65536(  163840),
'                                                 2^17= 131072(  327680), 2^18=  262144(  655360), 2^19=  524288( 1310720),
'                                                 2^17= 131072<  262144>, 2^18=  262144<  524288>, 2^19=  524288< 1048576>,
'                                                 2^20=1048576< 2097152>, 2^21= 2097152< 4194304>, 2^22= 4194304< 8388608>,
'                                                 2^23=8388608<16777216>, 2^24=16777216<33554432>, 2^25=33554432<67108864>
'
'    @Ӂ@FFTLimitNFFTLimitDigitɂ́Agݍ킹܂
'              iJ̌olōׂ͒Ă܂^ZmZtAAȂǁnɂĈقȂ܂j
'                 ---------------+----------------------------------------
'                  FFTLimitDigit | FFTLimitDigit
'                 ---------------+----------------------------------------
'                       6        |   mF
'                       5        |   `14, 15, 16
'                       4        |   17, 18, 19, 20, 21, 22, 23, 24, 25
'                       3        |   mF
'                 ---------------+----------------------------------------
'                 FFTLimitDigit́AVȏ̒l͕s
'
'        j[g@͎̉itAAjȂǂŉ̎ZoɎsȂǂ̎́A
'        FFTłĂꍇ܂̂ŁAFFTLimitDigit̒lP邩A
'        FFTLimitN̒lPĐɋ܂l܂ŃgCȂǂĉ
'        ̒lƁAFFŤvZ܂
'
'        PTm̏Z܂łȂA(FFTLimitDigit,FFTLimitN)=(5,16)ŁA
'        ȏȂ΁A(4,17`)̑gݍ킹߂܂
'
'        FFTLimitN̒lɂ͐͂܂񂪁ȀZŁA
'        Ƃ (FFTLimitDigit,FFTLimitN)=(4,25) Ɣz̗vf 2^25=33,554,432A
'        iɁjPŌvZłő包́A(2^25)*4/2 = 33554432*4/2 = 67,108,864 ƂȂ܂B
'        ̐PɕKvȃ́A67,108,864 byte  67,108 KB  67 MB
'        Z(BIMulFFT)̌vZɂ́i傴ςȌvZŁjAgQERs[QEPEfpzmQRWoCgKvŁA
'        Œł 67MB*(2+2+1)MB+33554432*2*3*8byte = 335MB+1,610,612,736byte = 335MB+1610MB = 1945MB  1.95GB !! ͕Kvł
'
'        ̎gpʂ炷ׂɍ폜ốAPƕfpzipjPPWoCgȂ̂ŁA
'        i[U[`^ByValwłȂ̂ŃRs[Q͌点܂j
'        67MB*(2+2)MB+33554432*(2*2+1*1)*8byte = 368MB+1,342,177,280byte = 335MB+1342MB = 1677MB  1.68GBj
'
'        vZ FFTLimitDigitFFTLimitN 𓮓IɑΉΌIȌvZ\łA
'        o[Wł͑ΉłĂ܂B
'
'
'    @Ql  t[Gϊ(FFT)̉ZA10i^(Decimal)܂͂S{xŏł΁A
'              FFTLimitDigit()̒l傫āAł܂AcOȂVBAł́A
'              Op֐10i^(Decimal)ɖΉȂ̂ŁAU傫ł܂
'              ǍŁAOp֐S{xŎgp\ł΁AȂ鍂\ł
'
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'  t[Gϊ       FFT(F() As Double, Optional IrevFLG As Boolean = False, Optional DivN As Double = 0, Optional DivFLG As Boolean = True) As Boolean
'  zf[^̕       ArraySort(A() As Double) As Boolean
'  --- BigIntType ---
'  Z Multiplication. <FFT >  BIMulFFT(A As BigIntType, B As BigIntType, Optional Digit As Variant, Optional N As Long = FFTLimitDigit) As BigIntType
'  --- <f(Complex Number)> ̔z ---
'  f̉Z           CNAdd(A() As Double, B() As Double, C() As Double) As Boolean
'          Z           CNSub(A() As Double, B() As Double, C() As Double) As Boolean
'          Z           CNMul(A() As Double, B() As Double, C() As Double) As Boolean
'          Z           CNDiv(A() As Double, B() As Double, C() As Double) As Boolean
'          Βl         CNAbs(A() As Double, B() As Double, Optional FLG As Boolean = False) As Boolean
'  --- Private [BIMulFFT̎gpp]---
'  BigIntFFTp̔z  BigInt2Arry(A As BigIntType, Arry() As Double, Optional L As Long = FFTLimitDigit) As Boolean
'  FFTp̔zBigInt  Arry2BigInt(Arry() As Double, A As BigIntType, Optional L As Long = FFTLimitDigit) As Boolean
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  dlύX   W[ύX(BigInt_Definition_FFTBigInt_Functions_FFT)
'                                                           X   pubN萔(FFTLimitN) ftHgݒlύX[1817]
'   [2009/12/07]    Ver.1.87 Alpha EditioniJŁj  C       zf[^̕(ArraySort) ϐ(N)錾EZoC
'   [2009/01/04]  * Ver.1.80 Alpha EditioniJŁj  VKǉ   t[Gϊ(FFT)Azf[^̕ցAfiZEZEZEZEΒlj
'                                                       VKǉ   BigIntFFTp̔zɁAFFTp̔zBigInt
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ  ̃W[Ŏ舵vf <f(Complex Number)> ̔zivf:Nj͈ȉ̗lł
'              zFF(0 to N-1, 0 to 1) As Double
'                      F(x,0): 
'                      F(x,1): 
'------------------------------------------------------------------------------
'

't[Gϊ (FFT:Fast Fourier Transform)
Public Function FFT(F() As Double, Optional IrevFLG As Boolean = False, Optional DivN As Double = 0, Optional DivFLG As Boolean = True) As Boolean
'  Q̎gԈ 
'------------------------------------------------------------------------------
'  QlURL  http://www.kurims.kyoto-u.ac.jp/~ooura/fftman/ftmn1_2.html#sec1_2
'------------------------------------------------------------------------------
'    F       [Double]   ͒lƏo͒liߒljpiz񐔂͂Q̐j
'                             zFF(0 to N-1, 0 to 1)
'                                      F(x,0): 
'                                      F(x,1): 
'        IrevFLG [Boolean]  iȗjtt[Gϊ(Inverse FFT)̃tO
'                                       True : tt[Gϊ
'                                       False: t[Gϊiȗj
'        DivN    [Double]   iȗjtt[Gϊ̏ (>=0)
'                                       0:ivfNj
'        DivFLG  [Boolean]  iȗjtt[Gϊ̋ ZtO
'                                       True : Ziȗj
'                                       False: ZXLbviBigInt̏Zpj
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'    zivfj͂Q̐ (2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, , 33554432)
'        z񐔂͑̉e󂯂̂ōő 33554432(=2^25) x܂łƂȂ܂
'------------------------------------------------------------------------------
'  Ql  FFTBigInt̏ZɗpꍇAő啪(FFTLimitDigit)4ł́A
'        33554432*4/2=67108864vZ\ȍő包ivf͌̂Q{KvȂ̂1/2ƂȂj
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError,
'              BIWarnningDialog
'        萔  FFTLimitN
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I     As Long     '
Dim J     As Long     '
Dim K     As Long     '
Dim L     As Long     '
Dim N     As Long     'f[^(Q̐)
Dim N1    As Long     'N-1
Dim M     As Long     '
Dim Mh    As Long     '
Dim Irev  As Long     '
Dim wr    As Double   '
Dim Wi    As Double   '
Dim Xr    As Double   '
Dim Xi    As Double   '
Dim Pi    As Double   '
Dim TMP   As Double   '
Dim theta As Variant  'Dec/Double   '}2*PI/n [}CiX͋tt[Gϊ]
    On Error GoTo ERR:
    BigIntErrFLG = False
    N = UBound(F, 1&) - LBound(F, 1&) + 1&
    TMP = Log(N) / Log(2)
    L = Int(TMP)
    TMP = TMP Mod 1
    If LBound(F, 1&) <> 0& Or L > FFTLimitN Or TMP > 0# Or DivN < 0# Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        N1 = N - 1&
        '
        '
        I = 0&
        For J = 1& To N1 - 1&
            K = CLng(N / 2&)
            I = I Xor K
            Do While K > I
                K = CLng(K / 2&)
                I = I Xor K
            Loop
            If J < I Then
                Xr = F(J, 0)
                Xi = F(J, 1)
                F(J, 0) = F(I, 0)
                F(J, 1) = F(I, 1)
                F(I, 0) = Xr
                F(I, 1) = Xi
            End If
        Next J
        '
        'Z
        '          3.1415926535897932384626433832795
        Pi = CDec("3.141592653589793238462643383")       '10i^(Decimal)̍ő 28
        theta = CDec(Pi * CDec(2)) / N
        If IrevFLG Then
        'tt[Gϊ
            theta = CDec(-1) * theta
        End If
        '
        Mh = 1&
        M = Mh * 2&
        Do While M <= N
            Irev = 0&
            For I = 0& To N1 Step M
                wr = Cos(theta * Irev)
                Wi = Sin(theta * Irev)
                K = CLng(N / 4&)
                Irev = Irev Xor K
                Do While K > Irev
                    K = CLng(K / 2&)
                    Irev = Irev Xor K
                Loop
                For J = I To Mh + I - 1&
                    K = J + Mh
                    Xr = F(J, 0) - F(K, 0)
                    Xi = F(J, 1) - F(K, 1)
                    F(J, 0) = F(J, 0) + F(K, 0)
                    F(J, 1) = F(J, 1) + F(K, 1)
                    F(K, 0) = wr * Xr - Wi * Xi
                    F(K, 1) = wr * Xi + Wi * Xr
                Next J
            Next I
            Mh = M
            M = Mh * 2&
        Loop
        '
        If IrevFLG Then
        'tt[Gϊ̏Z
            If DivN = 0# Then
                DivN = CDbl(N)
            End If
            If DivFLG Then
                For I = LBound(F, 1&) To UBound(F, 1&)
                    F(I, 0) = F(I, 0) / DivN
                    F(I, 1) = F(I, 1) / DivN
                Next I
            Else
            '̌vZȗ
                For I = LBound(F, 1&) To UBound(F, 1&)
                    F(I, 0) = F(I, 0) / DivN
                    'F(I, 1) = F(I, 1) / DivN
                Next I
            End If
        End If
        FFT = True
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "FFT")
End Function
'zf[^̕
Public Function ArraySort(a() As Double) As Boolean
'  Q̐̂Ƃɂ̃rbg]̕בւ 
'------------------------------------------------------------------------------
'  QlURL  http://www.kurims.kyoto-u.ac.jp/~ooura/fftman/ftmn1_25.html#sec1_2_5
'------------------------------------------------------------------------------
'    A()     [Double]   ͒lѕ֒liߒlj
'                             zFA(0 to N-1, 0 to 1)
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'    DoubleAŏ̓Y͂O
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError,
'              BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    L̍t[Gϊ(FFT)͓ŕւĂ̂Œʏ킱̊֐͕KvȂ
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I    As Long      '
Dim J    As Long      '
Dim K    As Long      '
Dim N    As Long      'vf
Dim N2   As Long      'vf-2
Dim TMP0 As Double    '
Dim TMP1 As Double    '
    On Error GoTo ERR:
    BigIntErrFLG = False
    N = (UBound(a, 1&) - LBound(a, 1&)) + 1&
    N2 = (UBound(a, 1&) - LBound(a, 1&)) - 1&
    I = 0&
    For J = 1& To N2
        K = CLng(N / 2&)
        Do While K > I
            K = CLng(K / 2&)
            I = I Xor K
        Loop
        If J < I Then
            TMP0 = a(J, 0)
            TMP1 = a(J, 1)
            a(J, 0) = a(I, 0)
            a(J, 1) = a(I, 1)
            a(I, 0) = TMP0
            a(I, 1) = TMP1
        End If
    Next J
    ArraySort = True
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "ArraySort")
End Function
'Z Multiplication. <FFT > ********************************************************************************
Public Function BIMulFFT(a As BigIntType, B As BigIntType, Optional Digit As Variant, Optional N As Long = FFTLimitDigit) As BigIntType
'  A*B
'------------------------------------------------------------------------------
'  ʏBigIntMulFԐړIɂgp
'  iő包ȏ̏ꍇɁAIKaratsuba@ŕ̂Łj
'------------------------------------------------------------------------------
'  @A         [BigIntType]    [U[`^
'  @@@B         [BigIntType]    [U[`^
'  @@@Digit     [Variant/Long]  iȗj߂錅
'                                  IsMissing֐gp̂Variant^ƂĂ
'  @@@N         [Long]         iȗjiFFTDouble^ŉZ錅j
'  @@@LimitFLG  [Boolean]      iȗj\ő包`FbNtO
'  ߒl@I  [BigIntType]    [U[`^ (A*B̉)
'@@  @ُI  [BigIntType]    [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ȒPȉȉ̗Ŏ܂
'
'        C=A*B (A=1234567890123456789E+10, B=-987654321E-20)
'
'        1. ƉƎw𕪂
'             AS=+1, A1=1234567890123456789 (19), A2=1E+10
'             BS=-1, B1=987654321           ( 9), B2=1E-20
'             BigIntType^͂̏[BigSgn,BigInt,BigExp]ɕĂ܂
'        2. z쐬vf
'           2.1. Ɠ[𓪂ɂ܂
'                  A1S=0000000000000000000 & 1234567890123456789
'                     =00000000000000000001234567890123456789 (19*2=38)
'                  B1S=000000000 & 987654321
'                     =000000000987654321 (9*2=18)
'           2.2. A1SB1S̑傫̌߂܂
'                  K=Max(A1Š, B1Š)
'                   =Max(38,18)
'                   =38
'           2.3. Niz񐔁j肵܂iQ̐搔j
'                  (10^FFTLimitDigit[FFTLimitDigit:t[Gϊ ])ł̌
'                    L=Roundup(K/FFTLimitDigit)
'                     =Roundup(38/4)
'                     =Roundup(9.5)
'                     =10
'                  Q̐搔
'                    N=2^1=2  <  L NG
'                    N=2^2=4  <  L NG
'                    N=2^3=8  <  L NG
'                    N=2^4=16 >= L OK !
'           2.4. t[Gϊp̔zivf(N,2),Double^jR쐬vf܂
'                  ListA(0 to N-1, 0 to 1)
'                  ListB(0 to N-1, 0 to 1)
'                  ListC(0 to N-1, 0 to 1) [p]
'                  ------+------------------------------------------------------------
'                    A1S | 0000  0000  0000  0000  0000  1234  5678  9012  3456  7890
'                  ListA | (9,0) (8,0) (7,0) (6,0) (5,0) (4,0) (3,0) (2,0) (1,0) (0,0)
'                  ------+------------------------------------------------------------
'                    B1S |   00  0000  0009  8765  4321
'                  ListB | (4,0) (3,0) (2,0) (1,0) (0,0)
'                  ------+------------------------------------------------------------
'                  000000̓[A00099Ac̗vfׂ͂ă[
'        3. FFT(t[Gϊ)
'             Call FFT(ListA)
'             Call FFT(ListB)
'        4. zifj̏Z
'             ListC=ListA*ListB  [Call CNMul(ListA, ListB, ListC)]
'        5. FFT(tt[Gϊ)
'             Call FFT(ListC, True, 0, False)
'        6. zListC(10^FFTLimitDigit)ŌJ菈
'             M=10^FFTLimitDigit
'             C_0=ListC(0,0) Mod M
'             C_1=(ListC(1,0)+(ListC(0,0) \ M)) Mod M
'             C_2=(ListC(2,0)+(ListC(1,0) \ M)) Mod M
'               
'             C_N-2=(ListC(N-2,0)+(ListC(N-3,0) \ M)) Mod M
'             C_N-1=ListC(N-1,0)+ListC(N-2,0)
'             C_xx FFTLimitDigit(=4)̕ŁAs͓Ƀ[ǉ
'             Ō̗vf ListC(N-1,0)͌J菈sv
'             ListC(x,1)͎̕gp܂
'        7. ߂i̘Aj
'             ANS = C_N-1 & C_N-2 &  & C_2 & C_1 & C_0
'             ́AANS瓪̕svȃ[폜
'             ۂɂ͕̘AZq(&)͔ɒx̂ŁAMidXe[gggpĂ܂
'               iQlURL http://msdn.microsoft.com/ja-jp/library/cc344058.aspxj
'        8. ɕƎw
'             C = AS2*BS**A2*B2
'               = 1*(-1)**1E+10*1E-20
'               = -1**1E-10
'
'------------------------------------------------------------------------------
'    AEB̌ 262144[=(2^FFTLimitN)*FFTLimitDigit/2]ȉ
'        ilFFTLimitN:17AFFTLimitDigit:4̏ꍇj
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError,
'              CutTopZero, CutLastZero, BIOverflowErrCheck,
'              DigitCheck_And_SetBigIntDigitCalculations,
'              BIKetaN,
'              FFT, CNMul, BigInt2Arry(*), Arry2BigInt(*),
'              BIWarnningDialog,
'              *:Private
'        萔  FFTLimitN, DefaultDigit, FFTLimitDigit
'        ϐ  DefaultDigit2, BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql@vZ
'          viBigIntMulFQlɂĉj
'------------------------------------------------------------------------------
Dim AA     As BigIntType   'Copy
Dim BB     As BigIntType   '
Dim CC     As BigIntType   '
Dim M      As Long         'vZi=Digit:߂錅j
Dim K1     As Long         '
Dim K2     As Long         '
Dim L0     As Long         '
Dim L1     As Long         '
Dim LinmtM As Long         'vZ\ȍő包
Dim ComplexNumberListA() As Double   'f(Complex Number)̔zA
Dim ComplexNumberListB() As Double   'f(Complex Number)̔zB
Dim ComplexNumberListC() As Double   'f(Complex Number)̔zC
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(a) Or BIIsError(B) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf (N > FFTLimitDigit) Or (N < 0&) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        AA = a
        BB = B
        'vZi߂錅`FbNj
        M = DigitCheck_And_SetBigIntDigitCalculations(Digit, Len(AA.BigInt), Len(BB.BigInt), "*")
        'vZ\ȍő包`FbN
        K1 = Len(AA.BigInt)
        K2 = Len(BB.BigInt)
        LinmtM = CLng((2& ^ FFTLimitN) * N / 2&)
        If K1 > LinmtM Or K2 > LinmtM Then
        'z񐔂̍őlG[
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '
            If K1 > K2 Then
                K1 = K1 - K2
                BB.BigInt = BB.BigInt & String$(K1, "0")
                BB.BigExp = BB.BigExp - K1
            ElseIf K2 > K1 Then
                K2 = K2 - K1
                AA.BigInt = AA.BigInt & String$(K2, "0")
                AA.BigExp = AA.BigExp - K2
            End If
            '
            Do
                'z쐬
                If BigInt2Arry(AA, ComplexNumberListA, 2, N) Then
                    If BigInt2Arry(BB, ComplexNumberListB, 2, N) Then
                        'FFT(t[Gϊ)
                        If FFT(ComplexNumberListA) Then
                            If FFT(ComplexNumberListB) Then
                                'Z
                                If CNMul(ComplexNumberListA, ComplexNumberListB, ComplexNumberListC) Then
                                    'Inverse FFT(tt[Gϊ)
                                    If FFT(ComplexNumberListC, True, 0, False) Then
                                        'to BigIntType
                                        If Arry2BigInt(ComplexNumberListC, CC, N) Then
                                            '
                                            If Asc(AA.BigSgn) = Asc(BB.BigSgn) Then
                                                CC.BigSgn = "+"
                                            Else
                                                CC.BigSgn = "-"
                                            End If
                                            '`FbN
                                            L0 = Len(CC.BigInt)
                                            L1 = Len(AA.BigInt) + Len(BB.BigInt)
                                            If L0 = L1 Or L0 = (L1 - 1&) Then
                                                'w
                                                CC.BigExp = AA.BigExp + BB.BigExp
                                                '[Jbg
                                                Call CutTopZero(CC)
                                                Call CutLastZero(CC)
                                                If Not BIIsError(CC) Then
                                                '
                                                    Exit Do
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
                'G[
                BigIntErrFLG = 51    'G[
                Error BigIntErrFLG
                Exit Function
            Loop
            '
            'I[o[t[`FbN
            If BIOverflowErrCheck(CC) Then
                BigIntErrFLG = 6      'I[o[t[
                Error BigIntErrFLG
                Exit Function
            End If
            'EߒlZbg
            BIMulFFT = BIKetaN(CC, M)
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIMulFFT")
End Function
'f(Complex Number)̉Z(Addition)
Public Function CNAdd(a() As Double, B() As Double, C() As Double) As Boolean
'  (a+bi)+(c+di)=(a+c)+(b+d)i
'------------------------------------------------------------------------------
'    A()     [Double]   ͒l  zFA(0 to N-1, 0 to 1)
'                                         A(x,0): 
'                                         A(x,1): 
'        B()     [Double]   ͒l  zFB(0 to N-1, 0 to 1)
'                                         B(x,0): 
'                                         B(x,1): 
'        C()     [Double]   Zliߒljzivfj͂̃W[ōĒ`܂
'                                         C(x,0): 
'                                         C(x,1): 
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'     A  B ̗vf͓
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ߒl C ̍ŏ̓Y͂O
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I As Long   '
Dim N As Long   'vf
    On Error GoTo ERR:
    BigIntErrFLG = False
    If UBound(a, 1&) = UBound(B, 1&) And LBound(a, 1&) = LBound(B, 1&) Then
        If UBound(a, 2&) = UBound(B, 2&) And LBound(a, 2&) = LBound(B, 2&) Then
            If LBound(a, 1&) = 0& And LBound(a, 2&) = 0& And UBound(a, 2&) = 1& Then
                N = UBound(a, 1&) - LBound(a, 1&)
                ReDim C(0 To N, 0 To 1)
                For I = 0& To N
                    C(I, 0) = a(I, 0) + B(I, 0)
                    C(I, 1) = a(I, 1) + B(I, 1)
                Next I
                CNAdd = True
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "CNAdd")
End Function
'f(Complex Number)̌Z(Subtraction)
Public Function CNSub(a() As Double, B() As Double, C() As Double) As Boolean
'  (a+bi)-(c+di)=(a-c)+(b-d)i
'------------------------------------------------------------------------------
'    A()     [Double]   ͒l  zFA(0 to N-1, 0 to 1)
'                                         A(x,0): 
'                                         A(x,1): 
'        B()     [Double]   ͒l  zFB(0 to N-1, 0 to 1)
'                                         B(x,0): 
'                                         B(x,1): 
'        C()     [Double]   Zliߒljzivfj͂̃W[ōĒ`܂
'                                         C(x,0): 
'                                         C(x,1): 
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'     A  B ̗vf͓
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ߒl C ̍ŏ̓Y͂O
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I As Long   '
Dim N As Long   'vf
    On Error GoTo ERR:
    BigIntErrFLG = False
    If UBound(a, 1&) = UBound(B, 1&) And LBound(a, 1&) = LBound(B, 1&) Then
        If UBound(a, 2&) = UBound(B, 2&) And LBound(a, 2&) = LBound(B, 2&) Then
            If LBound(a, 1&) = 0& And LBound(a, 2&) = 0& And UBound(a, 2&) = 1& Then
                N = UBound(a, 1&) - LBound(a, 1&)
                ReDim C(0 To N, 0 To 1)
                For I = 0& To N
                    C(I, 0) = a(I, 0) - B(I, 0)
                    C(I, 1) = a(I, 1) - B(I, 1)
                Next I
                CNSub = True
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "CNSub")
End Function
'f(Complex Number)̏Z(Multiplication)
Public Function CNMul(a() As Double, B() As Double, C() As Double) As Boolean
'  (a+bi)(c+di)=(ac-bd)+(ad+bc)i
'------------------------------------------------------------------------------
'    A()     [Double]   ͒l  zFA(0 to N-1, 0 to 1)
'                                         A(x,0): 
'                                         A(x,1): 
'        B()     [Double]   ͒l  zFB(0 to N-1, 0 to 1)
'                                         B(x,0): 
'                                         B(x,1): 
'        C()     [Double]   Zliߒljzivfj͂̃W[ōĒ`܂
'                                         C(x,0): 
'                                         C(x,1): 
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'     A  B ̗vf͓
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ߒl C ̍ŏ̓Y͂O
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I As Long   '
Dim N As Long   'vf
    On Error GoTo ERR:
    BigIntErrFLG = False
    If UBound(a, 1&) = UBound(B, 1&) And LBound(a, 1&) = LBound(B, 1&) Then
        If UBound(a, 2&) = UBound(B, 2&) And LBound(a, 2&) = LBound(B, 2&) Then
            If LBound(a, 1&) = 0& And LBound(a, 2&) = 0& And UBound(a, 2&) = 1& Then
                N = UBound(a, 1&) - LBound(a, 1&)
                ReDim C(0 To N, 0 To 1)
                For I = 0& To N
                    C(I, 0) = a(I, 0) * B(I, 0) - a(I, 1) * B(I, 1)
                    C(I, 1) = a(I, 0) * B(I, 1) + a(I, 1) * B(I, 0)
                Next I
                CNMul = True
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "CNMul")
End Function
'f(Complex Number)̏Z(Division)
Public Function CNDiv(a() As Double, B() As Double, C() As Double) As Boolean
'  (a+bi)(c+di)={(ac+bd)/(c^2+d^2)}+{(bc-ad)/(c^2+d^2)}i
'------------------------------------------------------------------------------
'    A()     [Double]   ͒l  zFA(0 to N-1, 0 to 1)
'                                         A(x,0): 
'                                         A(x,1): 
'        B()     [Double]   ͒l  zFB(0 to N-1, 0 to 1)
'                                         B(x,0): 
'                                         B(x,1): 
'        C()     [Double]   Zliߒljzivfj͂̃W[ōĒ`܂
'                                         C(x,0): 
'                                         C(x,1): 
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'     A  B ̗vf͓
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ߒl C ̍ŏ̓Y͂O
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I As Long   '
Dim N As Long   'vf
Dim D As Double
    On Error GoTo ERR:
    BigIntErrFLG = False
    If UBound(a, 1&) = UBound(B, 1&) And LBound(a, 1&) = LBound(B, 1&) Then
        If UBound(a, 2&) = UBound(B, 2&) And LBound(a, 2&) = LBound(B, 2&) Then
            If LBound(a, 1&) = 0& And LBound(a, 2&) = 0& And UBound(a, 2&) = 1& Then
                N = UBound(a, 1&) - LBound(a, 1&)
                ReDim C(0 To N, 0 To 1)
                For I = 0& To N
                    D = B(I, 0) * B(I, 0) + B(I, 1) * B(I, 1)
                    C(I, 0) = (a(I, 0) * B(I, 0) + a(I, 1) * B(I, 1)) / D
                    C(I, 1) = (a(I, 1) * B(I, 0) - a(I, 0) * B(I, 1)) / D
                Next I
                CNDiv = True
            End If
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "CNDiv")
End Function
'f(Complex Number)̐Βl(ABS)
Public Function CNAbs(a() As Double, B() As Double, Optional FLG As Boolean = False) As Boolean
'  |(a+bi)|=(a^2-b^2)
'------------------------------------------------------------------------------
'    A()     [Double]   ͒l  zFA(0 to N-1, 0 to 1)
'                                         A(x,0): 
'                                         A(x,1): 
'        B()     [Double]   ΒliߒljB(0 to N-1) zivfj͂̃W[ōĒ`܂
'        FLG     [Boolean]  ߒlB̔z񎟌 [True:2, False:1]
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ߒl B ̍ŏ̓Y͂O
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I As Long   '
Dim N As Long   'vf
    On Error GoTo ERR:
    BigIntErrFLG = False
    N = UBound(a, 1&) - LBound(a, 1&) + 1&
    If FLG Then
    'ߒl2̔z
        ReDim B(0 To N - 1, 0 To 1)
        For I = LBound(a, 1&) To N - 1&
            B(I, 0) = (a(I, 0) * a(I, 0) + a(I, 1) * a(I, 1)) ^ 0.5
        Next I
    Else
        ReDim B(0 To N - 1)
        For I = LBound(a, 1&) To N - 1&
            B(I) = (a(I, 0) * a(I, 0) + a(I, 1) * a(I, 1)) ^ 0.5
        Next I
    End If
    CNAbs = True
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "CNAbs")
End Function
'BigIntFFTp̔z <BIMulFFTp>
'Private
Function BigInt2Arry(a As BigIntType, Arry() As Double, Optional K As Long = 2, Optional L As Long = FFTLimitDigit) As Boolean
'  ArryBigIntType
'------------------------------------------------------------------------------
'  @A       [BigIntType]  [U[`^
'        Arry()  [Double]      iߒljzFArry(0 to N-1, 0 to 1)
'                                            Arry(x,0): 
'                                            Arry(x,1): iׂĂOj
'        K       [Long]        
'        L       [Long]        iȗj
'  ߒl@l  [Boolean]  False
'@@  @G[  [Boolean]  True
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'    ɂ͑ΉĂ܂
'        VBAẄ̐iBigInt_Definition_0QƁj '@@@-VBA-@@@
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError,
'              BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    zivfj͂̃W[ōĒ`܂
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim AA  As BigIntType   'Copy
Dim I   As Long         '
Dim J   As Long         '
Dim N   As Long         'ϊp̃f[^ (Q̐)
Dim LA0 As Long         'f[^ 
Dim LA1 As Long         '
Dim SA  As String       '
Dim Str As String       '
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(a) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        AA = a
        N = 1&
        LA0 = Len(AA.BigInt)
        LA1 = LA0 \ L
        If LA0 Mod L > 0& Then
            LA1 = LA1 + 1&
        End If
        Do
            N = N * K
        Loop While N < LA1 * K
        ReDim Arry(0 To N - 1, 0 To 1)
        SA = String$(L * LA1, "0")
        Mid(SA, L * LA1 - LA0 + 1&) = AA.BigInt
        LA0 = Len(SA)
        J = L
        For I = N - 1& To (N - 1&) - (LA1 - 1&) - 1& Step -1&
            Str = Mid$(SA, LA0 - J + 1&, L)   '@@@-VBA-@@@
            Arry(I, 0) = CDbl(Str)
            'Arry(I, 1) = 0
            J = J + L
            If J <= 0& Or LA0 - J + 1& <= 0& Then
                Exit For
            End If
        Next I
        BigInt2Arry = True
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BigInt2Arry")
End Function
'FFTp̔zBigInt <BIMulFFTp>
'Private
Function Arry2BigInt(Arry() As Double, a As BigIntType, Optional L As Long = FFTLimitDigit) As Boolean
'  BigIntTypeArry
'------------------------------------------------------------------------------
'    Arry()  [Double]      zFArry(0 to N-1, 0 to 1)
'                                    Arry(x,0): 
'                                    Arry(x,1): 
'        A       [BigIntType]  iߒlj[U[`^
'        L       [Long]        iȗj
'  ߒl@l  [Boolean]     False
'@@  @G[  [Boolean]     True
'------------------------------------------------------------------------------
'    BIMulFFT̎gppł
'------------------------------------------------------------------------------
'    ɂ͑ΉĂ܂i͖܂j
'------------------------------------------------------------------------------
'  ˑ  ֐  CutTopZeroS,
'              BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    zivfj͂̃W[ōĒ`܂
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim I     As Long     '
Dim N     As Long     '
Dim Nl    As Long     '
Dim D     As Double   '
Dim J     As Double   '
Dim K     As Double   '
Dim UnitE As Double   'i̒Pʐj
Dim SL    As String   '
Dim SNL   As String   '
Dim TMP1  As String   '
Dim TMP2  As String   '
    On Error GoTo ERR:
    BigIntErrFLG = False
    If L < 0& Or FFTLimitDigit < L Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        N = (UBound(Arry, 1&) - LBound(Arry, 1&) + 1&) - 1&   'Ō͏O
        K = 0#
        Nl = N * L
        UnitE = CDbl(10 ^ L)
        SL = String$(L, "0")
        SNL = String$(Nl, "0")
        For I = UBound(Arry, 1&) - 1& To LBound(Arry, 1&) Step -1&
            If Arry(I, 0) < 0# Then
                D = K
            Else
                D = Round(Arry(I, 0)) + K
            End If
            If D < 0# Then
                J = 0#
                K = 0#
            ElseIf D > 2147483647 Then
               K = Int(D / UnitE)
               J = D - K * UnitE
            Else
               J = D Mod UnitE
               K = D \ UnitE
            End If
            TMP1 = SL
            TMP2 = CStr(J)
            Mid(TMP1, L - Len(TMP2) + 1&, Len(TMP2)) = TMP2   'L̐
            Mid(SNL, I * L + 1&, L) = TMP1                    'g
        Next I
        If K <> 0 Then
            SNL = CStr(K) & SNL
        End If
        '------------------------------
        Call CutTopZeroS(SNL)
        With a
            .BigInt = SNL
            .BigExp = 0&
            .BigSgn = "+"
            .BigDat = Empty
        End With
        Arry2BigInt = True
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BigInt2Arry")
End Function
