Attribute VB_Name = "BigInt_Functions_Elliptic"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ Elliptic Integral
'
'------------------------------------------------------------------------------
'
'@ȉ~ϕ(Elliptic Integral) ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    (PEQ) Sȉ~ϕ          BICELbyAGM(K As BigIntType, T As Long, Optional Digit As Variant, _
'                                                          Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    (PEQ) ȉ~ϕ              BIGEL(X As BigIntType, K As BigIntType, T As Long, Optional Digit As Variant, _
'                                                     Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    P ȉ~ϕ̋t֐ [U(amplitude)]  BIam(U As BigIntType, K As BigIntType, Optional Digit As Variant, _
'                                                    Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    Q ȉ~ϕ̋t֐ <j[g@>     BIinvEL(S As BigIntType, K As BigIntType, Optional Digit As Variant, _
'                                                       Optional ELType As Long = 0, Optional FLG As Boolean = False, _
'                                                       Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    Jacobȋȉ~֐ [sn,cn,dn]                BIsncndn(U As BigIntType, K As BigIntType, Digit As Long, _
'                                                        SN As BigIntType, CN As BigIntType, DN As BigIntType, Optional Returnvalue As Long = 0, _
'                                                        Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  --- Private [BIinvEL̎gpp]---
'    Q sSȉ~ϕ                      BIEL(X As BigIntType, K As BigIntType, Digit As Long) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  VKǉ   ȉ~ϕ(BICELbyAGM,BIGEL),Jacobȋȉ~֐(BIsncndn),ȉ~ϕ̋t֐(BIam,BIinvEL)
'                                                       VKǉ   PrivateFunction Q sSȉ~ϕ(BIEL)
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃CuKvł
'    E}[N ,  ́Aȗ\ debug_, debug2_, debug3_ 
'      폜ꍇ̖ڈł
'------------------------------------------------------------------------------
'

' Sȉ~ϕ (complete elliptic integral)
Public Function BICELbyAGM(K As BigIntType, T As Long, Optional Digit As Variant, _
                           Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  PEQ Sȉ~ϕZp􉽕(AGM)ƊSȉ~ϕ̊֌W苁߂
'------------------------------------------------------------------------------
'  Ql  ȉ~֐_ ȉ~Ȑ̉͊w
'            : ~_
'            oŎ:woŉ  (2000N75 )
'            ISBN: 4-13-061303-0
'            [P.265-281]
'------------------------------------------------------------------------------
'  ̑̉E
'    Wikipedia - Zp􉽕
'      URL:http://ja.wikipedia.org/wiki/%E7%AE%97%E8%A1%93%E5%B9%BE%E4%BD%95%E5%B9%B3%E5%9D%87
'    Google  - Zp􉽕 ȉ~ϕ ֌W
'      URL:http://www.google.co.jp/search?q=%E7%AE%97%E8%A1%93%E5%B9%BE%E4%BD%95%E5%B9%B3%E5%9D%87+%E6%A5%95%E5%86%86%E7%A9%8D%E5%88%86+%E9%96%A2%E4%BF%82%E5%BC%8F
'    Yahoo! - Zp􉽕 ȉ~ϕ ֌W
'      URL:http://search.yahoo.co.jp/search?p=%E7%AE%97%E8%A1%93%E5%B9%BE%E4%BD%95%E5%B9%B3%E5%9D%87+%E6%A5%95%E5%86%86%E7%A9%8D%E5%88%86+%E9%96%A2%E4%BF%82%E5%BC%8F
'------------------------------------------------------------------------------
'  Wolfram Mathematica Online Integrator
'    URL:http://integrals.wolfram.com/index.jsp
'      Q ȉ~ϕ (1-k^2(sin[x])^2)^(0.5)dx
'      URL:http://integrals.wolfram.com/index.jsp?expr=%281-k%5E2%28sin%5Bx%5D%29%5E2%29%5E%280.5%29&random=false
'------------------------------------------------------------------------------
'  ɖ𗧂xvZTCg
'    URL:http://keisan.casio.jp/
'      ȉ~ϕ - xvZTCg
'      URL:http://keisan.casio.jp/has10/Menu.cgi?path=08000000%2e%93%c1%8e%ea%8a%d6%90%94%2f07000700%2e%91%c8%89%7e%90%cf%95%aa
'------------------------------------------------------------------------------
'    K        [BigIntType]      ꐔ(modulus) ܂͗S
'                                     PFK͕ꐔ(modulus) [K=Sin(), :(characteristic)]
'                                     QFK͗S
'                                               K= {(a^2-b^2)/(a^2)} [a>=b]
'                                               K=-{(b^2-a^2)/(b^2)} [a<b]
'                                               
'                                                 ȉ~ (X^2/a^2)+(Y^2/b^2)=1
'                                                 ȉ~̒S_AђZWƂƂ
'                                                 a:w(>0)Ƒȉ~̌_̂wWl
'                                                 b:x(>0)Ƒȉ~̌_̂xWl
'                                                K ͑̓lŕ\Ƃ
'                                                 M=K^2   (M:p[^[)
'        T        [Long]            
'                                     P: 1
'                                     Q: 2
'        Digit    [Variant/Long]    iȗj߂錅 (ȗ pubN萔 DefaultDigit or DefaultDigit2)
'        debug_   [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_  [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'  ߒl@l   [BigIntType]      ϕliŜP, ŜPȉ~ʒj
'                                     T=1(P) :K(K) ŜP     [1`1.5707963267949(=/2)]
'                                     T=2(Q) :E(K) ŜPȉ~ʒ [1`1.5707963267949(=/2)]
'@@  @ُI [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    Zp􉽕(AGM)ƊSȉ~ϕ̊֌Wi_ȉ͓Yj
'
'        0<b_0<=a_0, c_0^2=a_0^2-b_0^2
'        a_n+1=(a_n+b_n)/2, b_n+1=(a_n*b_n), c_n+1=(a_n-b_n)/2
'        ̂Ƃ
'        P Sȉ~ϕ  I(a_0,b_0)=[0`/2]{1/(a^2(cos())^2+b^2(sin())^2)}d
'                             
'                               M(a,b)=/2[0`/2]{1/(a^2(cos())^2+b^2(sin())^2)}d
'                               邢ͤ
'                               M(a,b)=/2[0`/2]{1/(((a+b)/2)^2(cos())^2+ab(sin())^2)}d
'                                       =/2[0`/2]{1/(((a+b)/2)^2(cos())^2-((a-b)/2)^2(sin())^2)}d
'                                       =/2[0`/2]{1/(((a+b)/2)((1-((a-b)/(a+b))^2((sin())^2)))}d
'                             
'                             I(a_0,b_0)=/2(1/M(a_0,b_0))
'        Q Sȉ~ϕ  J(a,b)=[0`/2]{(a^2(cos())^2+b^2(sin())^2)}d
'                                   =((a_0)^2-[n=0`]{(2^(n-1))(Cn)^2)})I(a_0,b_0)
'        ɁA
'          a_0=1
'          b_0=(1-k^2)=kc
'
'        ZɊ|鎞Ԃ́AiZp􉽕ς́jQȂ̂ő
'          Ailϕ⋉WJe͏Ȃj K ̒lɉe
'          (|K|Pɋ߂قǁAZɎԂ|)
'------------------------------------------------------------------------------
'    P: |K|<1
'        Q: |K|<=1,
'                ߂錅(Digit)ɏiۂ͖̌mFj
'                Zp􉽕ς̏vZ(Loop̌vZ)45(=30+15)ȉ
'                Pɂ͋߂錅̐͂܂
'------------------------------------------------------------------------------
'  Ql  xȍ֐gt[vZւ̓͗
'          URL:http://keisan.casio.jp/has10/Free.cgi
'          P sSȉ~ϕ: ellipticF(K)
'          Q sSȉ~ϕ: ellipticE(K)
'          K͐lɒuĂ
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv,
'              BICBit, DigitCheck,
'              DBIEq0, SetBigIntDigitCalculations, Wait,
'              BIIsBlargerA, BIIsAEqualB, BIKetaN,
'              BISqr, BIAGM, BIPi,
'              BIWarnningDialog, BI_debug1, BI_debug2
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    p̋߂錅(Digit)̏ 5000 xł
'        iZԂPxڈ by Pentium4 3.20 GHzj
'------------------------------------------------------------------------------
'  vZ  (Pentium4 3.20 GHz) [By Ver.1.94 BigInt_Demo(vZߒo:ON)]
'
'    P Sȉ~ϕ K(K)
'            ------------+--------------------------+---------------+---------------------------
'             ߂錅 |              K           |           | ܂
'                        |                          |               | Sȉ~ϕl
'            ------------+--------------------------+---------------+---------------------------
'                   10   | 0.555(    10)555 |      1b  | 1.718978667     ($:l)
'                   50   | 0.555(    50)555 |      1b  | 1.718978666559766123865023923890092290661257438677  ($:l)
'                  100   | 0.555(   100)555 |      1b x |   (ȗ)
'                 1000   | 0.555(  1000)555 |      8b x |   (ȗ)
'                10000   | 0.555( 10000)555 |  1 5b x |   (ȗ)
'                20000   | 0.111( 20000)111 |  320b x |   (ȗ)
'                  V    | 0.555(   V )555 |  355b x |   (ȗ)
'                  V    | 0.999(   V )999 |  610b x |   (ȗ)
'                50000   | 0.555( 50000)555 |   @v    |
'                  V    | 0.999(   V )999 |     v @ |
'               100000   | 0.999(100000)999 |     v @ |
'            ------------+--------------------------+---------------+---------------------------
'                                                                     $:xvZTCg t[vZ(http://keisan.casio.jp/has10/Free.cgi)ŊmF
'    Q Sȉ~ϕ E(K)
'            ------------+--------------------------+---------------+-------------+---------------------------
'             ߂錅 |              K           |           | LoopvZ| ܂
'                        |                          |               | (+1):LoopO | Sȉ~ϕl
'            ------------+--------------------------+---------------+-------------+---------------------------
'                   10   | 0.555(    10)555 |      1b  |   3(+1)     | 1.441486811     ($:l)
'                   V   | 0.999(    V)999 |      1b  |   6(+1)     | 1.000000001     ($:l)
'                   50   | 0.555(    50)555 |      1b x |   3(+1)     | 1.4414868112253661052939089024438818838484013593723  ($:l)
'                   V   | 0.999(    V)999 |      1b x |  10(+1)     | 1+6E-49         ($:1+1E-48)
'                  100   | 0.555(   100)555 |      2b x |   6(+1)     |   (ȗ)
'                   V   | 0.999(    V)999 |      2b x |  12(+1)     | 1+1.2E-98       (^Us)
'                 1000   | 0.555(  1000)555 |      9b x |   9(+1)     |   (ȗ)
'                  V    | 0.999(   V )999 |     15b x |  19(+1)     | 1+1.15E-997     (^Us)
'                10000   | 0.555( 10000)555 |  110b x |  12(+1)     |   (ȗ)
'                  V    | 0.999(   V )999 |  145b x |  25(+1)     | 1+1.151E-9996   (^Us)
'                20000   | 0.111( 20000)111 |  340b x |  12(+1)     |   (ȗ)
'                  V    | 0.555(   V )555 |  400b x |  12(+1)     |   (ȗ)
'                  V    | 0.999(   V )999 |  600b x |  27(+1)     | 1+2.303E-19996  (^Us)
'                50000   | 0.555( 50000)555 | 1030b x |  14(+1)     |   (ȗ)
'                  V    | 0.999(   V )999 | 1700b x |  30(+1)     | 1+5.756E-49996  (^Us)
'               100000   | 0.999(100000)999 | 3800b x |  32(+1)     | 1+1.1513E-99995 (^Us)
'            ------------+--------------------------+---------------+-------------+---------------------------
'                                                                                   $:xvZTCg t[vZ(http://keisan.casio.jp/has10/Free.cgi)ŊmF
'                                                                                     )50IĂ49Ȃ [2010/08/11mF]
'                                                                                                1 234567890123456789012345678901234567890123456789 
'                                                                                        1+1E-48=1.000000000000000000000000000000000000000000000001
'    |K|Pɋ߂قǁAilϕ⋉WJe͏ȂjZɎԂ|܂
'------------------------------------------------------------------------------
Dim KK       As BigIntType   'Copy
Dim CC       As BigIntType   'vZ̒l
Dim a        As BigIntType   'A>B Zp A_n+1=(A_n+B_n)*0.5
Dim B        As BigIntType   '    􉽕 B_n+1=(A_n*B_n)^0.5
Dim C        As BigIntType   '             C_n+1=(A_n-B_n)*0.5   <1/2FZpς̑>
Dim D        As BigIntType   '
Dim E        As BigIntType   '
Dim F        As BigIntType   '
Dim G        As BigIntType   '
Dim A2       As BigIntType   'A0*A0
Dim AB       As BigIntType   'A-B
Dim K2       As BigIntType   'K*K or |K|:`FbN
Dim Pi       As BigIntType   '
Dim X1       As BigIntType   '萔  1
Dim X2       As BigIntType   '      2
Dim X05      As BigIntType   '      0.5
Dim halfPi   As BigIntType   '/2
Dim M        As Long         'vZ
Dim dAB      As Long         'l
Dim Count    As Long         'JE^[
Dim LimtC    As Long         'vZ <Loop̌vZ>
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(K) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf T < 1& Or T > 2& Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        'Copy
        KK = K
        '萔
        X1 = BICBit(1)
        X2 = BICBit(2)
        X05 = BICBit(0.5)
        '
        K2 = KK                        'l
        K2.BigSgn = Chr$(43)           'K2=|K| <Chr(43):"+">
        If BIIsBlargerA(K2, X1) Then
        '|K|>1
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '߂錅̃`FbN
            If Not DigitCheck(Digit) Then Exit Function
            ']T
            dDigit = 5&
            'vZ
            M = SetBigIntDigitCalculations(Digit, dDigit)
            'K*K
            K2 = BigIntMul(KK, KK, M)
            '----------------------------------
            'Zp􉽕 l(#)
            a = X1
            B = BISqr(BigIntSub(X1, K2, M), M)
            '----------------------------------
            If T = 1& Then
            'P
                '
                If Not IsMissing(debug_) Then DebugTxt = "------------------------------------------------" & vbCr & _
                                                         "  P Sȉ~ϕ" & vbCr & _
                                                         "  Zp􉽕(AGM)ƊSȉ~ϕ̊֌W苁߂" & vbCr & _
                                                         "------------------------------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                '
                If BIEq0(B) Then
                '(K=1)
                    '
                    BigIntErrFLG = 5
                    Error BigIntErrFLG
                Else
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "Zp􉽕 M(1,(1-K^2)) vZEEE" & vbCr & _
                                   "-------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    '----------------------------------
                    'M(A,B) Zp􉽕
                    C = BIAGM(a, B, M, debug_, debug2_)
                    '----------------------------------
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "K(K)=(/2)/M(1,(1-K^2)) vZEEE" & vbCr & _
                                   "-------------------------------------" & vbCr & _
                                   "Zp􉽕 M(1,(1-K^2)) vZ" & vbCr & _
                                   "-------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    Pi = BIPi(M, False, 0&)          '
                    halfPi = BigIntMul(Pi, X05, M)   '/2
                    'I(A,B)=/2(1/M(A,B))
                    CC = BigIntDiv(halfPi, C, M)
                End If
            ElseIf T = 2& Then
            'Q
                '
                If Not IsMissing(debug_) Then DebugTxt = "------------------------------------------------" & vbCr & _
                                                         "  Q Sȉ~ϕ" & vbCr & _
                                                         "  Zp􉽕(AGM)ƊSȉ~ϕ̊֌W苁߂" & vbCr & _
                                                         "------------------------------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                '
                If BIEq0(B) Then
                ' (K=1)
                    CC = X1
                Else
                    If BIIsAEqualB(a, B) Then
                    '~ (K=0)
                        CC = BigIntMul(Pi, X05, M)
                    Else
                    'ȉ~ (|K|<1, K<>0)
                        '-----------------------------------------------
                        '[n=0`Count]{(2^(n-1))(Cn)^2)̌vẐ
                        'Zp􉽕(BIAGM)͎gpAڌvZ
                        '-----------------------------------------------
                        '
                        If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                                 " C : Do`Loop vZ" & vbCr & _
                                                                 " N : " & vbCr & _
                                                                 " S : iZp-􉽕ρj" & vbCr & _
                                                                 " T : vZ" & vbCr & _
                                                                 "---------------------------" & vbCr
                        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        dStepN = 1&       'o̓Xebv
                        Count = 0&        'JE^[
                        '**********************************************************************************************************************
                        'vZ
                        LimtC = 30& + 15&   'Do`LoopvZ (30+)
                                            '  Zp􉽕ς͂QȂ̂ŁAl̐xPȂ΁A
                                            '  2^31=2147483648(>2147483647:`̍ő包)30őlł邪A
                                            '  ۂ̏l(L#Q)̐x͗ǂȂ̂ŁA
                                            '  xPɂȂ܂łɐ̌vZKvƂ邱ƂlāA30Ɂ{
                                            '  iӁjEۂɂ́AvZ񐔈ȉő̃G[is*j\
                                            '          @̉񐔂܂ŌvẐ͑ςł
                                            '            i*:`̍ő包2147483647̐lPɕKvȃ́A2.14GBłj
                                            '----------------------------------------------------------------------------------------------
                                            '  {
                                            '    {Aȉ̗Ap̋߂錅̏iZԂ̖ڈPj10000AK=1-(1E-1000) 
                                            '    ]TƂď\NAłA15i>=1ȉ12jƂ30+15=45Ƃ
                                            '      E߂錅: 10000, K=1-(1E-10000)=0.999(10000)999    25+1i 1ȉ12+1j
                                            '      E߂錅: 20000, K=1-(1E-20000)=0.999(20000)999    27+1i 1ȉ13+1j
                                            '      E߂錅: 50000, K=1-(1E-50000)=0.999(50000)999    30+1i 1ȉ14+1j
                                            '      E߂錅:100000, K=1-(1E-100000)=0.999(100000)999  32+1i 1ȉ15+1j
                                            '                                                                       +1:LoopǑvZ
                                            '----------------------------------------------------------------------------------------------
                                            '  Ql  Zp􉽕ς̕KvvZ񐔁il̐xPƉj
                                            '                                                       iPentium4 3.20GHz [By Ver.1.94])
                                            '        -----------------------------------------------------------------------------------
                                            '          ߂錅  vZ  Q (2^n)         P̌vZԁi*:l,#lj
                                            '        -----------------------------------------------------------------------------------
                                            '                10         4    2^4 =        12        0.05 b *   <0.005  s/>
                                            '               100         7    2^7 =       128        0.15 b *   <0.0015 s/>
                                            '              1000        10    2^10=      1024        0.75 b *   <0.00075s/>
                                            '             10000        14    2^14=     16384        5    b *   <0.0005 s/>
                                            '            100000        17    2^17=    131072       50    b *   <0.0005 s/>
                                            '        2147483647        31    2^31=2147483648 (!)   12.43  #   (=5*2147483647/10000/(60*60*24))
                                            '                                                                     g[^Ԃ31*12.43/=385.33=1N20.33
                                            '                                     !:`͈̔͊O
                                            '----------------------------------------------------------------------------------------------
                        '**********************************************************************************************************************
                        A2 = BigIntMul(a, a, M)                                              '          A2 = A*A (=1*1)
                        'M(A,B) Zp􉽕
                        'n=0
                        G = BigIntMul(BigIntSub(A2, BigIntMul(B, B, M), M), X05, M)          '          g = (A*A-B*B)*0.5
                        'n=1
                        C = BigIntMul(BigIntAdd(a, B, M), X05, M)                            'Zp  C = (A+B)*0.5
                        D = BigIntMul(BigIntSub(a, B, M), X05, M)                            '          D = (A-B)*0.5
                        B = BISqr(BigIntMul(a, B, M), M)                                     '􉽕  B = (A*B)
                        a = C                                                                '          A = C
                        E = X1                                                               '          E = 1
                        F = BigIntMul(E, BigIntMul(D, D, M), M)                              '          f = E * D * D
                        G = BigIntAdd(G, F, M)                                               '          g = g + f
                        '
                        If Not IsMissing(debug_) Then
                            NowTime = Timer
                            DebugTxt = "C:" & CStr(Count) & _
                                       ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                            Call BI_debug1(debug_, DebugTxt, 0.000001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        'n>=2
                        Do
                            Count = Count + 1&                                               'JE^[
                            If Count > LimtC Then Error 51                                   'vZ񐔃`FbN
                            '------------------------------------------------------------
                            C = BigIntMul(BigIntAdd(a, B, M), X05, M)                        'Zp  C = (A+B)*0.5
                            AB = BigIntSub(a, B, M)                                          '          AB = A-B (A-B>=0)
                            D = BigIntMul(AB, X05, M)                                        '          D = (A-B)*0.5
                            B = BISqr(BigIntMul(a, B, M), M)                                 '􉽕  B = (A*B)
                            a = C                                                            '
                            '------------------------------------------------------------
                            '(a_0)^2-[n=0`Count]{(2^(n-1))(Cn)^2)}
                            E = BigIntMul(E, X2, M)                                          '          2^(n-1)
                            F = BigIntMul(E, BigIntMul(D, D, M), M)                          '          (2^(n-1))(Cn)^2)
                            G = BigIntAdd(G, F, M)                                           '          [n=0`Count]{(2^(n-1))(Cn)^2)
                            '------------------------------------------------------------
                            'l (Loop While)
                            dAB = (Len(B.BigInt) + B.BigExp) - (Len(AB.BigInt) + AB.BigExp)
                            '------------------------------------------------------------
                            If BIEq0(AB) Then
                            'B=C Zp􉽕(AGM)
                                '
                                If Not IsMissing(debug_) Then
                                    NowTime = Timer
                                    DebugTxt = "C:" & CStr(Count) & _
                                               ", N:" & CStr(M) & _
                                               ", S:" & BI2ExpN(AB, 3&) & _
                                               ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                                    OldTime = NowTime
                                End If
                                '
                                '
                                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                                '
                                Exit Do
                            End If
                            If Count Mod dStepN = 0& Then
                                '
                                If Not IsMissing(debug_) Then
                                    NowTime = Timer
                                    DebugTxt = "C:" & CStr(Count) & _
                                               ", N:" & CStr(dAB) & _
                                               ", S:" & BI2ExpN(AB, 3) & _
                                               ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr
                                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                                    OldTime = NowTime
                                End If
                                '
                                '
                                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                                '
                            End If
                            'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                            If IsMissing(debug_) And IsMissing(debug2_) Then Call Wait(0.0000001)   'DoEvents
                            '--- While  -------------------------------
                            'L̃`FbN (̃`FbN)
                            ' <L(M-1)ȏOKƂ>
                            '   vZ덷ɂAZpςƊ􉽕ςlɎȂP[XA
                            '   Ȃ킿AiṒjʂ̕sv̏ꍇɑΉ邽
                            '   vZ(M)͗]T(dDigit=5)܂ނ̂
                            '     ܂l(A,B,G)ɖ͂Ȃ
                            '    yz         M(vZ)
                            '      A(Zp): x.xxxxxxx1
                            '      B(􉽕): x.xxxxxxx2
                            '                   ^^^^^^^^^v(M-1)
                            '
                        Loop While dAB < M - 1&
                        '
                        If Not IsMissing(debug_) Then
                            NowTime = Timer
                            DebugTxt = "E(K)=((a_0)^2-[n=0`Count]{(2^(n-1))(Cn)^2)})K(K)" & vbCr & _
                                       "vZEEE" & vbCr & _
                                       "-------------------------------------" & vbCr & _
                                       "Do`Loop܂ [" & CStr(Count) & "]" & vbCr & _
                                       "-------------------------------------" & vbCr
                            Call BI_debug1(debug_, DebugTxt, 0.000001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        Pi = BIPi(M, False, 0&)          '
                        halfPi = BigIntMul(Pi, X05, M)   '/2
                        'J(a,b)=((a_0)^2-[n=0`Count]{(2^(n-1))(Cn)^2)})I'(a_n-1,b_n-1)
                        'ɁAI'(a_n-1,b_n-1)=(/2)/M(a_n-1,b_n-1)
                        a = BigIntDiv(halfPi, a, M)      'I'(a_n-1,b_n-1)=(/2)/M(a_n-1,b_n-1)
                        B = BigIntSub(A2, G, M)          '(a_0)^2-[n=0`Count]{(2^(n-1))(Cn)^2)}
                        CC = BigIntMul(B, a, M)          'J(a,b)
                    End If
                End If
            End If
            'EߒlZbg
            BICELbyAGM = BIKetaN(CC, CLng(Digit))
        End If
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BICELbyAGM")
End Function
' ȉ~ϕ (general elliptic integral)
Public Function BIGEL(X As BigIntType, K As BigIntType, T As Long, Optional Digit As Variant, _
                      Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  PEQ sSȉ~ϕ
'------------------------------------------------------------------------------
'  Ql  T "Numerical Recipes in C", Cambridge University Press
'                 : W.H.Press, B.P.Flannery, S.A.Teukolsky, W.T.Vetterling
'            M uNumerical Recipes in C [{] Cɂ鐔lvZ̃Vsv (10 13/11/01)
'                 : Oc s,  rY,  F,  
'                 ISBN: 4-87408-560-1
'                 URL: http://gihyo.jp/book/1993/4-87408-560-1
'                 [P.194-200]
'
'            Bulirsch, Roland, 1965, Numerische Mathematik, vol.7, p.78, 1965, op. cit vol.7,
'              p.353; 1969, op. cit, vol.13. p.305
'            Abramowitz, Milton, and Stegun, Irene A. 1964, Handbook of Mathematical Functions,
'              Applied Mathmatics Series, vol.55 (Washington: National Bureau of Standards;
'              reprinted 1968 by Dover Publications, New York), chapter 17.
'            Mathews, Jon, and walker, R.L. 1970, Mathematical Methods of Physics, 2nd ed.
'              (Reading, Mass.: W.A. Benjamin/Addison-Wesley), pp.78-79.
'------------------------------------------------------------------------------
'  Wolfram Mathematica Online Integrator
'    URL:http://integrals.wolfram.com/index.jsp
'      Q ȉ~ϕ (1-k^2(sin[x])^2)^(0.5)dx
'      URL:http://integrals.wolfram.com/index.jsp?expr=%281-k%5E2%28sin%5Bx%5D%29%5E2%29%5E%280.5%29&random=false
'------------------------------------------------------------------------------
'  ɖ𗧂xvZTCg
'    URL:http://keisan.casio.jp/
'      ȉ~ϕ - xvZTCg
'      URL:http://keisan.casio.jp/has10/Menu.cgi?path=08000000%2e%93%c1%8e%ea%8a%d6%90%94%2f07000700%2e%91%c8%89%7e%90%cf%95%aa
'------------------------------------------------------------------------------
'    X        [BigIntType]      
'                                     PFƂ͒PUq̊px
'                                     QFƂ͑ȉ~̓_~ɓepx
'                                       Ƃ pxipx̊:PQj
'                                       ȉ~̊px~ɓepxŁA
'                                       SŔaa̔aƓ~́A
'                                       Wƕsȕɓepx
'        K        [BigIntType]      ꐔ(modulus) ܂͗S
'                                     PFK͕ꐔ(modulus) [K=Sin(), :(characteristic)]
'                                     QFK͗S
'                                               K= {(a^2-b^2)/(a^2)} [a>=b]
'                                               K=-{(b^2-a^2)/(b^2)} [a<b]
'                                               
'                                                 ȉ~ (X^2/a^2)+(Y^2/b^2)=1
'                                                 ȉ~̒S_AђZWƂƂ
'                                                 a:w(>0)Ƒȉ~̌_̂wWl
'                                                 b:x(>0)Ƒȉ~̌_̂xWl
'                                                K ͑̓lŕ\Ƃ
'                                                 M=K^2   (M:p[^[)
'        T        [Long]            
'                                     P: 1
'                                     Q: 2
'        Digit    [Variant/Long]    iȗj߂錅 (ȗ pubN萔 DefaultDigit or DefaultDigit2)
'        debug_   [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_  [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_  [Variant/Object]  iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl@l   [BigIntType]      ϕli, ȉ~ʒj
'@@  @ُI [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    PEQ ̊eȉ~ϕ𓝈ꂵŕ\
'        ȉABulirsch ̋L@iASYj܂́AAbramowitz and Stegun ̂̂ŕ\
'
'        A(x),B(x),C(x),D(x)Cӂ̑AS(x)R܂͂S̑Ƃ΁A
'        ́Aɑȉ~ϕŕ\
'
'        {(A(x)+B(x)(S(x)))/(C(x)+D(x)(S(x)))}dx
'
'        ɁAȉ̊֌W
'          ysin()
'          xtan()
'          kc^21-k^2
'          kc=Cos()
'          kSin()
'
'        L̍lœôAȉ
'        ʑȉ~ϕ (general elliptic integral) ł
'        =============================================================================
'         GEL(p,kc,a,b)߁[0`]{(a+b*x^2)/((1+p*x^2)((1+x^2)(1+(kc^2)(x^2))))}dx
'        =============================================================================
'
'        ʑȉ~ϕeϕ͈ȉŕ\Ƃo
'
'        P Legendre ȉ~ϕ (Legendre elliptic integral of the 1st kind)
'        <P sSȉ~ϕ>
'          F(,k)F(Ӂ_)
'                 [0`]{1/((1-(kc^2)(sin())^2))}d
'                 [0`y]{1/((1-y^2)(1-(k^2)(y^2)))}dy
'                 [0`x]{1/((1+x^2)(1+(kc^2)(x^2)))}dx
'                 BIGEL(x,k,1,Digit)
'
'        P Sȉ~ϕ (complete elliptic integral of the 1st kind)
'          K(k)F(/2,k)
'              BICELbyAGM(k,1,Digit)
'              BIGEL(/2,k,1,Digit)
'
'        Q Legendre ȉ~ϕ (Legendre elliptic integral of the 2nd kind)
'        <Q sSȉ~ϕ>
'          E(,k)E(Ӂ_)
'                 [0`]{(1-(kc^2)(sin())^2)}d
'                 [0`y]{(1-(k^2)(y^2))/(1-y^2)}dy
'                 [0`x]{(1+(kc^2)(x^2))/((1+x^2)(1+x^2))}dx
'                 BICELbyAGM(x,k,2,Digit)
'
'        Q Sȉ~ϕ (complete elliptic integral of the 2nd kind)
'          E(k)E(/2,k)
'              BICELbyAGM(k,2,Digit)
'              BIGEL(/2,k,1,Digit)
'
'        R ȉ~ϕ (elliptic integral of the 3rd kind)
'          Ή
'
'        R Sȉ~ϕ (complete elliptic integral of the 3rd kind)
'          Ή
'
'
'        BIGEL     :̃W[̊֐   ȉ~ϕ
'        BICELbyAGM:        V             Sȉ~ϕ
'
'        ******************************************************
'        BIGEL( sSȉ~ϕ)BICELbyAGM( Sȉ~ϕ)̊֌W
'          P Sȉ~ϕ
'            K(k)F(/2,k)
'                BIGEL(/2,k,1,Digit)   < sSȉ~ϕ>
'                BICELbyAGM(k,1,Digit)   < Sȉ~ϕ>
'          Q Sȉ~ϕ
'            E(k)E(/2,k)
'                BIGEL(/2,k,2,Digit)   < sSȉ~ϕ>
'                BICELbyAGM(k,2,Digit)   < Sȉ~ϕ>
'        ******************************************************
'------------------------------------------------------------------------------
'    X<=/2, |K|<=1
'------------------------------------------------------------------------------
'  Ql  Ep̋߂錅(Digit)̏ 1000 xł
'          iZԂPxڈ by Pentium4 3.20 GHzj
'        Exȍ֐gt[vZւ̓͗
'            URL:http://keisan.casio.jp/has10/Free.cgi
'            P sSȉ~ϕ: ellipticF(sin(X),K)
'            Q sSȉ~ϕ: ellipticE(sin(X),K)
'            X,K͐lɒuĂ
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv, BIReciprocal,
'              BICBit, DigitCheck,
'              BIEq0, SetBigIntDigitCalculations, Wait,
'              BIIsBlargerA, BIIsBbelowA, BIIsAEqualB, BIKetaN,
'              BISqr, BIPi, BICosBS, BITanBS, BIAtnBS, BICELbyAGM,
'              BIWarnningDialog, BI_debug1, BI_debug2,
'              BI2ExpN(*),
'              *:vZߒo͕(BI_debug1)̂
'        萔
'        ϐ  BigIntErrFLG, DevelopFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    R sSȉ~ϕɂ͑ΉĂ܂
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim TT       As Long         'Copy
Dim KK       As BigIntType   '
Dim XX       As BigIntType   '
Dim CC       As BigIntType   'vZ̒l
Dim a        As BigIntType   '
Dim B        As BigIntType   '
Dim C        As BigIntType   '
Dim D        As BigIntType   '
Dim D2       As BigIntType   '1/D
Dim E        As BigIntType   '
Dim F        As BigIntType   '
Dim G        As BigIntType   '
Dim p        As BigIntType   '
Dim P2       As BigIntType   '1/p
Dim Y        As BigIntType   '
Dim z        As BigIntType   '
Dim CA       As BigIntType   'ڕWx(Epsilon)̕
Dim CB       As BigIntType   'ڕWx(Epsilon)0.01{
Dim em       As BigIntType   '
Dim kc       As BigIntType   '(1-K^2)
Dim K2       As BigIntType   'K*K or |K|:`FbN
Dim Pi       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X05      As BigIntType   '      0.5
Dim eye      As BigIntType   '
Dim kc2      As BigIntType   '(1-K^2)
Dim SqrE     As BigIntType   '(E)
Dim TanX     As BigIntType   'Tan(X)
Dim TMP1     As BigIntType   '
Dim TMP2     As BigIntType   '
Dim TMP3     As BigIntType   '
Dim halfPi   As BigIntType   '/2
Dim Epsilon  As BigIntType   'ڕWx <rl (CvV)>
Dim DFLGcrnt As Boolean      'DevelopFLGҔ
Dim L        As Long         '
Dim M        As Long         'vZ
Dim Count    As Long         'JE^[
Dim LimtC    As Long         'vZ <Loop̌vZ>  [BICELbyAGMƓlƂ/mȍ͂܂]
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim dDigit2  As Long         'VtgiƂ̈ʂƂ[Ƃ0.1]ɁAxi߂錅jɕKvȒǉ]Tj
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(X) Or BIIsError(K) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf Asc(X.BigSgn) = 45 Then   'X<0
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf T < 1& Or T > 2& Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        'Copy
        TT = T
        KK = K
        XX = X
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X05 = BICBit(0.5)
        '
        K2 = KK
        K2.BigSgn = Chr$(43)                      'K2=|K| <Chr(43):"+">
        If BIIsBlargerA(K2, X1) Then
        '|K|>1
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '߂錅̃`FbN
            If Not DigitCheck(Digit) Then Exit Function
            ']T
            dDigit = 5&
            'Vtg
            dDigit2 = -(Len(XX.BigInt) + XX.BigExp)
            If dDigit2 < 0& Then dDigit2 = 0&
            'vZ
            M = SetBigIntDigitCalculations(Digit, dDigit + dDigit2)
            '
            Pi = BIPi(M, False, 0&)              '
            halfPi = BigIntMul(Pi, X05, M)       '/2
            TMP1 = BIKetaN(halfPi, CLng(Digit))  '/2 ߂錅
            If BIIsBlargerA(XX, TMP1) Then
            'XX>/2
                'lɕϊ
                XX = BIMod(XX, halfPi)
            End If
            If BIIsAEqualB(XX, TMP1) Then
            'XX=/2
                If TT = 1& Then
                'P Sȉ~ϕ
                    CC = BICELbyAGM(KK, 1, M)
                ElseIf TT = 2& Then
                'Q Sȉ~ϕ
                    CC = BICELbyAGM(KK, 2, M)
                End If
            ElseIf BIEq0(XX) Then
                If TT = 1& Then
                'P ȉ~ϕ
                    CC = X0
                ElseIf TT = 2& Then
                'Q ȉ~ϕ
                    CC = X0
                End If
            Else
                '
                If Not IsMissing(debug3_) Then
                    NowTime = Timer
                    DebugTxt = "Tan Tan(X) ̌vZ" & _
                               " " & vbCr
                    Call BI_debug1(debug3_, DebugTxt, 0.00001)
                    OldTime = NowTime
                End If
                '
                '
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                '
                '--------------------------------
                'BIWarnningDialogXbLbv
                'X/2̂Ƃ BITanBS (1-Sin(XX)^2)=0 <Tan(XX)=> Łu0 ŏZ܂BvG[΍
                DFLGcrnt = DevelopFLG
                DevelopFLG = False
                TanX = BITanBS(XX, M, 2, debug3_, debug2_)
                DevelopFLG = DFLGcrnt
                '--------------------------------
                '
                If Not IsMissing(debug3_) Then
                    NowTime = Timer
                    DebugTxt = " " & vbCr & _
                               "Tan Tan(X) ̌vZ I" & _
                               " " & vbCr
                    Call BI_debug1(debug3_, DebugTxt, 0.00001)
                    OldTime = NowTime
                End If
                '
                '
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                '
                If BigIntErrFLG = 11 Then
                '0ŏZ܂
                    'XX=/2Ƃ݂Ȃ
                    If TT = 1& Then
                    'P Sȉ~ϕ
                        CC = BICELbyAGM(KK, 1, M)
                    ElseIf TT = 2& Then
                    'Q Sȉ~ϕ
                        CC = BICELbyAGM(KK, 2, M)
                    End If
                Else
                    If BIEq1(KK) Then
                    'KK=1
                        If TT = 2& Then
                        'Q ȉ~ϕ ()
                            '
                            If Not IsMissing(debug_) Then
                                NowTime = Timer
                                DebugTxt = "(K=1)ł" & vbCr
                                Call BI_debug1(debug_, DebugTxt, 0.000001)
                                OldTime = NowTime
                            End If
                            '
                            '
                            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                            '
                            '/2 - Atn(XX)
                            halfPi = BigIntMul(Pi, X05, M)
                            TMP1 = BIAtnBS(XX, M, True)          'True:ٓ_`FbN
                            TMP2 = BigIntSub(halfPi, TMP1, M)
                            CC = BICosBS(TMP2, M)
                        Else
                            BigIntErrFLG = 5
                            Error BigIntErrFLG
                        End If
                    ElseIf BIEq0(KK) Then
                    'KK=0
                        '
                        If Not IsMissing(debug_) Then
                            NowTime = Timer
                            If TT = 1& Then
                            'P ȉ~ϕ
                                DebugTxt = " " & vbCr & "(K=0) ł" & vbCr
                            ElseIf TT = 2& Then
                            'Q ȉ~ϕ (~)
                                DebugTxt = " " & vbCr & "~(K=0) ł" & vbCr
                            End If
                            Call BI_debug1(debug_, DebugTxt, 0.000001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        CC = XX
                    Else
                        '===============================
                        'ڕWx (CvV)
                        Epsilon = X1
                        Epsilon.BigExp = -M
                        '===============================
                        CA = BISqr(Epsilon, M, , True)
                        'CB=0.01*CA
                        CB = CA
                        CB.BigExp = CB.BigExp - 2&
                        '
                        K2 = BigIntMul(KK, KK, M)       'KK^2
                        kc2 = BigIntSub(X1, K2, M)      '  (1-KK*KK)=(kc)^2
                        kc = BISqr(kc2, M, , True)      '(1-KK*KK)=kc
                        a = X1                          'A = 1
                        '
                        If Not IsMissing(debug_) Then
                            NowTime = Timer
                            DebugTxt = "-------------------------------------" & vbCr & _
                                       "kc:" & BI2ExpN(kc, 8) & _
                                       ", CA:" & BI2ExpN(CA, 8) & _
                                       ", CB:" & BI2ExpN(CB, 8) & _
                                       " " & vbCr
                            Call BI_debug1(debug_, DebugTxt, 0.000001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        If TT = 1& Then
                        'P ȉ~ϕ
                            B = X1
                        ElseIf TT = 2& Then
                        'Q ȉ~ϕ
                            B = kc2
                        End If
                        C = BigIntMul(TanX, TanX, M)                        'C = TanX * TanX
                        D = BigIntAdd(X1, C, M)                             'D = 1# + C
                        D2 = BIReciprocal(D, M)                             '1/D
                        TMP1 = BigIntAdd(X1, BigIntMul(C, kc2, M), M)       'p = Sqr((1# + C * kc * kc) * (1/D))
                        TMP2 = BigIntMul(TMP1, D2, M)
                        p = BISqr(TMP2, M, , True)
                        P2 = BIReciprocal(p, M)                             '1/p
                        D = BigIntMul(TanX, D2, M)                          'D = TanX * (1/D)
                        C = BigIntDiv(D, BigIntAdd(p, p, M), M)             'C = D / (p + p)
                        eye = a                                             '
                        z = BigIntSub(eye, B, M)                            'z = eye - B
                        a = BigIntMul(X05, BigIntAdd(a, B, M), M)           'A = 0.5 * (A + B)
                        Y = BIReciprocal(TanX, M)                           'Y = Abs(1# / TanX)
                        Y.BigSgn = Chr$(43)                                  'Y=|Y| <Chr(43):"+">
                        F = X0                                              'f = 0
                        L = 0&                                              'L = 0
                        em = X1                                             'em = 1
                        dStepN = 1&                                         'o̓Xebv
                        Count = 0&                                          'JE^[
                        LimtC = 30& + 15&                                   'Do`LoopvZ (30+)
                        Do                                                  '----------------------------------
                            Count = Count + 1&                              'JE^[
                            If Count > LimtC Then Error 51                  'vZ񐔃`FbN
                            B = BigIntAdd(B, BigIntMul(eye, kc, M), M)      'B = B + (eye * kc)
                            E = BigIntMul(em, kc, M)                        'E = em * kc
                            G = BigIntMul(E, P2, M)                         'g = E * (1/p)
                            D = BigIntAdd(D, BigIntMul(F, G, M), M)         'D = D + (f * g)
                            F = C                                           'f = C
                            eye = a                                         'eye = A
                            p = BigIntAdd(p, G, M)                          'p = p + g
                            P2 = BIReciprocal(p, M)                         '1/p
                            TMP1 = BigIntMul(D, P2, M)                      'C = 0.5 * ((D * (1/p)) + C)
                            C = BigIntMul(X05, BigIntAdd(TMP1, C, M), M)    '
                            G = em                                          'g = em
                            em = BigIntAdd(em, kc, M)                       'em = em + kc
                            TMP1 = BigIntDiv(B, em, M)                      'A = 0.5 * ((B / em) + A)
                            a = BigIntMul(X05, BigIntAdd(TMP1, a, M), M)    '
                            Y = BigIntSub(Y, BigIntDiv(E, Y, M), M)         'Y = Y - (E / Y)
                            SqrE = BISqr(E, M, , True)                      'Sqr(E)
                            If BIEq0(Y) Then                                'if Y=0 then
                                Y = SqrE                                    'Y = Sqr(E) * CB
                                SqrE.BigExp = SqrE.BigExp + CB.BigExp       '  ̂ߏZłȂw [CB:1E-n(n:)]
                            End If                                          '
                            TMP1 = BigIntSub(G, kc, M)                      'Abs(g - kc)
                            TMP1.BigSgn = Chr$(43)                          'TMP1=|TMP1| <Chr(43):"+">
                            TMP2 = G                                        'CA * g
                            TMP2.BigExp = TMP2.BigExp + CA.BigExp           '  ̂ߏZłȂw [CA:1E-n(n:)]
                            If BIIsBbelowA(TMP1, TMP2) Then                 'If Abs(g - kc) <= CA * g Then
                            '
                                '
                                If Not IsMissing(debug_) Then
                                    TMP3 = BigIntSub(TMP1, TMP2, M)
                                    NowTime = Timer
                                    DebugTxt = "Do`Loop܂ [" & CStr(Count) & "]" & vbCr & _
                                               "-------------------------------------" & vbCr & _
                                               "C:" & CStr(Count) & _
                                               ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                               "  |g-kc|-CA*g:" & BI2ExpN(TMP3, 16) & _
                                               ", kc:" & BI2ExpN(kc, 8) & vbCr & _
                                               "  A:" & BI2ExpN(a, 3) & _
                                               ", B:" & BI2ExpN(B, 3) & _
                                               ", C:" & BI2ExpN(C, 3) & _
                                               ", D:" & BI2ExpN(D, 3) & _
                                               ", E:" & BI2ExpN(E, 3) & vbCr & _
                                               "  f:" & BI2ExpN(F, 3) & _
                                               ", g:" & BI2ExpN(G, 3) & _
                                               ", em:" & BI2ExpN(em, 3) & _
                                               ", eye:" & BI2ExpN(eye, 3) & vbCr
                                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                                    OldTime = NowTime
                                End If
                                '
                                '
                                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                                '
                                Exit Do                                     '
                            Else                                            '
                                kc = BigIntAdd(SqrE, SqrE, M)               'kc = Sqr(E) + Sqr(E)
                                L = L + L                                   'L = L + L (=2 * L)
                                If Asc(Y.BigSgn) = 45 Then                  'if Y<0 then
                                    L = L + 1&                              'L = L + 1
                                End If                                      '
                            End If                                          '
                            '
                            If Not IsMissing(debug_) Then
                                TMP3 = BigIntSub(TMP1, TMP2, M)
                                NowTime = Timer
                                DebugTxt = "C:" & CStr(Count) & _
                                           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                           "  |g-kc|-CA*g:" & BI2ExpN(TMP3, 16) & _
                                           ", kc:" & BI2ExpN(kc, 8) & vbCr & _
                                           "  A:" & BI2ExpN(a, 3) & _
                                           ", B:" & BI2ExpN(B, 3) & _
                                           ", C:" & BI2ExpN(C, 3) & _
                                           ", D:" & BI2ExpN(D, 3) & _
                                           ", E:" & BI2ExpN(E, 3) & vbCr & _
                                           "  f:" & BI2ExpN(F, 3) & _
                                           ", g:" & BI2ExpN(G, 3) & _
                                           ", em:" & BI2ExpN(em, 3) & _
                                           ", eye:" & BI2ExpN(eye, 3) & vbCr
                                Call BI_debug1(debug_, DebugTxt, 0.000001)
                                OldTime = NowTime
                            End If
                            '
                            '
                            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                            '
                            'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                            If IsMissing(debug_) And IsMissing(debug2_) Then Call Wait(0.0000001)     'DoEvents
                        Loop                                                '----------------------------------
                        If Asc(Y.BigSgn) = 45 Then                          'if Y<0 then
                            L = L + 1&                                      'L = L + 1
                        End If
                        TMP1 = BigIntDiv(em, Y, M)                          'E = (Atn(em / Y) + Pi * L) * A / em
                        '
                        If Not IsMissing(debug3_) Then
                            NowTime = Timer
                            DebugTxt = "Tan̋t֐ Atn(em/Y) ̌vZ" & _
                                       " " & vbCr
                            Call BI_debug1(debug3_, DebugTxt, 0.00001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        TMP1 = BIAtnBS(TMP1, M, True, debug3_, debug2_)
                        '
                        If Not IsMissing(debug3_) Then
                            NowTime = Timer
                            DebugTxt = " " & vbCr & _
                                       "Tan̋t֐ Atn(em/Y) ̌vZ I" & _
                                       " " & vbCr
                            Call BI_debug1(debug3_, DebugTxt, 0.00001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        TMP2 = BigIntMul(Pi, BICBit(L), M)
                        TMP3 = BigIntDiv(a, em, M)
                        E = BigIntMul(BigIntAdd(TMP1, TMP2, M), TMP3, M)
                        If Asc(TanX.BigSgn) = 45 Then                       'if TanX<0 then
                            Call BISgnChange(E)                             'E = -E
                        End If
                        CC = BigIntAdd(E, BigIntMul(C, z, M), M)            'CC = E + C * z
                    End If
                End If
            End If
            'EߒlZbg
            BIGEL = BIKetaN(CC, CLng(Digit))
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIGEL")
End Function
' P ȉ~ϕ̋t֐ [Rȓȉ~֐ U(amplitude) JacobiAmplitude [am(U,K)]]
Public Function BIam(u As BigIntType, K As BigIntType, Optional Digit As Variant, _
                     Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  P ȉ~ϕ̋t֐Jacobȋȉ~֐苁߂
'------------------------------------------------------------------------------
'    u        [BigIntType]      ԁiP sSȉ~ϕ̐ϕlj
'        K        [BigIntType]      ꐔ(modulus) (Mckc^2=1-K^2, K=Sin(), :(characteristic))
'        Digit    [Variant/Long]    iȗj߂錅 (ȗ pubN萔 DefaultDigit or DefaultDigit2)
'        debug_   [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_  [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_  [Variant/Object]  iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl@l   [BigIntType]      theta  pxiWAj
'@@  @ُI [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    Jacobȋȉ~֐ Asin(JacobiSN(U)) 苁߂
'------------------------------------------------------------------------------
'    |K|<=1, 0<=U(<=/2)
'------------------------------------------------------------------------------
'  Ql  p̋߂錅(Digit)̏ 2000 xł
'        iZԂPxڈ by Pentium4 3.20 GHzj
'------------------------------------------------------------------------------
'  ˑ  ֐  BIsncndn,
'              BIIsError, BICBit, DigitCheck, SetBigIntDigitCalculations,
'              BIIsBOrMore, BIKetaN,
'              BIWarnningDialog, BI_debug1, BI_debug2
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim UU       As BigIntType   'Copy
Dim KK       As BigIntType   '
Dim CC       As BigIntType   'vZ̒l
Dim X        As BigIntType   'l
Dim SN       As BigIntType   'Jacobȋȉ~֐ ߂l
Dim CN       As BigIntType   '
Dim DN       As BigIntType   '
Dim X1       As BigIntType   '萔  1
Dim emc      As BigIntType   'Mckc^2=1-K^2
Dim M        As Long         'vZ
Dim dDigit   As Long         ']T
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(u) Or BIIsError(K) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf Asc(u.BigSgn) = 45 Then   'U<0
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        'Copy
        UU = u
        KK = K
        '萔
        X1 = BICBit(1)
        '߂錅̃`FbN
        If Not DigitCheck(Digit) Then Exit Function
        ']T
        dDigit = 1&
        'vZ
        M = SetBigIntDigitCalculations(Digit, dDigit)
        'Mckc^2=1-K^2
        emc = BigIntSub(X1, BigIntMul(K, K, M), M)
        If BIIsBOrMore(emc, X1) Then
        'emc>=1
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "|1-K^2|=|Mc|>=1 ł" & vbCr & _
                           " ivZł܂j" & vbCr & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "------------------------------------" & vbCr & _
                           "Jacobȋȉ~֐(sn) 苁߂܂" & vbCr & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            CC = BIsncndn(UU, KK, M, SN, CN, DN, 0, debug3_, debug2_)
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "ASin(sn)vZ܂" & vbCr & _
                           "------------------------------------" & vbCr & _
                           " " & vbCr & _
                           "Jacobȋȉ~֐(sn) vZI" & vbCr & _
                           "------------------------------------" & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            CC = BIASinBS(CC, M, , debug3_, debug2_)
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "ASin(sn) vZI" & vbCr & _
                           "------------------------------------" & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            'E߂l̐ݒ
            BIam = BIKetaN(CC, CLng(Digit))
        End If
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIam")
End Function
'Q ȉ~ϕ̋t֐ <j[g@>
Public Function BIinvEL(S As BigIntType, K As BigIntType, Optional Digit As Variant, _
                        Optional ELType As Long = 0, Optional FLG As Boolean = False, _
                        Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  Q ȉ~ϕ̋t֐j[g@苁߂
'------------------------------------------------------------------------------
'    S        [BigIntType]      Q ȉ~ϕ̒liȉ~ʒj
'        K        [BigIntType]      S
'                                     K= {(a^2-b^2)/(a^2)} [a>=b]
'                                     K=-{(b^2-a^2)/(b^2)} [a<b]
'                                       
'                                         ȉ~ (X^2/a^2)+(Y^2/b^2)=1
'                                         ȉ~̒S_AђZWƂƂ
'                                           a:w(>0)Ƒȉ~̌_̂wWl
'                                           b:x(>0)Ƒȉ~̌_̂xWl
'                                         K ͑̓lŕ\Ƃ
'                                          M=K^2   (M:p[^[)
'        Digit    [Variant/Long]    iȗj߂錅 (ȗ pubN萔 DefaultDigit or DefaultDigit2)
'        ELType   [Long]            iȗjQ sSȉ~ϕ̒l߂֐
'                                               0: (łZ@)I (BIGEL)
'                                               1: BIGEL
'        FLG      [Boolean]         iȗjS̒leliSȉ~ϒljȏ̏ꍇ̏
'                                              True:  őliSȉ~ϒljƂ݂ȂivZ덷΍j
'                                              False: G[Ƃ
'        debug_   [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_  [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_  [Variant/Object]  iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl@l   [BigIntType]      theta  pxiWA, px̊:PQj
'                                     bȉ~̊px~ɓepxŁA
'                                     bSŔaa̔aƓ~́A
'                                     bWƕsȕɓepx
'@@  @ُI [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    j[g@ɂċ߂
'------------------------------------------------------------------------------
'    |K|<=1, 0<=S(<=/2)
'------------------------------------------------------------------------------
'  Ql  p̋߂錅(Digit)̏ 200 xł
'        iZԂPxڈ by Pentium4 3.20 GHzj
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv,
'              BICBit, DigitCheck,
'              BIEq0, SetBigIntDigitCalculations,
'              BISgnChange, BIIsBlargerA, BIIsBsmallerA, BIKetaN,
'              BISqr, BIPi, BISin, BIAtnBS, BICELbyAGM, BIEL,
'              ELbyGaussLegendreIntegration, ELbySinpson, ELbySeriesExpansion,
'              BIWarnningDialog, BI_debug2
'        萔
'        ϐ  BigIntErrFLG, ErrorCheckSkipFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    E S /2ȏ̖߂ĺA FLG ̐ݒɂ܂
'        E K Pɋ߂ƌ덷傫Ȃ܂
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim T        As Long         'Copy
Dim KK       As BigIntType   '
Dim SS       As BigIntType   '
Dim CC       As BigIntType   'vZ̒l
Dim E        As BigIntType   'f(x)=E(x): Q sSȉ~ϕ̒l
Dim X        As BigIntType   'l
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X05      As BigIntType   '      0.5
Dim dX       As BigIntType   'l
Dim E2       As BigIntType   'f'(x)=(1-K^2 (Sin(x))^2): Q sSȉ~ϕ̓֐̒liX/ȉ~ϕ̔ϕ֐j
Dim K2       As BigIntType   'K^2
Dim Pi       As BigIntType   '
Dim SinX     As BigIntType   'Sin(X)
Dim TMP1     As BigIntType   '
Dim TMP2     As BigIntType   '
Dim TMP3     As BigIntType   '
Dim Xold     As BigIntType   'Ỏl
Dim halfPi   As BigIntType   '/2 [90x]
Dim Epsilon  As BigIntType   'rl
Dim XFLG     As Boolean      '
Dim XFLG2    As Boolean      '
Dim M        As Long         'vZ
Dim dXX      As Long         'l
Dim Count    As Long         'JE^[
Dim LimtC    As Long         'vZ
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim dXXold   As Long         'O̎l
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(S) Or BIIsError(K) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf Asc(X.BigSgn) = 45 Then   'X<0
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf ELType < 0& Or ELType > 1& Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        'Copy
        SS = S
        KK = K
        T = ELType
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X05 = BICBit(0.5)
        '߂錅̃`FbN
        If Not DigitCheck(Digit) Then Exit Function
        ']T
        dDigit = 3&
        'vZ
        M = SetBigIntDigitCalculations(Digit, dDigit)
        '
        Pi = BIPi(M, False, 0&)          '
        halfPi = BigIntMul(Pi, X05, M)   '/2
        '
        K2 = KK
        K2.BigSgn = Chr$(43)              'K2=|K| <Chr(43):"+">
        If BIIsBlargerA(K2, X1) Then
        '|K|>1
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '===============================
            'ڕWx (CvV)
            Epsilon = X1
            Epsilon.BigExp = -M
            '===============================
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "(X)Q Sȉ~ϕE(K)ƔrEEE" & vbCr & _
                           "------------------------------------------------" & vbCr & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            'SƑQ Sȉ~ϕE(K)̔r
            E = BICELbyAGM(KK, 2, Digit, debug3_, debug2_)
            If BIIsBlargerA(SS, E) Then
            'SS>E
                TMP1 = BigIntSub(BigIntMul(SS, E, M), Epsilon, M)
                If BIIsBsmallerA(TMP1, X0) Or FLG Then
                'TMP1<0, CvVȉ or Sȉ~ϒlƂ݂ȂtO
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "(X) > E(K) łi(X)-E(K)0 <vZ덷>j" & vbCr & _
                                   "(X) = E(K) ƌȂ܂" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    CC = halfPi
                Else
                '~ʒ(X)S1/4ȏ゠
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "G[ [(X) > E(K)] ł" & vbCr & _
                                   "  ~ʒ(X)1/4ȉ~ʒȏ゠܂" & vbCr & _
                                   "  (X)́AE(K)Őݒ肵Ă" & vbCr & _
                                   "  E(K) " & BI2ExpN(E, 15) & vbCr & _
                                   "------------------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    BigIntErrFLG = 5
                    Error BigIntErrFLG
                End If
            Else
                If BIEq0(KK) Then
                'K=0 (~)
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "~(K=0)ł" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    CC = SS
                ElseIf BIEq1(KK) Then
                'K=1 ()
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "(K=1)ł" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    'CC = Acos(SS) = Atn(-SS / Sqr(1# - SS * SS)) + halfPi
                    TMP1 = BigIntSub(X1, BigIntMul(SS, SS, M), M)
                    TMP2 = BISqr(TMP1, M, , True)
                    TMP3 = BigIntDiv(SS, TMP2, M)
                    Call BISgnChange(TMP3)
                    TMP1 = BIAtnBS(TMP3, M, True, debug3_, debug2_)
                    CC = BigIntAdd(TMP1, halfPi, M)
                Else
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "------------------------------------------------" & vbCr & _
                                   "Q ȉ~ϕ̋t֐j[g@苁߂܂" & vbCr & _
                                   "------------------------------------------------" & vbCr & _
                                   " " & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                             " C : Do`Loop vZ" & vbCr & _
                                                             " T : vZ" & vbCr & _
                                                             " N : " & vbCr & _
                                                             " X : vZ̒l (j[g@)" & vbCr & _
                                                             " E : E(X_old)-X_0" & vbCr & _
                                                             "       E(X_old): Q Sȉ~ϕ" & vbCr & _
                                                             "       X_old   : OX" & vbCr & _
                                                             "       X_0     : (X)" & vbCr & _
                                                             " dx : i|X-X_old|j" & vbCr & _
                                                             "---------------------------" & vbCr
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    XFLG = False
                    XFLG2 = False
                    Count = 0&
                    LimtC = 1000&
                    K2 = BigIntMul(KK, KK, M)   'KK^2
                    'j[g@ (_ȉ͓Y)
                    'x_n+1=x_n-f(x_n)/f'(x_n)
                    '  ɁA
                    '    f(x_n)=BICELbyAGM(KK, 2, Digit)-S   'Q Sȉ~ϕ - S
                    '    f'(x_n)=(1-K^2 (Sin(x_n))^2)      'ȉ~ϕ̔ϕ֐
                    '----------------------------------------------
                    'l
                    'Q Sȉ~ϕE(K) TZl(T)
                    E = BIKetaN(E, 5&)
                    'Pl:X=E*(S/(/2))
                    TMP1 = BigIntDiv(BIKetaN(SS, 5&), E, 5&)
                    X = BigIntMul(BICBit(1.5707), TMP1, 5&)
                    '----------------------------------------------
                    ErrorCheckSkipFLG = True
                    Do
                        Count = Count + 1&
                        If Count > LimtC Then Error 51   '~b^[
                        Xold = X
                        dXXold = dXX
                        '-----------------------------------------------
                        'E=f(x_n)=E(x_n,K)-S
                        Select Case T
                            'E=E(x_n,K)
                            ' ȉ~ϕiQ sSȉ~ϕj
                            Case 0, 1: E = BIEL(X, KK, CLng(Digit))
                        End Select
                        E = BigIntSub(E, SS, M)
                        '-----------------------------------------------
                        'E2=f'(x_n)
                        'TMP1 = BISinBS(X, M, 2)
                        'SxȂ灪(BISinBS)聫(BISin)̕
                        TMP1 = BISin(X, M, , 2, debug3_, debug2_)
                        SinX = BigIntMul(TMP1, TMP1, M)
                        TMP2 = BigIntSub(X1, BigIntMul(K2, SinX, M), M)
                        E2 = BISqr(TMP2, M, , True, 0, , debug3_, debug2_)
                        '-----------------------------------------------
                        'X=x_n+1=x_n-f(x_n)/f'(x_n)
                        X = BigIntSub(Xold, BigIntDiv(E, E2, M), M)
                        '-----------------------------------------------
                        'vZ덷΍ilĐݒ肵ăgCj
                        If Asc(X.BigSgn) = 45 Then   'X<0
                            If XFLG Then
                            'QERxڂ̃G[
                                If XFLG2 Then
                                'Rxڂ̃G[
                                    BigIntErrFLG = 51
                                    Error BigIntErrFLG
                                Else
                                'Qxڂ̃G[
                                    'lāXݒ(1E-M)
                                    'i0Ǝl0ŏZG[ɂȂ̂ŏo邾lƂj
                                    X = X1
                                    X.BigExp = -M
                                    XFLG2 = True
                                End If
                            Else
                            'Pxڂ̃G[
                                'l(/4){xōĐݒ
                                X = BICBit(0.785398163397448)
                                XFLG = True
                            End If
                        End If
                        '`FbN
                        dX = BigIntSub(X, Xold, M)
                        dX.BigSgn = Chr$(43)   'dX=|dX| <Chr(43):"+">
                        dXX = (Len(X.BigInt) + X.BigExp) - (Len(dX.BigInt) + dX.BigExp)
                        If BIEq0(dX) Then
                        '
                            '
                            If Not IsMissing(debug_) Then
                                TMP3 = BigIntSub(TMP1, TMP2, M)
                                NowTime = Timer
                                DebugTxt = "C:" & CStr(Count) & _
                                           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                           "  N:" & CStr(Digit) & _
                                           ", X:" & BI2ExpN(X, 6) & _
                                           ", E:" & BI2ExpN(E, 4) & _
                                           ", dx:" & BI2ExpN(dX, 4) & vbCr
                                Call BI_debug1(debug_, DebugTxt, 0.000001)
                                OldTime = NowTime
                            End If
                            '
                            Exit Do
                        Else
                            '
                            If Not IsMissing(debug_) Then
                                TMP3 = BigIntSub(TMP1, TMP2, M)
                                NowTime = Timer
                                DebugTxt = "C:" & CStr(Count) & _
                                           ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                           "  N:" & CStr(dXX) & _
                                           ", X:" & BI2ExpN(X, 6) & _
                                           ", E:" & BI2ExpN(E, 4) & _
                                           ", dx:" & BI2ExpN(dX, 4) & vbCr
                                Call BI_debug1(debug_, DebugTxt, 0.000001)
                                OldTime = NowTime
                            End If
                            '
                            If Count > 4& Then
                                If dXXold >= dXX Then
                                'vZ덷iUorl[dx]萔lɎj΍
                                    'O̒l̗p
                                    X = Xold
                                    Exit Do
                                End If
                            End If
                        End If
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                        If IsMissing(debug_) And IsMissing(debug2_) Then Call Wait(0.0000001)     'DoEvents
                    Loop While dXX < M
                    ErrorCheckSkipFLG = False
                    '
                    If Not IsMissing(debug_) Then
                        TMP3 = BigIntSub(TMP1, TMP2, M)
                        NowTime = Timer
                        DebugTxt = "Do`Loop܂ [" & CStr(Count) & "]" & vbCr & _
                                   "-------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    CC = X
                End If
            End If
            'EߒlZbg
            BIinvEL = BIKetaN(CC, CLng(Digit))
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIinvEL")
    ErrorCheckSkipFLG = False
End Function
'Jacobȋȉ~֐ (Jacobian ellictic function)
Public Function BIsncndn(u As BigIntType, K As BigIntType, Digit As Long, _
                         SN As BigIntType, CN As BigIntType, DN As BigIntType, Optional Returnvalue As Long = 0, _
                         Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  P ȉ~ϕ F(,k) ̋t֐ [sn,cn,dn]
'------------------------------------------------------------------------------
'  Ql  T "Numerical Recipes in C", Cambridge University Press
'                 : W.H.Press, B.P.Flannery, S.A.Teukolsky, W.T.Vetterling
'            M uNumerical Recipes in C [{] Cɂ鐔lvZ̃Vsv (10 13/11/01)
'                 : Oc s,  rY,  F,  
'                 ISBN: 4-87408-560-1
'                 URL: http://gihyo.jp/book/1993/4-87408-560-1
'                 [P.194-200]
'
'            Bulirsch, Roland, 1965, Numerische Mathematik, vol.7, p.78, 1965, op. cit vol.7,
'              p.353; 1969, op. cit, vol.13. p.305
'            Abramowitz, Milton, and Stegun, Irene A. 1964, Handbook of Mathematical Functions,
'              Applied Mathmatics Series, vol.55 (Washington: National Bureau of Standards;
'              reprinted 1968 by Dover Publications, New York), chapter 17.
'            Mathews, Jon, and walker, R.L. 1970, Mathematical Methods of Physics, 2nd ed.
'              (Reading, Mass.: W.A. Benjamin/Addison-Wesley), pp.78-79.
'------------------------------------------------------------------------------
'    u           [BigIntType]      ԁiP sSȉ~ϕ̐ϕlj
'        K           [BigIntType]      Mckc^2=1-K^2 (K:ꐔ(modulus), K=Sin(), :(characteristic))
'        Digit       [Long]            ߂錅
'        sn          [BigIntType]      i߂ljsin()
'        cn          [BigIntType]      i߂ljcos()
'        dn          [BigIntType]      i߂ljtan()
'        Returnvalue [Long]            iȗj߂l̐ݒ
'                                            0:sn (=sin()) (ȗ)
'                                        1:sn (=sin())
'                                        2:cn (=cos())
'                                        3:dn (=tan())
'                                        ɁAƁFPUq̊px
'        debug_      [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_     [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_     [Variant/Object]  iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl@l      [BigIntType]      ֐̒l(sn, cn, dn ̂ǂꂩ)
'@@  @ُI    [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    E߂l̊֌W
'          Mckc^21-K^2 (K:ꐔ(modulus), K=Sin(), :(characteristic))
'          sn^2{cn^21
'          (k^2)(sn^2){dn^21
'
'        P sSȉ~ϕ
'          uF(x,k)[0`x]{1/((1-t^2)(1-(k^2)(t^2)))}dt
'                   [0`]{((1-(k^2)(sin()^2)))}d
'        Ƃ
'          sn(u)sn(u,k)F-1(u,k)xsin()  <F-1F̋t֐>
'          cn(u)(1-sn(u)^2)cos()
'          dn(u) (1-(k^2)(sn(u)^2))(1-(k^2)(sin()^2))
'          ns(u)1/sn(u)cosec()
'          nc(u)1/cn(u)sec()
'          nd(u)1/dn(u)
'          sc(u)sn(u)/cn(u)tan()
'          cs(u)cn(u)/sn(u)cot()
'          sd(u)sn(u)/dn(u)
'          ds(u)dn(u)/sn(u)
'          cd(u)cn(u)/dn(u)
'          dc(u)dn(u)/cn(u)
'------------------------------------------------------------------------------
'    0<=|emmc|<1
'------------------------------------------------------------------------------
'  Ql  Ek(ꐔ)0<|k|<1Ƃ̂ʂł邪AɌl
'          k=0(emmc=1)ƂƎOp֐A
'          k=1(emmc=0)ƂƑoȐ֐
'        Ep̋߂錅(Digit)̏ 2000 xł
'          iZԂPxڈ by Pentium4 3.20 GHzj
'------------------------------------------------------------------------------
'  ˑ  ֐  BIIsError, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv, BIReciprocal,
'              BICBit, DigitCheck,
'              BIEq0, SetBigIntDigitCalculations, Wait,
'              BISgnChange, BIIsAEqualB, BIIsBbelowA, BIIsBOrMore, BIKetaN,
'              BISqr, BISinBS, BICosBS, BIExp,
'              BIWarnningDialog, BI_debug1, BI_debug2
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim UU       As BigIntType   'Copy
Dim KK       As BigIntType   '
Dim a        As BigIntType   '
Dim B        As BigIntType   '
Dim C        As BigIntType   '
Dim D        As BigIntType   '
Dim E        As BigIntType   '
Dim F        As BigIntType   '
Dim G        As BigIntType   '
Dim CA       As BigIntType   'ڕWx(Epsilon)̕
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X2       As BigIntType   '      2
Dim X05      As BigIntType   '      0.5
Dim emc      As BigIntType   'Mckc^2=1-K^2
Dim em()     As BigIntType   '
Dim en()     As BigIntType   '
Dim TMP      As BigIntType   '
Dim Gold     As BigIntType   '
Dim Epsilon  As BigIntType   'ڕWx <rl (CvV)>
Dim bo       As Boolean      '
Dim I        As Long         '
Dim L        As Long         '
Dim M        As Long         'vZ
Dim dM       As Long         'vZ
Dim Count    As Long         'JE^[
Dim LimtC    As Long         'vZ <Loop̌vZ>  [BICELbyAGMƓlƂ/mȍ͂܂]
Dim dDigit   As Long         ']T
Dim dDigit2  As Long         'Vtg
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(u) Or BIIsError(K) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf Returnvalue < 0& Or Returnvalue > 3& Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        'Copy
        UU = u
        KK = K
        '߂錅̃`FbN
        If Not DigitCheck(Digit) Then Exit Function
        ']T
        dDigit = 3&
        'Vtg
        dDigit2 = Abs(Len(UU.BigInt) + UU.BigExp)
        If dDigit2 < 0& Then dDigit2 = 0&
        'vZ
        M = SetBigIntDigitCalculations(Digit, dDigit + dDigit2)
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X2 = BICBit(2)
        X05 = BICBit(0.5)
        'Mckc^2=1-K^2
        emc = BigIntSub(X1, BigIntMul(KK, KK, M), M)
        '
        If BIIsBOrMore(emc, X1) Then
        'emc>=1
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "|Mc|>=1 ł" & vbCr & _
                           " Jacobȋȉ~֐ł͑ΏۊOłivZł܂j" & vbCr & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '
            If Not IsMissing(debug3_) Then
                NowTime = Timer
                DebugTxt = "Jacobȋȉ~֐ ̌vZJn" & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.00001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            '===============================
            'ڕWx (CvV)
            Epsilon = X1
            Epsilon.BigExp = -M
            '===============================
            CA = BISqr(Epsilon, M, , True, , , debug3_, debug2_)
            '
            Count = 0&                                               'JE^[
            LimtC = 30& + 15&                                        'Do`LoopvZ (30+)
            ReDim em(0 To LimtC)                                     'm
            ReDim en(0 To LimtC)                                     '
            '
            If Not IsMissing(debug_) Then
                NowTime = Timer
                DebugTxt = "-------------------------------------" & vbCr & _
                           "M(vZ): " & CStr(M) & vbCr & _
                           "K:" & BI2ExpN(KK, 8) & _
                           ", Mc:" & BI2ExpN(emc, 8) & _
                           ", CA:" & BI2ExpN(CA, 8) & _
                           " " & vbCr
                Call BI_debug1(debug_, DebugTxt, 0.000001)
                OldTime = NowTime
            End If
            '
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            If Not BIEq0(emc) Then                                      'emc<>0
'ČvZŏꍇ(***)
'RTY:
                If Asc(emc.BigSgn) = 45 Then                            '(emc<0)
                    bo = True                                           '    bo = True
                    D = BigIntSub(X1, emc, M)                           '    D = 1# - emc
                    emc = BigIntMul(emc, D, M)                          '    emc = emc / (-1# / D)
                    Call BISgnChange(emc)                               '
                    D = BISqr(D, M, , True, , , debug3_, debug2_)       '    D = Sqr(D)
                    UU = BigIntMul(UU, D, M)                            '    uu = uu * D
                Else                                                    '
                    bo = False                                          '    bo = False
                End If                                                  '
                '
                If Not IsMissing(debug_) Then
                    NowTime = Timer
                    DebugTxt = "-------------------------------------" & vbCr & _
                               "0<|Mc|<1 ł" & vbCr & _
                               " ʂJacobȋȉ~֐vZ܂" & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                '
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                '
                L = 0&
                a = X1                                                  'A = 1
                G = X1                                                  'G = 1
                DN = X1                                                 'dn = 1
                Do                                                      '----------------------------------
                    Count = Count + 1&                                  'JE^[
                    If Count > LimtC Then Error 51                      'vZ񐔃`FbN
                    L = L + 1&                                          '    L = L + 1
                    Gold = G                                            '
                    em(L) = a                                           '    em(I) = A
                    emc = BISqr(emc, M, , True, , , debug3_, debug2_)   '    emc = Sqr(emc)
                    en(L) = emc                                         '    en(I) = emc
                    C = BigIntMul(X05, BigIntAdd(a, emc, M), M)         '    C = 0.5 * (A + emc)
                    E = BigIntSub(a, emc, M)                            '    E = Abs(A - emc)
                    E.BigSgn = Chr$(43)                                 '        E=|E| <Chr(43):"+">
                    F = a                                               '    F = CA * A
                    F.BigExp = F.BigExp + CA.BigExp                     '        <̂ߏZłȂw/CA:1E-n(n:)>
                    G = BigIntSub(E, F, M)                              '    G = E - F
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "C:" & CStr(Count) & _
                                   ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                   "  |A-emc|-CA*g:" & BI2ExpN(G, 32) & vbCr & _
                                   "  E:" & BI2ExpN(E, 16) & _
                                   ", F:" & BI2ExpN(F, 16) & vbCr & _
                                   "  A:" & BI2ExpN(a, 16) & _
                                   ", emc:" & BI2ExpN(emc, 16) & vbCr & _
                                   "  C:" & BI2ExpN(C, 16) & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    If BIIsBbelowA(G, X0) Then                          '    If Abs(A - emc) - (CA * A) <= 0  Then
                          '
                          If Not IsMissing(debug_) Then
                              NowTime = Timer
                              DebugTxt = "Do`Loop܂ [" & CStr(Count) & "]" & vbCr & _
                                         " (|A-emc|-CA*g<0 ƂȂ܂)" & vbCr & _
                                         "-------------------------------------" & vbCr
                              Call BI_debug1(debug_, DebugTxt, 0.000001)
                              OldTime = NowTime
                          End If
                          '
                          '
                          If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                          '
                        Exit Do                                         '        Exit Do
                    ElseIf BIIsAEqualB(Gold, G) Then                    '    elseif Gold=G then
                          dM = CLng(M / 100&)
                          If dM < dDigit Then dM = dDigit
                          '
                          If Not IsMissing(debug_) Then
                              NowTime = Timer
                              DebugTxt = "******************************************************" & vbCr & _
                                         "|A-emc|-CA*g{ŎAlɂȂ܂ [" & CStr(Count) & "]" & vbCr & _
                                         " vZ(M:" & CStr(M) & ")  " & CStr(dM) & " ₵ČvZs܂" & vbCr & _
                                         "******************************************************" & vbCr
                              Call BI_debug1(debug_, DebugTxt, 0.000001)
                              OldTime = NowTime
                          End If
                          '
                          '
                          If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                          '
                          M = M + dM   '*1
                          '------------------------------------------------------------
                          'ČvZŏꍇ(***)
                          'iJ̌vZŁAvZɁ{(*1)ΑΉ\Ɣf^RXg()邪AČvZȂj
                          'emc = BigIntSub(X1, BigIntMul(K, K, M), M) 'Mckc^2=1-K^2
                          'Count = 0&                                 'JE^[Zbg
                          'GoTo RTY:
                          '------------------------------------------------------------
                    End If                                              '    End If
                    emc = BigIntMul(emc, a, M)                          '    emc = emc * A
                    a = C                                               '    A = C
                    'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                    If IsMissing(debug_) And IsMissing(debug2_) Then Call Wait(0.0000001)     'DoEvents
                Loop                                                 '----------------------------------
                '
                If Not IsMissing(debug_) Then
                    NowTime = Timer
                    DebugTxt = "For`Next OEEE" & vbCr & _
                               " " & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                UU = BigIntMul(UU, C, M)                                'uu = uu * C
                '
                If Not IsMissing(debug3_) Then
                    NowTime = Timer
                    DebugTxt = "Sin(X)vZ܂" & vbCr & _
                               "------------------------------------" & vbCr & _
                               " " & vbCr & _
                               "For`Next vZI" & vbCr & _
                               "------------------------------------" & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                'SN = BISin(uu, M, , 2, debug3_, debug2_)                 '<SxȂ(BISinBS)(BISin)̕>
                SN = BISinBS(UU, M, , debug3_, debug2_)                 'sn = Sin(uu)
                '
                If Not IsMissing(debug3_) Then
                    NowTime = Timer
                    DebugTxt = "Cos(X)vZ܂" & vbCr & _
                               "------------------------------------" & vbCr & _
                               "Sin(X) vZI" & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                'cn = BICos(uu, M, , 2, debug3_, debug2_)                '<SxȂ(BICosBS)(BICos)̕>
                CN = BICosBS(UU, M, , debug3_, debug2_)                 'cn = Cos(uu)
                '
                If Not IsMissing(debug3_) Then
                    NowTime = Timer
                    DebugTxt = "------------------------------------" & vbCr & _
                               "Cos(X) vZI" & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                If Not BIEq0(SN) Then                                   'If sn <> 0 Then
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "-------------------------------------" & vbCr & _
                                   "For`Next vZJn" & vbCr & _
                                   " " & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    a = BigIntDiv(CN, SN, M)                            '    A = cn / sn
                    C = BigIntMul(C, a, M)                              '    C = C * A
                    For I = L To 1& Step -1&                            '    For II = L To 1 Step -1
                        B = em(I)                                       '        B = em(II)
                        a = BigIntMul(a, C, M)                          '        A = A * C
                        C = BigIntMul(C, DN, M)                         '        C = C * dn
                        E = BIReciprocal(BigIntAdd(a, B, M), M)         '        E=1/(A+B)
                        F = BigIntAdd(en(I), a, M)                      '        F=en(I)+A
                        DN = BigIntMul(F, E, M)                         '        dn = (en(I) + A) / (B + A) =(en(I)+A)*(1/(A+B))=F*E
                        a = BigIntDiv(C, B, M)                          '        A = C / B
                        '
                        If Not IsMissing(debug_) Then
                            NowTime = Timer
                            DebugTxt = "C:" & CStr(L - I + 1&) & " / " & CStr(L) & "" & _
                                       ", [T:" & Format$(NowTime - OldTime, "#0.000 Sec]") & vbCr & _
                                       "  A:" & BI2ExpN(a, 8) & _
                                       ", B:" & BI2ExpN(B, 8) & _
                                       ", C:" & BI2ExpN(C, 8) & vbCr & _
                                       "  E:" & BI2ExpN(E, 8) & _
                                       ", F:" & BI2ExpN(E, 8) & _
                                       ", dn:" & BI2ExpN(DN, 8) & vbCr
                            Call BI_debug1(debug_, DebugTxt, 0.000001)
                            OldTime = NowTime
                        End If
                        '
                        '
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                        If IsMissing(debug_) And IsMissing(debug2_) Then Call Wait(0.0000001)     'DoEvents
                    Next I                                              '    Next I
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "sn,cn,dnvZ܂" & vbCr & _
                                   "------------------------------------" & vbCr & _
                                   " " & vbCr & _
                                   "For`Next vZI" & vbCr & _
                                   "------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                    E = BigIntAdd(X1, BigIntMul(C, C, M), M)            '    E=C*C+1#
                    '
                    If Not IsMissing(debug3_) Then
                        NowTime = Timer
                        DebugTxt = "------------------------------------" & vbCr & _
                                   " Sqr(E) vZ܂" & vbCr & _
                                   " " & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    F = BISqr(E, M, , True, 0, , debug3_, debug2_)      '    F=Sqr(E)
                    '
                    If Not IsMissing(debug3_) Then
                        NowTime = Timer
                        DebugTxt = " " & vbCr & _
                                   " vZI" & vbCr & _
                                   "------------------------------------" & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    a = BIReciprocal(F, M)                              '    A = 1# / Sqr(C * C + 1#) =1/F
                    If Asc(SN.BigSgn) = 43 Then                         '    If sn >= 0# Then
                        SN = a                                          '        sn = A
                    Else                                                '    Else
                        SN = a                                          '        sn = -A
                        Call BISgnChange(SN)                            '
                    End If                                              '    End If
                    CN = BigIntMul(C, SN, M)                            '    cn = C * sn
                Else
                    '
                    If Not IsMissing(debug_) Then
                        NowTime = Timer
                        DebugTxt = "sn,cn,dnvZ܂" & vbCr & _
                                   "------------------------------------" & vbCr & _
                                   " " & vbCr
                        Call BI_debug1(debug_, DebugTxt, 0.000001)
                        OldTime = NowTime
                    End If
                    '
                    '
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                End If                                                  'End If
                If bo Then                                              'If (bo) Then
                    a = DN                                              '    A = dn
                    DN = CN                                             '    dn = cn
                    CN = a                                              '    cn = A
                    SN = BigIntDiv(SN, D, M)                            '    sn = sn / D
                End If                                                  'End If
            Else                                                        'Else
            'Mc=0(oȐ֐)
                '
                If Not IsMissing(debug_) Then
                    NowTime = Timer
                    DebugTxt = "-------------------------------------" & vbCr & _
                               "Mc=0 ł" & vbCr & _
                               " oȐ֐vZ܂" & vbCr
                    Call BI_debug1(debug_, DebugTxt, 0.000001)
                    OldTime = NowTime
                End If
                '
                '
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                '
                a = BIExp(UU, M, , False, debug3_, debug2_)             'A=Exp(uu)
                B = BIReciprocal(a, M)                                  'B=Exp(-uu)=E^(-uu)=1/(E^uu)=1/Exp(uu)=1/A
                C = BigIntAdd(a, B, M)                                  'C=Exp(uu)+Exp(-uu)
                D = BIReciprocal(C, M)                                  'D=1/E=1/{Exp(uu)+Exp(-uu)}
                E = BigIntSub(a, B, M)                                  'E=Exp(uu)-Exp(-uu)
                CN = BigIntMul(X2, D, M)                                'cn = 1/Cosh(uu)=1/{(Exp(uu)+Exp(-uu))/2}=2/{Exp(uu)+Exp(-uu)}=2/E=2*C
                DN = CN                                                 'dn = cn
                SN = BigIntMul(E, D, M)                                 'sn = Tanh(uu)=(Exp(uu)-Exp(-uu))/(Exp(uu)+Exp(-uu))=D/E=D*C
            End If                                                      'End If
            'E߂l̐ݒ
            Select Case Returnvalue
                Case 0, 1: BIsncndn = BIKetaN(SN, CLng(Digit))
                Case 2:    BIsncndn = BIKetaN(CN, CLng(Digit))
                Case 3:    BIsncndn = BIKetaN(DN, CLng(Digit))
                Case Else: Error 51
            End Select
        End If
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIsncndn")
End Function
'Q sSȉ~ϕ (Incomplete elliptic integral of the second kind)
Private Function BIEL(X As BigIntType, K As BigIntType, Digit As Long) As BigIntType
'  Q sSȉ~ϕ <Q ȉ~ϕ̋t֐(BIinvEL)̌ďop>
'------------------------------------------------------------------------------
'  Ql  T "Numerical Recipes in C", Cambridge University Press
'                 : W.H.Press, B.P.Flannery, S.A.Teukolsky, W.T.Vetterling
'            M uNumerical Recipes in C [{] Cɂ鐔lvZ̃Vsv (10 13/11/01)
'                 : Oc s,  rY,  F,  
'                 ISBN: 4-87408-560-1
'                 URL: http://gihyo.jp/book/1993/4-87408-560-1
'                 [P.194-200]
'
'            Bulirsch, Roland, 1965, Numerische Mathematik, vol.7, p.78, 1965, op. cit vol.7,
'              p.353; 1969, op. cit, vol.13. p.305
'            Abramowitz, Milton, and Stegun, Irene A. 1964, Handbook of Mathematical Functions,
'              Applied Mathmatics Series, vol.55 (Washington: National Bureau of Standards;
'              reprinted 1968 by Dover Publications, New York), chapter 17.
'            Mathews, Jon, and walker, R.L. 1970, Mathematical Methods of Physics, 2nd ed.
'              (Reading, Mass.: W.A. Benjamin/Addison-Wesley), pp.78-79.
'------------------------------------------------------------------------------
'    X        [BigIntType]  
'                                 ȉ~̓_~ɓepx
'                                   Ƃ pxipx̊:PQj
'                                   ȉ~̊px~ɓepxŁA
'                                   SŔaa̔aƓ~́A
'                                  Wƕsȕɓepx
'        K        [BigIntType]  S
'                                 K= {(a^2-b^2)/(a^2)} [a>=b]
'                                 K=-{(b^2-a^2)/(b^2)} [a<b]
'                                   
'                                     ȉ~ (X^2/a^2)+(Y^2/b^2)=1
'                                     ȉ~̒S_AђZWƂƂ
'                                       a:w(>0)Ƒȉ~̌_̂wWl
'                                       b:x(>0)Ƒȉ~̌_̂xWl
'                                      K ͑̓lŕ\Ƃ
'                                       M=K^2   (M:p[^[)
'        Digit    [Long]        ߂錅 (ȗ pubN萔 DefaultDigit or DefaultDigit2)
'  ߒl@l   [BigIntType]  ϕliȉ~ʒj
'@@  @ُI [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'     ȉ~ϕ(BIGEL)sv폜At֐(BIinvEL)̐p֐
'        ڍׂ́ABIGELQ
'------------------------------------------------------------------------------
'    X</2, 0<|K|<1
'------------------------------------------------------------------------------
'  Ql
'------------------------------------------------------------------------------
'  ˑ  ֐  BigIntAdd, BigIntSub, BigIntMul, BigIntDiv, BIReciprocal,
'              BICBit,
'              BIEq0,
'              BISgnChange, BIIsBbelowA, BIKetaN,
'              BIPi,BISqr, BITanBS, BIAtnBS, BICELbyAGM,
'              BIWarnningDialog
'        萔
'        ϐ  BigIntErrFLG, DevelopFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    Q ȉ~ϕ̋t֐(BIinvEL)̌ďop
'        ă`FbN͏ȗĂ܂
'------------------------------------------------------------------------------
'  vZ  mF
'------------------------------------------------------------------------------
Dim KK       As BigIntType   'Copy
Dim XX       As BigIntType   '
Dim CC       As BigIntType   'vZ̒l
Dim a        As BigIntType   '
Dim B        As BigIntType   '
Dim C        As BigIntType   '
Dim D        As BigIntType   '
Dim D2       As BigIntType   '1/D
Dim E        As BigIntType   '
Dim F        As BigIntType   '
Dim G        As BigIntType   '
Dim p        As BigIntType   '
Dim P2       As BigIntType   '1/p
Dim Y        As BigIntType   '
Dim z        As BigIntType   '
Dim CA       As BigIntType   'ڕWx(Epsilon)̕
Dim CB       As BigIntType   'ڕWx(Epsilon)0.01{
Dim em       As BigIntType   '
Dim kc       As BigIntType   '(1-K^2)
Dim Pi       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X05      As BigIntType   '      0.5
Dim eye      As BigIntType   '
Dim kc2      As BigIntType   '(1-K^2)
Dim SqrE     As BigIntType   '(E)
Dim TanX     As BigIntType   'Tan(X)
Dim TMP1     As BigIntType   '
Dim TMP2     As BigIntType   '
Dim TMP3     As BigIntType   '
Dim Epsilon  As BigIntType   'ڕWx <rl (CvV)>
Dim DFLGcrnt As Boolean      'DevelopFLGҔ
Dim L        As Long         '
Dim M        As Long         'vZ
Dim Count    As Long         'JE^[
Dim LimtC    As Long         'vZ <Loop̌vZ>  [BICELbyAGMƓlƂ]
    On Error GoTo ERR:
    'Copy
    XX = X
    KK = K
    'vZ
    M = Digit + 1&
    If M Mod 2& = 1& Then M = M + 1&   'Ƃ <# CǍvZ>
    '萔
    X0 = BICBit(0)
    X1 = BICBit(1)
    X05 = BICBit(0.5)
    '
    Pi = BIPi(M, False, 0&)
    'JE^[
    Count = 0&
    '--------------------------------
    'BIWarnningDialogXbLbv
    'X/2̂Ƃ BITanBS (1-Sin(XX)^2)=0 <Tan(XX)=> Łu0 ŏZ܂BvG[΍
    DFLGcrnt = DevelopFLG
    DevelopFLG = False
    On Error GoTo ERR2:
    TanX = BITanBS(XX, M, 2)
    DevelopFLG = DFLGcrnt
    '--------------------------------
    If BigIntErrFLG = 11 Then
    '0ŏZ܂
        'XX=/2Ƃ݂Ȃ
        'Q Sȉ~ϕ
        CC = BICELbyAGM(KK, 2, M)
    Else
        '--------------------------------
        '1E-M(=10^(-M)) ڕWx (CvV)
        Epsilon = X1
        Epsilon.BigExp = -M
        'CA=Epsilon
        CA = Epsilon
        CA.BigExp = Epsilon.BigExp / 2&   '# ̂ߕłȂw [CA:1E-2n(n:̐)]
        'CB=0.01*CA
        CB = CA
        CB.BigExp = CB.BigExp - 2&        '̂ߏZłȂw
        '--------------------------------
        kc2 = BigIntSub(X1, BigIntMul(KK, KK, M), M)        '  (1-KK*KK)=(kc)^2
        kc = BISqr(kc2, M, , True)                          '(1-KK*KK)=kc
        a = X1                                              'A = 1
        B = kc2                                             'B = kc^2
        C = BigIntMul(TanX, TanX, M)                        'C = TanX * TanX
        D = BigIntAdd(X1, C, M)                             'D = 1# + C
        D2 = BIReciprocal(D, M, , True)                     '1/p
        TMP1 = BigIntAdd(X1, BigIntMul(C, kc2, M), M)       'p = Sqr((1# + C * kc * kc) * (1/D))
        TMP2 = BigIntMul(TMP1, D2, M)                       '
        p = BISqr(TMP2, M, , True)                          '
        P2 = BIReciprocal(p, M, , True)                     '1/p
        D = BigIntMul(TanX, D2, M)                          'D = TanX * (1/D)
        C = BigIntDiv(D, BigIntAdd(p, p, M), M)             'C = D / (p + p)
        eye = a                                             '
        z = BigIntSub(eye, B, M)                            'z = eye - B
        a = BigIntMul(X05, BigIntAdd(a, B, M), M)           'A = 0.5 * (A + B)
        Y = BIReciprocal(TanX, M, , True)                   'Y = Abs(1# / TanX)
        Y.BigSgn = Chr$(43)                                  'Y=|Y| <Chr(43):"+">
        F = X0                                              'f = 0
        L = 0&                                              'L = 0
        em = X1                                             'em = 1
        LimtC = 30& + 15&                                   'vZ
        Do                                                  '------------------
            Count = Count + 1&                              'JE^[
            If Count > LimtC Then Error 51                  'vZ񐔃`FbN
            B = BigIntAdd(B, BigIntMul(eye, kc, M), M)      'B = B + (eye * kc)
            E = BigIntMul(em, kc, M)                        'E = em * kc
            G = BigIntMul(E, P2, M)                         'g = E * (1/p)
            D = BigIntAdd(D, BigIntMul(F, G, M), M)         'D = D + (f * g)
            F = C                                           'f = C
            eye = a                                         'eye = A
            p = BigIntAdd(p, G, M)                          'p = p + g
            P2 = BIReciprocal(p, M, , True)                 '1/p
            TMP1 = BigIntMul(D, P2, M)                      'C = 0.5 * ((D * (1/p)) + C)
            C = BigIntMul(X05, BigIntAdd(TMP1, C, M), M)    '
            G = em                                          'g = em
            em = BigIntAdd(em, kc, M)                       'em = em + kc
            TMP1 = BigIntDiv(B, em, M)                      'A = 0.5 * ((B / em) + A)
            a = BigIntMul(X05, BigIntAdd(TMP1, a, M), M)    '
            Y = BigIntSub(Y, BigIntDiv(E, Y, M), M)         'Y = Y - (E / Y)
            SqrE = BISqr(E, M, , True)                      'Sqr(E)
            If BIEq0(Y) Then                                'if Y=0 then
                Y = SqrE                                    'Y = Sqr(E) * CB
                Y.BigExp = Y.BigExp + CB.BigExp             '  ̂ߏZłȂw[CB:1E-n(n:̐)]
            End If                                          '
            TMP1 = BigIntSub(G, kc, M)                      'Abs(g - kc)
            TMP1.BigSgn = Chr$(43)                           'TMP1=|TMP1| <Chr(43):"+">
            TMP2 = G                                        'CA * g
            TMP2.BigExp = TMP2.BigExp + CA.BigExp           '  ̂ߏZłȂw[CA:1E-n(n:̐)]
            If BIIsBbelowA(TMP1, TMP2) Then                 'If Abs(g - kc) <= CA * g Then
                Exit Do                                     '
            Else                                            '
                kc = BigIntAdd(SqrE, SqrE, M)               'kc = Sqr(E) + Sqr(E)
                L = L + L                                   'L = L + L
                If Asc(Y.BigSgn) = 45 Then                  'if Y<0 then
                    L = L + 1&                              'L = L + 1
                End If                                      '
            End If                                          '
        Loop                                                '------------------
        If Asc(Y.BigSgn) = 45 Then                          'if Y<0 then
            L = L + 1&                                      'L = L + 1
        End If                                              '
        TMP1 = BigIntDiv(em, Y, M)                          'E = (Atn(em / Y) + Pi * L) * A / em
        TMP1 = BIAtnBS(TMP1, M, True)                       '
        TMP2 = BigIntMul(Pi, BICBit(L), M)                  '
        TMP3 = BigIntDiv(a, em, M)                          '
        E = BigIntMul(BigIntAdd(TMP1, TMP2, M), TMP3, M)    '
        If Asc(TanX.BigSgn) = 45 Then                       'if TanX<0 then
            Call BISgnChange(E)                             'E = -E
        End If                                              '
        CC = BigIntAdd(E, BigIntMul(C, z, M), M)            'CC = E + C * z
    End If
    'EߒlZbg
    BIEL = BIKetaN(CC, CLng(Digit))
Exit Function
ERR2:
'Resume Next
    DevelopFLG = DFLGcrnt
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIEL")
End Function
