Attribute VB_Name = "BigInt_Functions_Napier"
Option Explicit
'
'------------------------------------------------------------------------------
'
'  VBAő{Zs߂̃Cup  Z֐ Napier
'
'------------------------------------------------------------------------------
'
'@Rΐ̒ (Napier's constant) ֘ÃW[ł
'
'------------------------------------------------------------------------------
'
'
'pubN萔
Public Const eLimitN As Long = 5000      'Rΐ̒ꂅ  ȗ̓vZ(For`Next)
'------------------------------------------------------------------------------
'pubNϐ
Public BeC           As BigIntType       'Rΐ̒ꂅiۂɎgp錅܂łs[BIE֐̈PublicFlg:True]Ɋi[j
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    Rΐ̒         <\>   BIE(Optional N As Long = 10001&, Optional PublicFlg As Boolean) As BigIntType
'    Rΐ̒X(e^x)            BIExp(X As BigIntType, Optional Digit As Variant, Optional N As Long = eLimitN, Optional PublicFlg As Boolean, _
                                             Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    BIExp: Rΐ̒ꂅ߂ۂɁAx=1 ɂĎgp
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'       ɂ      o[W (*:Jo[W)                     XVe
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'   [2010/12/05]    Ver.1.94 Alpha EditioniJŁj  dlύX   W[ύX(BigInt_Functions_NapierBigInt_Functions_4)
'                                                           X   Rΐ̒(BIE)  w(_ȉ)vZǉ
'                                                           X   Rΐ̒(BIE)  (MidXe[ggAq&)
'   [2010/02/14]    Ver.1.89 Alpha EditioniJŁj      X   Rΐ̒X(e^x)  QiɂčœK(𑬂߂)ق
'                                                           X   Rΐ̒X(e^x)  For`Next
'                                                       C       Rΐ̒X(e^x)  vZق
'   [2009/11/10]    Ver.1.86 Alpha EditioniJŁj      X   Rΐ̒X(e^x)  ꕔ̔ʎ֐(BIEq0)ɕύX
'                                                           X   Rΐ̒X(e^x)  Digitȗ
'                                                           X   pubN萔(NapierN)  ȗ̌
'                                                       dlύX   Rΐ̒X  Digit̃f[^^ύX (VariantLong)
'                                                       Pp   Rΐ̒X(e^x)  Z̐Pp (pubN萔:NapierN)
'                                                       Pp   Rΐ̒X(e^x)  vZ񐔂̐Ppiȍ~͈ȗ̌vZ񐔂̂Ă̂ݎgpj
'   [2008/12/10]    Ver.1.73 Alpha EditioniJŁj      X   Rΐ̒ꂅ(BIE)  `FbNT(ľ؋@\)ǉ
'   [2008/12/10]    Ver.1.73 Alpha EditioniJŁj  ɘa   pubN萔  Rΐ̒ꂅ  NapierN(100000010001)
'   [2008/11/06]    Ver.1.69 Alpha EditioniJŁj  ɘa   Rΐ̒  vZ pubN萔(NapierN) 10001
'   [2008/10/05]    Ver.1.67 Alpha EditioniJŁj      X   pubN萔(NapierNeN)
'                                                           X   Rΐ̒X(e^x)  @
'   [2008/06/30]  * Ver.1.61 Alpha EditioniJŁj  C       Rΐ̒X  G[኱
'   [2008/06/21]  * Ver.1.59 Alpha EditioniJŁj  C       Rΐ̒X  œK vZ
'   [2008/06/18]  * Ver.1.57 Alpha EditioniJŁj         Rΐ̒X  e^0
'   [2008/06/14]  * Ver.1.51 Alpha EditioniJŁj  C       Rΐ̒X  őJԂvZ̏(Exit For)
'   [2008/06/10]    Ver.1.27 Alpha EditioniJŁj      X   Rΐ̒X  ֐ (BIExpBIeCalc)
'   [2008/06/09]    Ver.1.24 Alpha EditioniJŁj  C       Rΐ̒X  l`FbN
'   [2008/06/05]    Ver.0.98 Alpha EditioniJŁj      X   Rg
' ---------------+------------------------------------+----------+-----------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃Cu(BigInt_Definition_1`2,BigInt_Functions_1)Kvł
'    E}[N ,  ́Aȗ\ debug_, debug2_, debug3_ 
'      폜ꍇ̖ڈł
'------------------------------------------------------------------------------
'

'Rΐ̒ꂅ(lCsA/Napier's constant)
Public Function BIE(Optional N As Long = 10001&, Optional PublicFlg As Boolean) As BigIntType
'  ^Rΐ̒ꂅ(lCsA)
'   2.7182818284590452353602874713526624977572470936999595749669676277240766303535475945713821785251664274
'------------------------------------------------------------------------------
'    N          [Long]        iȗj ̌(N)  10001i̊֐̊i[j܂
'        PublicFlg  [Boolean]     iȗj [True:pubNϐ BeC Ɋi[]
'  ߒl  I   [BigIntType]  Rΐ̒ꂅ (N̐)
'@@  @ُI   [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'  dv  ̎Rΐ̒ꂅ̕\́A10002ڈȉ؎̂ĂĂ܂B
'          Rΐ̒ꂅ͐ɈӖƍl؎̂ĂƂĂ܂
'            y10002ځi_ȉ10001ځj́A"5"Ȃ̂ŁA؂̂ĂƎľܓ̌ʂ͈قȂ܂z
'------------------------------------------------------------------------------
'    ̎Rΐ̒ꂅ(lCsA)̊֐́A10001i_ȉ10000j܂ŖߒlŎ擾ł܂
'        gp錅܂Ă̂ł΁Aŏ PublicFlg  True 
'        ĂяoǍ pubNϐ BeC QƂƃXs[hAbvł܂
'------------------------------------------------------------------------------
'    10001i_ȉ10000j܂
'------------------------------------------------------------------------------
'  ˑ  ֐  BIWarnningDialog
'        萔
'        ϐ  BeC, BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    o[Wł͌vZx̊֌WŁA10001܂Ŏgp͖̂ł
'        px̉ZXs[hȂ΁A200ȉŎgpĂ
'------------------------------------------------------------------------------
'  Ql@vZԁ@mF
'------------------------------------------------------------------------------
'  ̕\́ABigInt080.dvb  BIExp ŎZoA
'  C^[lbgɌJĂ镡̕\ƔrĈvĂ邱ƂmFĂ܂
'    Rΐ̒ꂅ́ALTCg̊OÑN擾\ł
'        e (mathematical constant) - Wikipedia, the free encyclopedia
'        http://en.wikipedia.org/wiki/E_(mathematical_constant)
'          \IȃN
'            The Number e by Jerry Bonnell and Robert Nemiroff - Project Gutenberg
'            http://www.gutenberg.org/ebooks/127
'            iSjhttp://www.gutenberg.org/cache/epub/127/pg127.html.utf8
'    IC厫T
'        http://oeis.org/?language=japanese
'          A001113 (Decimal expansion of e.)
'          http://oeis.org/A001113
'------------------------------------------------------------------------------
Dim CC        As BigIntType   '
Dim I         As Long         '
Dim L         As Long         '
Dim M         As Long         '
Dim L100      As Long         '100&
Dim Digit     As Long         '
Dim CheckSume As Long         '
Dim ExpTMP    As Long         'w
Dim SgnTMP    As String       '
Dim IntTMP    As String       '
    On Error GoTo ERR:
    '
    Digit = 10001&
    'l`FbN
    If N < 0& Or Digit < N Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        L = 0&
        L100 = 100&
        'm
        IntTMP = String$(Digit, " ")
        'CheckSume 10001i_ȉ10000j܂ [ave.=45121/10001=4.5116488]
        CheckSume = 45121
        '
        SgnTMP = "+"
        '_ȏ
        L = L + 1&:   Mid(IntTMP, L, 1&) = "2"
        '                                     0        1         2         3         4         5         6         7         8         9        10
        '_ȉ-------------------------- 1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890 ---------i1s100j
        L = L + 1&:   Mid(IntTMP, L, L100) = "7182818284590452353602874713526624977572470936999595749669676277240766303535475945713821785251664274"   '2-101i珬_ȉj
        L = L + L100: Mid(IntTMP, L, L100) = "2746639193200305992181741359662904357290033429526059563073813232862794349076323382988075319525101901"
        L = L + L100: Mid(IntTMP, L, L100) = "1573834187930702154089149934884167509244761460668082264800168477411853742345442437107539077744992069"
        L = L + L100: Mid(IntTMP, L, L100) = "5517027618386062613313845830007520449338265602976067371132007093287091274437470472306969772093101416"
        L = L + L100: Mid(IntTMP, L, L100) = "9283681902551510865746377211125238978442505695369677078544996996794686445490598793163688923009879312"
        L = L + L100: Mid(IntTMP, L, L100) = "7736178215424999229576351482208269895193668033182528869398496465105820939239829488793320362509443117"
        L = L + L100: Mid(IntTMP, L, L100) = "3012381970684161403970198376793206832823764648042953118023287825098194558153017567173613320698112509"
        L = L + L100: Mid(IntTMP, L, L100) = "9618188159304169035159888851934580727386673858942287922849989208680582574927961048419844436346324496"
        L = L + L100: Mid(IntTMP, L, L100) = "8487560233624827041978623209002160990235304369941849146314093431738143640546253152096183690888707016"
        L = L + L100: Mid(IntTMP, L, L100) = "7683964243781405927145635490613031072085103837505101157477041718986106873969655212671546889570350354"   '902-1001i_ȉ951-1000j
        '
        L = L + L100: Mid(IntTMP, L, L100) = "0212340784981933432106817012100562788023519303322474501585390473041995777709350366041699732972508868"   '1002-1101
        L = L + L100: Mid(IntTMP, L, L100) = "7696640355570716226844716256079882651787134195124665201030592123667719432527867539855894489697096409"
        L = L + L100: Mid(IntTMP, L, L100) = "7545918569563802363701621120477427228364896134225164450781824423529486363721417402388934412479635743"
        L = L + L100: Mid(IntTMP, L, L100) = "7026375529444833799801612549227850925778256209262264832627793338656648162772516401910590049164499828"
        L = L + L100: Mid(IntTMP, L, L100) = "9315056604725802778631864155195653244258698294695930801915298721172556347546396447910145904090586298"
        L = L + L100: Mid(IntTMP, L, L100) = "4967912874068705048958586717479854667757573205681288459205413340539220001137863009455606881667400169"
        L = L + L100: Mid(IntTMP, L, L100) = "8420558040336379537645203040243225661352783695117788386387443966253224985065499588623428189970773327"
        L = L + L100: Mid(IntTMP, L, L100) = "6171783928034946501434558897071942586398772754710962953741521115136835062752602326484728703920764310"
        L = L + L100: Mid(IntTMP, L, L100) = "0595841166120545297030236472549296669381151373227536450988890313602057248176585118063036442812314965"
        L = L + L100: Mid(IntTMP, L, L100) = "5070475102544650117272115551948668508003685322818315219600373562527944951582841882947876108526398139"   '1901-2001 (By BigInt071.dvb)
        '
        L = L + L100: Mid(IntTMP, L, L100) = "5599006737648292244375287184624578036192981971399147564488262603903381441823262515097482798777996437"   '2002-2101
        L = L + L100: Mid(IntTMP, L, L100) = "3089970388867782271383605772978824125611907176639465070633045279546618550966661856647097113444740160"
        L = L + L100: Mid(IntTMP, L, L100) = "7046262156807174818778443714369882185596709591025968620023537185887485696522000503117343920732113908"
        L = L + L100: Mid(IntTMP, L, L100) = "0329363447972735595527734907178379342163701205005451326383544000186323991490705479778056697853358048"
        L = L + L100: Mid(IntTMP, L, L100) = "9669062951194324730995876552368128590413832411607226029983305353708761389396391779574540161372236187"
        L = L + L100: Mid(IntTMP, L, L100) = "8936526053815584158718692553860616477983402543512843961294603529133259427949043372990857315802909586"
        L = L + L100: Mid(IntTMP, L, L100) = "3138268329147711639633709240031689458636060645845925126994655724839186564209752685082307544254599376"
        L = L + L100: Mid(IntTMP, L, L100) = "9170419777800853627309417101634349076964237222943523661255725088147792231519747780605696725380171807"
        L = L + L100: Mid(IntTMP, L, L100) = "7636034624592787784658506560507808442115296975218908740196609066518035165017925046195013665854366327"
        L = L + L100: Mid(IntTMP, L, L100) = "1254963990854914420001457476081930221206602433009641270489439039717719518069908699860663658323227870"   '2901-3001 (By BigInt079.dvb)
        '
        L = L + L100: Mid(IntTMP, L, L100) = "9376502260149291011517177635944602023249300280401867723910288097866605651183260043688508817157238669"   '3002-3101
        L = L + L100: Mid(IntTMP, L, L100) = "8422422010249505518816948032210025154264946398128736776589276881635983124778865201411741109136011649"
        L = L + L100: Mid(IntTMP, L, L100) = "9507662907794364600585194199856016264790761532103872755712699251827568798930276176114616254935649590"
        L = L + L100: Mid(IntTMP, L, L100) = "3798045838182323368612016243736569846703785853305275833337939907521660692380533698879565137285593883"
        L = L + L100: Mid(IntTMP, L, L100) = "4998947074161815501253970646481719467083481972144888987906765037959036696724949925452790337296361626"
        L = L + L100: Mid(IntTMP, L, L100) = "5897603949857674139735944102374432970935547798262961459144293645142861715858733974679189757121195618"
        L = L + L100: Mid(IntTMP, L, L100) = "7385783644758448423555581050025611492391518893099463428413936080383091662818811503715284967059741625"
        L = L + L100: Mid(IntTMP, L, L100) = "6282360921680751501777253874025642534708790891372917228286115159156837252416307722544063378759310598"
        L = L + L100: Mid(IntTMP, L, L100) = "2676094420326192428531701878177296023541306067213604600038966109364709514141718577701418060644363681"
        L = L + L100: Mid(IntTMP, L, L100) = "5464440053316087783143174440811949422975599314011888683314832802706553833004693290115744147563139997"   '3901-4001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "2217038046170928945790962716622607407187499753592127560844147378233032703301682371936480021732857349"   '4002-4101
        L = L + L100: Mid(IntTMP, L, L100) = "3594756433412994302485023573221459784328264142168487872167336701061509424345698440187331281010794512"
        L = L + L100: Mid(IntTMP, L, L100) = "7223737886126058165668053714396127888732527373890392890506865324138062796025930387727697783792868409"
        L = L + L100: Mid(IntTMP, L, L100) = "3253658807339884572187460210053114833513238500478271693762180049047955979592905916554705057775143081"
        L = L + L100: Mid(IntTMP, L, L100) = "7511269898518840871856402603530558373783242292418562564425502267215598027401261797192804713960068916"
        L = L + L100: Mid(IntTMP, L, L100) = "3828665277009752767069777036439260224372841840883251848770472638440379530166905465937461619323840363"
        L = L + L100: Mid(IntTMP, L, L100) = "8931313643271376888410268112198912752230562567562547017250863497653672886059667527408686274079128565"
        L = L + L100: Mid(IntTMP, L, L100) = "7699631378975303466061666980421826772456053066077389962421834085988207186468262321508028828635974683"
        L = L + L100: Mid(IntTMP, L, L100) = "9654358856685503773131296587975810501214916207656769950659715344763470320853215603674828608378656803"
        L = L + L100: Mid(IntTMP, L, L100) = "0730626576334697742956346437167093971930608769634953288468336130388294310408002968738691170666661468"   '4901-5001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "0001512114344225602387447432525076938707777519329994213727721125884360871583483562696166198057252661"   '5002-5101
        L = L + L100: Mid(IntTMP, L, L100) = "2206797540621062080649882918454395301529982092503005498257043390553570168653120526495614857249257386"
        L = L + L100: Mid(IntTMP, L, L100) = "2069174036952135337325316663454665885972866594511364413703313936721185695539521084584072443238355860"
        L = L + L100: Mid(IntTMP, L, L100) = "6310680696492485123263269951460359603729725319836842336390463213671011619282171115028280160448805880"
        L = L + L100: Mid(IntTMP, L, L100) = "2382031981493096369596735832742024988245684941273860566491352526706046234450549227581151709314921879"
        L = L + L100: Mid(IntTMP, L, L100) = "5927180019409688669868370373022004753143381810927080300172059355305207007060722339994639905713115870"
        L = L + L100: Mid(IntTMP, L, L100) = "9963577735902719628506114651483752620956534671329002599439766311454590268589897911583709341937044115"
        L = L + L100: Mid(IntTMP, L, L100) = "5121920117164880566945938131183843765620627846310490346293950029458341164824114969758326011800731699"
        L = L + L100: Mid(IntTMP, L, L100) = "4373935069662957124102732391387417549230718624545432220395527352952402459038057445028922468862853365"
        L = L + L100: Mid(IntTMP, L, L100) = "4221381572213116328811205214648980518009202471939171055539011394331668151582884368760696110250517100"   '5901-6001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "7392762385553386272553538830960671644662370922646809671254061869502143176211668140097595281493907222"   '6002-6101
        L = L + L100: Mid(IntTMP, L, L100) = "6011126811531083873176173232352636058381731510345957365382235349929358228368510078108846343499835184"
        L = L + L100: Mid(IntTMP, L, L100) = "0445170427018938199424341009057537625776757111809008816418331920196262341628816652137471732547772778"
        L = L + L100: Mid(IntTMP, L, L100) = "3488774366518828752156685719506371936565390389449366421764003121527870222366463635755503565576948886"
        L = L + L100: Mid(IntTMP, L, L100) = "5495002708539236171055021311474137441061344455441921013361729962856948991933691847294785807291560885"
        L = L + L100: Mid(IntTMP, L, L100) = "1039678195942983318648075608367955149663644896559294818785178403877332624705194505041984774201418394"
        L = L + L100: Mid(IntTMP, L, L100) = "7731202815886845707290544057510601285258056594703046836344592652552137008068752009593453607316226118"
        L = L + L100: Mid(IntTMP, L, L100) = "7281739280746230946853678231060979215993600199462379934342106878134973469592464697525062469586169091"
        L = L + L100: Mid(IntTMP, L, L100) = "7857397659519939299399556754271465491045686070209901260681870498417807917392407194599632306025470790"
        L = L + L100: Mid(IntTMP, L, L100) = "1774527513186809982284730860766536866855516467702911336827563107223346726113705490795365834538637196"   '6901-7001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "2358563126183871567741187385277229225947433737856955384562468010139057278710165129666367644518724656"   '7002-7101
        L = L + L100: Mid(IntTMP, L, L100) = "5373040244368414081448873295784734849000301947788802046032466084287535184836495919508288832320652212"
        L = L + L100: Mid(IntTMP, L, L100) = "8104190448047247949291342284951970022601310430062410717971502793433263407995960531446053230488528972"
        L = L + L100: Mid(IntTMP, L, L100) = "9176598760166678119379323724538572096075822771784833616135826128962261181294559274627671377944875867"
        L = L + L100: Mid(IntTMP, L, L100) = "5365754486140761193112595851265575973457301533364263076798544338576171533346232527057200530398828949"
        L = L + L100: Mid(IntTMP, L, L100) = "9034259566232975782488735029259166825894456894655992658454762694528780516501720674785417887982276806"
        L = L + L100: Mid(IntTMP, L, L100) = "5366506419109734345288783386217261562695826544782056729877564263253215942944180399432170000905426507"
        L = L + L100: Mid(IntTMP, L, L100) = "6309558846589517170914760743713689331946909098190450129030709956622662030318264936573369841955577696"
        L = L + L100: Mid(IntTMP, L, L100) = "3787624918852865686607600566025605445711337286840205574416030837052312242587223438854123179481388550"
        L = L + L100: Mid(IntTMP, L, L100) = "0756893811249353863186352870837998456926199817945233640874295911807474534195514203517261842008455091"   '7901-8001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "7084568236820089773945584267921427347756087964427920270831215015640634134161716644806981548376449157"   '8002-8101
        L = L + L100: Mid(IntTMP, L, L100) = "3900121217041547872591998943825364950514771379399147205219529079396137621107238494290616357604596231"
        L = L + L100: Mid(IntTMP, L, L100) = "2535060685376514231153496656837151166042207963944666211632551577290709784731562782775987881364919512"
        L = L + L100: Mid(IntTMP, L, L100) = "5748332879377157145909106484164267830994972367442017586226940215940792448054125536043131799269673915"
        L = L + L100: Mid(IntTMP, L, L100) = "7542419296607312393763542139230617876753958711436104089409966089471418340698362993675362621545247298"
        L = L + L100: Mid(IntTMP, L, L100) = "4642137528910798843813060955526227208375186298370667872244301957937937860721072542772890717328548743"
        L = L + L100: Mid(IntTMP, L, L100) = "7435578196651171661833088112912024520404868220007234403502544820283425418788465360259150644527165770"
        L = L + L100: Mid(IntTMP, L, L100) = "0044521097735585897622655484941621714989532383421600114062950718490427789258552743035221396835679018"
        L = L + L100: Mid(IntTMP, L, L100) = "0764060421383073087744601708426882722611771808426643336517800021719034492342642662922614560043373838"
        L = L + L100: Mid(IntTMP, L, L100) = "6833555534345300426481847398921562708609565062934040526494324426144566592129122564889356965500915430"   '8901-9001
        '
        L = L + L100: Mid(IntTMP, L, L100) = "6426134252668472594914314239398845432486327461842846655985332312210466259890141712103446084271616619"   '9002-9101
        L = L + L100: Mid(IntTMP, L, L100) = "0012571958707932175696985440133976220967494541854071184464339469901626983516078489245140589409463952"
        L = L + L100: Mid(IntTMP, L, L100) = "6780735457970030705116368251948770118976400282764841416058720618418529718915401968825328930914966534"
        L = L + L100: Mid(IntTMP, L, L100) = "5753571427318482016384644832499037886069008072709327673127581966563941148961716832980455139729506687"
        L = L + L100: Mid(IntTMP, L, L100) = "6047409154204284299935410258291135022416907694316685742425225090269390348148564513030699251995904363"
        L = L + L100: Mid(IntTMP, L, L100) = "8402842926741257342244776558417788617173726546208549829449894678735092958165263207225899236876845701"
        L = L + L100: Mid(IntTMP, L, L100) = "7823038096567883112289305809140572610865884845873101658151167533327674887014829167419701512559782572"
        L = L + L100: Mid(IntTMP, L, L100) = "7074064318086014281490241467804723275976842696339357735429301867394397163886117642090040686633988568"
        L = L + L100: Mid(IntTMP, L, L100) = "4168100387238921448317607011668450388721236436704331409115573328018297798873659091665961240202177855"
        L = L + L100: Mid(IntTMP, L, L100) = "8854876176161989370794380056663364884365089144805571039765214696027662583599051987042300179465536788"   '9901-10001i_ȉ9900-10000j
        '-----------------------------------------------------------------------------------------------------------------------------------------    '(By BigInt080.dvb)
        '10002ڂ"5"
        '
        '`FbN
        If Right$(IntTMP, 1&) <> " " Then
        'ok
            'CheckSume
            M = 0&
            For I = 1& To Digit
                M = M + CLng(Mid$(IntTMP, I, 1&))
            Next I
            If CheckSume = M Then
            'ok
                'w
                ExpTMP = 1& - Digit
                '
                If Digit > N Then
                    ExpTMP = ExpTMP + (Digit - N)
                    IntTMP = Left$(IntTMP, N)
                End If
                With CC
                    .BigSgn = SgnTMP
                    .BigExp = ExpTMP
                    .BigInt = IntTMP
                End With
                If PublicFlg Then
                'BeC Ɋi[
                    BeC = CC
                End If
                'ߒlZbg
                BIE = CC
            Else
            'NG
                BigIntErrFLG = 51
                Error BigIntErrFLG
            End If
        Else
        'NG
            BigIntErrFLG = 51
            Error BigIntErrFLG
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIE")
End Function
'Rΐ̒ꂅ(lCsA)X  e^x
Public Function BIExp(X As BigIntType, Optional Digit As Variant, Optional N As Long = eLimitN, Optional PublicFlg As Boolean, _
                      Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  e^X  Rΐ̒ꂅ(lCsA)̂w [e^x=(k:0`)(x^k/(k!))]
'------------------------------------------------------------------------------
'    X          [BigIntType]      ׂ搔
'        Digit      [Variant/Long]    iȗj߂錅 (ȗ pubN萔 NapierN)
'        N          [Long]            iȗjőJԂvZ (ȗ pubN萔 eLimitN)
'        PublicFlg  [Boolean]         iȗj[True:pubNϐ BPEC Ɋi[]
'        debug_     [Variant/Object]  iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_    [Variant/Object]  iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_    [Variant/Object]  iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I   [BigIntType]      Rΐ̒ꂅ (^xKetaN̐)
'@@  @ُI   [BigIntType]      [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    e^x eC[WJɂċ߂
'        Rΐ̒ꂅ߂ۂɁAx=1 ɂĎgp
'
'        pɂɎgp̂ł΁Aŏ PublicFlg  True 
'        ĂяoǍ pubNϐ BPEC QƂƃXs[hAbvł܂
'
'       |X| (w̐Βl)
'         10^(-L)̏ꍇ
'            ʏ [e^x=(k:0`)(x^k/(k!))] ̂̂
'         10^(-L)ȏ̏ꍇ
'            Qi e^x=([e^a]eC[WJ)^bׂ ɂĎ𑬂߂Ή
'       ɁAL=BIMinV(BIMaxV(Len(XX.BigInt), 5), 15)
'               x=ab
'       ɁÅ֐ɔח]T𑽂߂ɎĂ
'------------------------------------------------------------------------------
'    ȗ̓vZ(For`Next):eLimitN=5000
'
'        X <= 4944763835.2279119521(x)
'        w(BigExp)̐l2,147,483,647z
'------------------------------------------------------------------------------
'  ˑ  ֐  BeC,
'              BIIsError, BigIntAdd, BigIntMul, BigIntDiv,
'              BICBit, DigitCheck, Bigint2String,
'              BIEq0, SetBigIntDigitCalculations, Wait,
'              BIIsAEqualB, BIIsBOrMore, BIKetaN,
'              BIWarnningDialog
'        萔  BigIntLimit, DefaultDigit, NapierN, eLimitN
'        ϐ  DefaultDigit2, BigIntErrFLG,
'              NowTime, LastTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ݂̂obł́A2147483647(=BigIntLimit)܂ŋ߂͖̂ł
'        px̉ZXs[hȂ΁A߂錅1000000ȉŎgpĂ
'
'         Digit ͏ȗ\A߂錅ƂĕK{
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium4 2.80C GHz)
'                    [By Ver.0.79 BigInt_Demo(vZߒo:ON)]
'                       e^2   100    2b    x
'                            1000   10  x
'                            ȏ͖mF
'                       e^1  1000    7  x
'                            2000   50    x
'                            3000  170    x
'                            ȏ͖mF
'
'                  (Pentium4 3.20 GHz)
'                    [By Ver.1.89 BigInt_Demo(vZߒo:ON)]
'                       e^
'                               100 ߂錅  100    1b 
'                                1000            1000    8b x
'                                2000            2000   15b x
'                                5000            5000   55b x
'                               10000           10000  310b x
'                       e^1
'                                       ߂錅  100    1b 
'                                                  1000    6b x
'                                                  2000   10b x
'                                                  5000   50b x
'                                                 10000  245b x
'------------------------------------------------------------------------------
Dim XX       As BigIntType   'Copy
Dim CC       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X2       As BigIntType   '      2
Dim E0       As BigIntType   'OilPj
Dim en       As BigIntType   'm
Dim E1       As BigIntType   'Pȍ~݌v  ̒l
Dim D0       As BigIntType   'q
Dim F0       As BigIntType   '
Dim KK       As BigIntType   'QîׂW [2^(100*n)]
Dim X0L0     As BigIntType   'Qi萔 (10^(-L))
Dim TMP      As BigIntType   'vZ̉l
Dim TMP1     As BigIntType   '
Dim TMP2     As BigIntType   '
Dim FLG      As Boolean      'X<0(t)tO
Dim FLG2     As Boolean      'QitO
Dim I        As Long         '
Dim K        As Long         '
Dim L        As Long         'Qi萔̎w (2^L) <Min:5, Max:15>
Dim M        As Long         'vZ
Dim M2       As Long         'vZ2 <Max:3*Digit>
Dim dE       As Long         'liOƌvŽj
Dim DL1      As Long         '
Dim Ddm      As Long         ']Ti錅j[Decision-digit margin]
Dim MinN     As Long         'ŒvZ
Dim Nnow     As Long         '݂̌vZߒo
Dim NlAst    As Long         'ǑvZߒo
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim DigitL   As Long         '=Digit
Dim ExpMin   As Long         'Qi萔̎w Min
Dim ExpMax   As Long         '                 Max
Dim BLimit_2 As Long         '(BigIntLimit-dDigit)/2
Dim dM2      As Double       'vZ M2 ̊
Dim TMPD     As Double       '
Dim DigitD   As Double       '=Digit
Dim ddDigit  As Double       ']T dDigit ̊
'
Dim OldTime  As Single       '
Dim DebugTxt As String       '
'
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    If BIIsError(X) Then
    '`FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    ElseIf BIIsBOrMore(X, BICBit(4944763836#)) Then
    '`FbN (X>=4944763836)
        BigIntErrFLG = 6
        Error BigIntErrFLG
    ElseIf N <= 0& Then
    'őJԂvZ `FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        '
        XX = X
        Call CutLastZero(XX)
        '
        DigitL = CLng(Digit)   'Long
        DigitD = CDbl(Digit)   'Double
        '
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X2 = BICBit(2)
        '
        Ddm = 1&       ']T
        MinN = 5&      'ŒvZ
        dStepN = 10&   'o̓Xebv
        FLG = False
        FLG2 = False
        '===============================================
        '
        dM2 = 0.5         '50.0%
        ddDigit = 0.005   ' 0.5%
        ']T
        dDigit = 5& + CLng(ddDigit * DigitD)
        If BigIntLimit - DigitL <= dDigit Then
            dDigit = BigIntLimit - DigitL
        End If
        'vZ
        M = SetBigIntDigitCalculations(DigitL, dDigit)
        'vZ M2
        If BigIntLimit - M <= DigitL Then
            M2 = BigIntLimit
        Else
            I = BIMaxV(CLng(dM2 * DigitD), 5)
            If BigIntLimit - M <= I Then
                M2 = BigIntLimit
            Else
                M2 = M + I
            End If
            BLimit_2 = CLng(CDbl(BigIntLimit - dDigit) / (1& + dM2))
            If Len(XX.BigInt) >= BLimit_2 Then
                DL1 = BigIntLimit
            Else
                DL1 = CLng((1 + dM2) * CDbl(Len(XX.BigInt))) + dDigit
            End If
            M2 = BIMaxV(DL1, M2)
            'M2 Max ߂錅R
            If M2 / DigitL > 3 Then
                M2 = 3& * DigitL
            End If
        End If
        '===============================================
        If Asc(XX.BigSgn) = 45 Then   'XX<0
        't 1/(e^x)  e^(-x)
            XX.BigSgn = "+"
            FLG = True
        End If
        '
        If BIEq0(XX) Then
        'e^0=1 (XX=0)
            CC = X1
        Else
            'Qi萔̎w (2^L)
            ExpMin = 5&
            ExpMax = 15&
            L = BIMinV(BIMaxV(Len(XX.BigInt), ExpMin), ExpMax)
            '10^(-L)
            X0L0 = X1
            X0L0.BigExp = -1& * L
            '
            If BIIsBOrMore(XX, X0L0) Then   'XX>=10^(-L)
            'QiɂĎ𑬂߂Ή
                'ňvZ
                '(A^{X/((2^L)^n)})^((2^L)^n)  A^X
                '  B  =A^{X/((2^L)^n)}  <{X/((2^L)^n)}:10^(-L)ȉɂȂnƂ>
                '  A^X=B^((2^L)^n)      <ׂŉZ>
                '
                '  n߂̂ɐmȌvZ͕KvȂ <T({x)ŌvZ>
                '  AXX/(2^(L*n))͐mɌvZKvL
                '    X=2^(L*n), L=100Ƃ
                '    X=2^(100*n)
                '    X=(2^100)^n
                '    Ln(X)=Ln((2^100)^n)
                '    Ln(X)=n*Ln(2^100)
                '    n=Ln(X)/Ln(2^100)
                FLG2 = True
                TMP = BigIntDiv(XX, X0L0, 10)
                '----------------------------------
                '{x_^ (Double) 
                TMPD = BICDbl(TMP)
                TMPD = Log(TMPD) / Log(2 ^ L)
                '----------------------------------
                I = CLng(Int(TMPD)) + 1&        'n
                TMP2 = BICBit(L * I)            'L*n
                '<vZ M2>
                KK = BIPowersI(X2, TMP2, M2)    '2^(L*n)
                XX = BigIntDiv(XX, KK, M)       'XX=XX/(2^(L*n))
                '
                If Not IsMissing(debug_) Then DebugTxt = " n : " & CStr(I) & " " & vbCr & _
                                                         " bwb" & BI2ExpN(X0L0, 8) & "ȏȂ̂ŁAQiɂĎ𑬂߂܂" & vbCr & _
                                                         " B^((2^" & CStr(L) & ")^n)  (A^{X/((2^" & CStr(L) & ")^n)})^((2^" & CStr(L) & ")^n)  A^X" & vbCr & _
                                                         "---------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                '
            Else
            'eC[WĴ
            End If
            '
            If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                     " K : vZ" & vbCr & _
                                                     " N : Rΐ̋܂ (Pȍ~)" & vbCr & _
                                                     " L : vZiPȍ~j̗L" & vbCr & _
                                                     " T : vZ" & vbCr & _
                                                     "---------------------------" & vbCr & _
                                                     " ߂錅: " & CStr(DigitL) & vbCr & _
                                                     " ]  T  : " & CStr(dDigit) & vbCr & _
                                                     " v@Z@: " & CStr(M) & " [߂錅{]T]" & vbCr & _
                                                     "---------------------------" & vbCr & _
                                                     " WJɎgpX(T): " & BI2ExpN(XX, 16) & vbCr & _
                                                     "---------------------------" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            E0 = X1   'O      l 1
            E1 = X0   'Pȍ~  鐔
            D0 = XX   'q
            en = X1   '鐔
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, liOj" & Bigint2String(E0) & vbCr, 0.00001)
            '
            'uG[`FbNvXLbv
            ErrorCheckSkipFLG = True
            'eC[WJ
            ' e^x=(k:0`)(x^k/(k!))
            For K = 1& To N   'N:eLimitN=5000
                '------------------------------------------------------------
                F0 = BigIntDiv(X1, BICBit(K), M)   '1/k
                TMP = BigIntMul(D0, F0, M)         'X*(1/k)
                'j
                TMP = BigIntMul(en, TMP, M)        '(O̒l)*(X/k)
                en = TMP
                '------------------------------------------------------------
                'Z
                E1 = BigIntAdd(E1, en, M)
                'l Zo
                dE = (Len(E0.BigInt) + E0.BigExp) - (Len(en.BigInt) + en.BigExp)
                If dE < 0& Then
                    E0 = E1
                    dE = (Len(E0.BigInt) + E0.BigExp) - (Len(en.BigInt) + en.BigExp)
                End If
                '------------------------------------------------------------
                '
                'ڍׂȉߒo
                If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:" & CStr(K) & ",EN " & Bigint2String(en) & vbCr, 0.00001)
                '
                If K Mod dStepN = 0& Then
                    'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                    Call Wait(0.0000001)   'DoEvents
                    '
                    If Not IsMissing(debug_) Then
                        Nnow = dE
                        NowTime = Timer
                        If Nnow > NlAst + 1& Then
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format$(NlAst + 1&, "00") & "`" & Format$(Nnow, "00") & _
                                       ", L:" & Len(E1.BigInt) & _
                                       ", T:" & Format$(NowTime - OldTime, "#0.000 Sec") & vbCr
                        Else
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format$(Nnow, "00") & _
                                       ", L:" & Len(E1.BigInt) & _
                                       ", T:" & Format$(NowTime - OldTime, "#0.000 Sec") & vbCr
                        End If
                        OldTime = NowTime
                        NlAst = Nnow
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                    '
                End If
                If K > MinN Then
                    ' -----------------------------------------------------------
                    If dE >= CLng(Digit) + Ddm Then
                    '
                        '
                        If Not IsMissing(debug_) Then
                            Nnow = dE
                            DebugTxt = "l 1E+" & CStr(DigitL + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                                       "El(O) [" & BI2ExpN(E0, 8) & "]" & vbCr & _
                                       "E" & CStr(K) & " T[" & BI2ExpN(en, 8) & "]" & vbCr & _
                                       "(*):߂錅{]T [=" & CStr(DigitL) & "+" & CStr(Ddm) & "]" & vbCr & _
                                       "lƔfČvZI܂B" & vbCr & _
                                       "I" & vbCr & _
                                       "K:" & CStr(K) & _
                                       ", N:" & Format$(Nnow, "00") & _
                                       ", L:" & Len(E1.BigInt) & _
                                       ", T:" & Format$(NowTime - LastTime, "#0.000 Sec") & vbCr
                        End If
                        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                        '
                        Exit For
                    End If
                End If
            Next K
            'uG[`FbNvXLbvɖ߂
            ErrorCheckSkipFLG = False
            '
            If K > N Then
            'őJԂvZ
                If Not IsMissing(debug_) Then
                    DebugTxt = "----------------------------------" & vbCr & _
                               "̓r E0+E1:" & Bigint2String(BigIntAdd(E0, E1, CLng(Digit))) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "Pȍ~̍v E1:" & Bigint2String(E1) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "O E0:" & Bigint2String(E0) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                               "JԂvZ͎ɏI܂B " & vbCr
                End If
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            End If
            '
            '̌vZiO{Pȍ~̍vj
            '<vZ M2>
            TMP = BigIntAdd(E0, E1, M2)
            '
            If FLG2 Then
            'Qi <ׂ>
                '(B)^{(2^L)^n}
                '
                If K > N Then
                'őJԂvZ
                    If Not IsMissing(debug_) Then
                        DebugTxt = "------------------------------------------------" & vbCr & _
                                   "  (B^{(2^" & CStr(L) & ")^n}) ZJn" & vbCr & _
                                   "    B(T): " & BI2ExpN(TMP, 32) & vbCr & _
                                   "    (2^" & CStr(L) & ")^" & CStr(I) & "(T): " & BI2ExpN(KK, 32) & vbCr & _
                                   "    M(vZ): " & CStr(M2) & vbCr & _
                                   "------------------------------------------------" & vbCr & _
                                   "Qi(B^{(2^" & CStr(L) & ")^n}) ׂ(BIPowers)ŌvZ܂" & vbCr & vbCr & vbCr
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.000001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
                End If
                '
                '<vZ M2>
                TMP1 = BIPowers(TMP, KK, M2, 0, debug_, debug2_, debug3_)
            Else
                TMP1 = TMP
            End If
            '
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, " " & vbCr & vbCr, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            If FLG Then
            't̏ e^(-x)  1/(e^x)
                CC = BIReciprocal(TMP1, M, False, True)
            Else
                CC = TMP1
            End If
            '
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
            '
            '
            CC = BIKetaN(CC, DigitL)
            If PublicFlg Then
            'BPEC Ɋi[
                BeC = CC
            End If
        End If
        'ߒlZbg
        BIExp = CC
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.000001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    'uG[`FbNvXLbvɖ߂
    ErrorCheckSkipFLG = False
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIExp")
End Function
